#ifndef pdf_signatureH
#define pdf_signatureH

#include <Windows.h>
/*
   Notice for Visual Studio 6 users:

   This version of the WinCrypt.h was taken from Visual Studio 2005. It contains a
   modification because the data type ULONG_PTR is not defined in the header files
   of Visual Studio 6.

   The version that is included in Visual Studio 6 is not complete and does not compile!

   So, if this file will not compile due to certain undefined data types then copy the WinCryp.h
   into the Visual Studio 6 /VC98/Include directory. Copy also the crypt32.lib into the /VC98/Lib
   directory of Visual Studio. After these changes the example should compile fine.

   Newer versions of Visual Studio are delivered with incomplete but compilable versions of the
   WinCrypt.h.

   The class uses also the cryptui.dll which should be available on Windows operating systems.
   If the DLL cannot be found then install the Windows SDK for your development environment.
   To avoid further incompatibilities the library is loaded with LoadLibrary() if necessary.
*/
#include "WinCrypt.h"

#define PDF_STATIC // Enable static binding when compiling the project with the workspace dynapdf_static.
#include "../../../include/C_CPP/dynapdf.h"

namespace DynaPDF
{

class CWinCrypt
{
  public:
   CWinCrypt(void);
   ~CWinCrypt(void);
   void CleanUp(void);
   bool CloseAndSignPDFFile(const void* PDF, const char* OutFile, bool DetachedSignature);
   bool LoadCertFromFile(const char* FileName, const wchar_t* Password);
   bool OpenCert(UI32 Index);
   bool OpenStore(const wchar_t* Name);
   bool SelectCertificateFromStore(void);
  private:
   PCCERT_CONTEXT m_CertCtx;
   BYTE*          m_PKCS7Obj;
   HCERTSTORE     m_Store;

   BYTE* GetFileBuf(const char* FileName, long &BufSize);
};

}

#endif
