unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ShellAPI, dynapdf, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{
   Note that the dynapdf.dll must be copied into the output directory or into a
   Windwos search path (e.g. %WINDOWS%/System32) before the application can be executed!
}

// Error callback function.
// If the function name should not appear at the beginning of the error message set
// the flag emNoFuncNames (pdf.SetErrorMode(emNoFuncNames);). 
function ErrProc(const Data: Pointer; ErrCode: Integer; const ErrMessage: PChar; ErrType: Integer): Integer; stdcall;
begin
   MessageDlg(ErrMessage, mtError, [mbOK], 0);
   Result := -1; // We break processing if an error occurs.
end;

procedure TForm1.Button1Click(Sender: TObject);
var pdf: TPDF; outFile, AlertScript: String; f, act, keyStrokeAct, formatAct, keyStrokeAct2, formatAct2: Integer;
begin
   pdf := nil;
   try
      pdf := TPDF.Create;
      // Error messages and warnings are passed to the callback function.
      pdf.SetOnErrorProc(nil, @ErrProc);
      if not pdf.CreateNewPDFA('') then begin // The output file is opened later
         pdf.Free;
         Exit;
      end;
      pdf.SetDocInfoA(diCreator, 'C++ Example Project');
      pdf.SetDocInfoA(diSubject, 'How to Edit an existing pdf file');
      pdf.SetDocInfoA(diTitle, 'Edit pdf files');
      pdf.SetDocInfoA(diAuthor, 'Jens Boschulte');
      pdf.SetViewerPreferences(vpDisplayDocTitle, avNone);
      // Conversion of pages to templates is normally not required. Templates are required if
      // the page should be scaled or used multiple times in a document, e.g. as background.
      // See help file for further information.
      pdf.SetImportFlags(ifImportAll or ifImportAsPage);
      if pdf.OpenImportFileA('../../test_files/taxform.pdf', ptOpen, '') < 0 then begin
         pdf.Free;
         Exit;
      end;
      pdf.ImportPDFFile(1, 1.0, 1.0);

      pdf.EditPage(1);

      pdf.SetCheckBoxChar(ccCross4);
      pdf.SetLineWidth(0.0);
      pdf.SetFieldBorderColor(NO_COLOR);

      f := pdf.CreateRadioButton('AntragsArt', 'EinkommensSteuerErklrung', false, -1, 70, 746.5, 13.0, 13.0);
      pdf.CreateCheckBox('', 'Sparzulage', false, f, 70, 722.5, 13.0, 13.0);
      pdf.CreateCheckBox('', 'VerlustErklrung', false, f, 249.5, 722.5, 13.0, 13.0);

      pdf.SetFontA('Courier', DynaPDF.fsNone, 12.0, true, DynaPDF.cp1252);
      pdf.CreateTextField('Finanzamt', -1, false, 0, 70.0, 698.0, 358.0, 14.0);
      pdf.CreateTextField('Steuernummer', -1, false, 14, 70.0, 673.5, 150.0, 14.0);
      pdf.CreateTextField('Finanzamt_alt', -1, false, 0, 272.0, 673.5, 156.0, 14.0);

      pdf.CreateCheckBox('Rckerstattung', 'Ja', true, -1, 429, 675.0, 13.0, 13.0);
      pdf.CreateTextField('Telefon', -1, false, 0, 285.5, 650.0, 142.5, 14.0);
      {
         Acrobat 7.0 ignores the character spacing, the only way to get the same result is to set the Comb flag.
         See help file for further information.
      }
      pdf.SetCharacterSpacing(7.2);
      f := pdf.CreateTextField('Name', -1, false, 25, 70.0, 626.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('Vorname', -1, false, 25, 70.0, 602.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('Geburtsdatum', -1, false, 10, 70.0, 578.0, 113.0, 14.0);
      // Create a custom date format action -> input example: 13.05.1971 or 13-05-1971 or 13/05/1971
      // Two actions are required, one for the event onKeyStroke and one for the event onFormat.
      keyStrokeAct := pdf.CreateJSActionA('AFDate_KeystrokeEx("ddmmyyyy");');
      formatAct := pdf.CreateJSActionA('AFDate_FormatEx("ddmmyyyy");');

      // Add both actions to the field
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct, f);

      pdf.SetCharacterSpacing(0.0);
      f := pdf.CreateComboBox('Religion', false, -1, 185.0, 578.0, 71.0, 14.0);
      pdf.AddValToChoiceFieldA(f, 'keine', 'keine', true);
      pdf.AddValToChoiceFieldA(f, 'Evang', 'Evang.', false);
      pdf.AddValToChoiceFieldA(f, 'Kath', 'Kath.', false);
      pdf.AddValToChoiceFieldA(f, 'andere', 'andere', false);

      pdf.CreateTextField('Beruf', -1, false, 0, 257.0, 578.0, 171.0, 14.0);

      pdf.SetCharacterSpacing(7.2);
      f := pdf.CreateTextField('Strasse', -1, false, 25, 70.0, 554.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('PLZ', -1, false, 5, 70.0, 530.0, 70.5, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      pdf.SetNumberFormat(f, dsNoneDot, 0, nsRed, '', false);

      f := pdf.CreateTextField('Wohnort', -1, false, 20, 142.5, 530.0, 285.5, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);

      pdf.SetCharacterSpacing(0.0);
      pdf.SetFontA('Courier', fsNone, 11.0, true, cp1252);

      f := pdf.CreateTextField('VerheiratetSeit', -1, false, 10, 70.0, 506.0, 70.5, 14.0);
      // We need another date format here. The date should be delimited with a dot.
      keyStrokeAct2 := pdf.CreateJSActionA('AFDate_KeystrokeEx("dd.mm.yyyy");');
      formatAct2 := pdf.CreateJSActionA('AFDate_FormatEx("dd.mm.yyyy");');
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct2, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct2, f);

      f := pdf.CreateTextField('VerwitwetSeit', -1, false, 10, 142.0, 506.0, 71.0, 14.0);
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct2, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct2, f);

      f := pdf.CreateTextField('GeschiedenSeit', -1, false, 10, 214.0, 506.0, 71.0, 14.0);
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct2, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct2, f);

      f := pdf.CreateTextField('GetrenntSeit', -1, false, 10, 286.0, 506.0, 142.0, 14.0);
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct2, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct2, f);

      pdf.SetCharacterSpacing(7.2);
      pdf.SetFontA('Courier', fsNone, 12.0, true, cp1252);
      f := pdf.CreateTextField('EhefrauVorname', -1, false, 25, 70.0, 458.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('EhefrauName', -1, false, 25, 70.0, 434.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);

      f := pdf.CreateTextField('EhefrauGeburtdatum', -1, false, 10, 70.0, 410.0, 114.0, 14.0);
      // Add both actions to the field
      pdf.AddActionToObj(otField, oeOnKeyStroke, keyStrokeAct, f);
      pdf.AddActionToObj(otField, oeOnFormat, formatAct, f);

      pdf.SetCharacterSpacing(0.0);
      f := pdf.CreateComboBox('EhefrauReligion', false, -1, 185.0, 410.0, 71.0, 14.0);
      pdf.AddValToChoiceFieldA(f, 'keine', 'keine', true);
      pdf.AddValToChoiceFieldA(f, 'Evang', 'Evang.', false);
      pdf.AddValToChoiceFieldA(f, 'Kath', 'Kath.', false);
      pdf.AddValToChoiceFieldA(f, 'andere', 'andere', false);

      pdf.CreateTextField('EhefrauBeruf', -1, false, 0, 257.0, 410.0, 171.0, 14.0);
      pdf.CreateTextField('EhefrauStrasse', -1, false, 49, 70.0, 386.0, 358.0, 14.0);

      f := pdf.CreateRadioButton('Veranlagung', 'Zusammen', false, -1, 70.0, 363.0, 13.0, 13.0);
      pdf.CreateCheckBox('', 'Getrennt', false, f, 141.5, 363.0, 13.0, 13.0);
      pdf.CreateCheckBox('', 'Eheschliessung', false, f, 213.5, 363.0, 13.0, 13.0);

      f := pdf.CreateRadioButton('Guetergemeinschaft', 'Ja', false, -1, 357.0, 363.0, 13.0, 13.0);
      pdf.CreateCheckBox('', 'Nein', false, f, 393.0, 363.0, 13.0, 13.0);

      pdf.SetCharacterSpacing(7.2);
      f := pdf.CreateTextField('Konto', -1, false, 10, 70.0, 314.0, 142.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      pdf.SetNumberFormat(f, dsNoneDot, 0, nsRed, '', false);
      f := pdf.CreateTextField('BLZ', -1, false, 8, 286.0, 314.0, 113.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      pdf.SetNumberFormat(f, dsNoneDot, 0, nsRed, '', false);

      f := pdf.CreateTextField('Bank', -1, false, 25, 70.0, 290.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);

      pdf.CreateCheckBox('AbwInhaber', 'Ja', false, -1, 70.0, 267.0, 13.0, 13.0);
      f := pdf.CreateTextField('AbwKontoInhaber', -1, false, 21, 128.0, 266.5, 300.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);

      f := pdf.CreateTextField('AbwEmpfName', -1, false, 25, 70.0, 218.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('AbwEmpfVorname', -1, false, 25, 70.0, 194.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('AbwEmpfStrasse', -1, false, 25, 70.0, 170.0, 358.0, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      f := pdf.CreateTextField('AbwEmpfPLZ', -1, false, 5, 70.0, 146.5, 70.5, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);
      pdf.SetNumberFormat(f, dsNoneDot, 0, nsRed, '', false);

      f := pdf.CreateTextField('AbwEmpfWohnort', -1, false, 20, 142.5, 146.5, 285.5, 14.0);
      pdf.SetFieldFlags(f, ffComb, false);

      // Add a reset button to the form
      pdf.SetFieldBorderColor(clBlack);
      pdf.SetFieldBackColor(clMoneyGreen);
      pdf.SetLineWidth(1.0);
      pdf.SetFontA('Helvetica', fsBold, 12.0, true, cp1252);
      f := pdf.CreateButtonA('Reset', 'Zurcksetzen', -1, 440.0, 730.0, 120.0, 25.0);
      // We want a bevelled border
      pdf.SetFieldBorderStyle(f, bsBevelled); 
      act := pdf.CreateResetAction();
      pdf.AddActionToObj(otField, oeOnMouseUp, act, f);

      pdf.SetCharacterSpacing(0.0);
      pdf.SetFontA('Courier', fsNone, 12.0, true, cp1252);
      pdf.WriteTextA(53.0, 48.0, DateTimeToStr(Date));

      pdf.SetFillColor(RGB($FF, $66, $66));
      pdf.SetFontA('Helvetica', fsBold, 22.0, false, cp1252);
      pdf.WriteTextA(340.0, 70.0, 'www.dynaforms.de');

      pdf.SetLineWidth(0.0);
      pdf.SetLinkHighlightMode(hmPush);
      pdf.SetAnnotFlags(afReadOnly);
      pdf.WebLinkA(340.0, 64.0, 204.0, 22.0, 'http://www.dynaforms.de');

      AlertScript := 'if (app.viewerVersion >= 7.0 && app.viewerVersion < 8.0)'#13
      +'{'#13
      +'app.alert("Due to bugs in Acrobat 7.0 character spacing does not work'
      +' in text fields. We use the flag ffComb instead which is supported since'
      +' Acrobat 6.0. However, if the field''''s format is controled by a JavaScript'
      +' Action, we cannot set the flag because Acrobat 6.0 is then unable'
      +' to display the field''''s text. Acrobat 7.0 has problems to place the'
      +' the cursor in such fields but the final format will be correctly applied.'
      +' The problem is that if the form should work with Acrobat 6.0 we cannot set'
      +' the flag ffComb to the date fields. It is also impossible to get the same'
      +' result as with character spacing with the flag ffComb. So, what can we do to make the'
      +' form compatible to all Acrobat versions? I really don''''t know! The easiest way'
      +' would be to avoid the usage of such date formats.");'#13
      +'}';

      pdf.AddJavaScriptA('VersionCheck', AlertScript);

      pdf.EndPage;
      // No fatal error occurred?
      if pdf.HaveOpenDoc then begin
         // We write the file into the application directory. If the file cannot be opened
         // then we display a file open dialog. The error callback function
         // is not used here to avoid displaying of an error messages if the output file
         // cannot be opened.
         pdf.SetOnErrorProc(nil, nil);
         GetDir(0, outFile);
         outFile := outFile + '\out.pdf';
         while not pdf.OpenOutputFileA(outFile) do begin
            if not OpenDialog1.Execute then begin
               pdf.Free;
               Exit;
            end;
            outFile := OpenDialog1.FileName;
            // The file open dialog changes the active directory. If the application is executed again
            // the input file cannot longer be found. So, we must set the active directory back to the
            // application directory.
            ChDir(ExtractFilePath(Application.ExeName));
         end;
         pdf.SetOnErrorProc(nil, @ErrProc);
      end;
      if pdf.CloseFile then begin
         ShellExecute(Handle, PChar('open'), PChar(outFile), nil, nil, SW_SHOWMAXIMIZED);
      end;
   except
      on E: Exception do MessageDlg(E.Message, mtError, [mbOK], 0);
   end;
   if pdf <> nil then pdf.Free;
end;

end.
