VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Collections2"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5160
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   5160
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   735
      Left            =   1320
      TabIndex        =   0
      Top             =   840
      Width           =   2535
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "This example creates a PDF Collection, also known as PDF Package."
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   ' Error messages and warnings are passed to the error event function.
   If Not clsPDF.CreateNewPDFA("") Then ' The output file is opened later
      Exit Sub
   End If
   Call clsPDF.SetDocInfoA(diAuthor, "Jens Boschulte")
   Call clsPDF.SetDocInfoA(diCreator, "VB test application")
   Call clsPDF.SetDocInfoA(diKeywords, "PDF Collections; PDF Packages")
   Call clsPDF.SetDocInfoA(diTitle, "PDF Collections")
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone

   ' The page of this file is shown when opening the file with an older version of Adobe's Acrobat.
   ' Otherwise, the default document of the collection is opened. Click on "Cover sheet" to view the
   ' contents of this page.
   Call clsPDF.SetImportFlags(ifImportAll Or ifImportAsPage)
   If clsPDF.OpenImportFileA("../../test_files/collection_en.pdf", ptOpen, "") < 0 Then
      clsPDF.FreePDF
      Exit Sub
   End If
   clsPDF.ImportPDFFile 1, 1#, 1#
   clsPDF.CloseImportFile

   Dim ef As Long
   Call clsPDF.CreateCollection(civTile)

   ' We add a user defined field Index to the list so that we can sort it in every order we want.
   ef = clsPDF.CreateCollectionFieldA(cisCustomNumber, 0, "File index", "Index", False, True)
   Call clsPDF.SetColSortField(ef, True)

   Call clsPDF.CreateCollectionFieldA(cisFileName, 1, "File name", "", True, True)
   ' The creation date is documented in the PDF Reference and a valid field in a file specification
   ' but Acrobat 8 ignores it. Maybe it works when the next update of Acrobat is available...
   ' clsPDF.CreateCollectionFieldA(cisCreationDate, 4, "Creation date", "", true, false)
   Call clsPDF.CreateCollectionFieldA(cisSize, 2, "File size", "", True, False)
   Call clsPDF.CreateCollectionFieldA(cisModDate, 3, "Modification date", "", True, False)

   ' We embed a few different file types to see how they are displayed in a collection
   ef = clsPDF.AttachFileA("../../test_files/taxform.pdf", "A PDF file...", True)
   Call clsPDF.SetColDefFile(ef)  ' This file is opened when viewing the file Acrobat 8 or later
   Call clsPDF.CreateColItemNumber(ef, "Index", 0#, "")
   ef = clsPDF.AttachFileA("../../test_files/fulltest.emf", "An EMF file...", True)
   Call clsPDF.CreateColItemNumber(ef, "Index", 1#, "")
   ef = clsPDF.AttachFileA("../../test_files/sample.txt", "A text file...", True)
   Call clsPDF.CreateColItemNumber(ef, "Index", 2#, "")

   ' Let's check whether the collection is valid.
   ' We know that the collection is valid in this example, but when editing an imported collection
   ' this function can be very helpful.
   clsPDF.CheckCollection

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      Dim outFile As String
      outFile = App.Path + "\out.pdf"
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      clsPDF.CloseFile
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

