VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Signature Appearance"
   ClientHeight    =   2580
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2580
   ScaleWidth      =   4965
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   735
      Left            =   1200
      TabIndex        =   0
      Top             =   960
      Width           =   2535
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "This example signs a document digitally with a self sign certificate and creates a user defined signature field."
      Height          =   390
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4800
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   ' Error messages and warnings are passed to the error event function.
   If Not clsPDF.CreateNewPDFA("") Then ' The output file is opened later
      Exit Sub
   End If
   Call clsPDF.SetDocInfoA(diAuthor, "Jens Boschulte")
   Call clsPDF.SetDocInfoA(diCreator, "VB test application")
   Call clsPDF.SetDocInfoA(diTitle, "Custom digital signature appearance")
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone

   Call clsPDF.Append
   Call clsPDF.SetFontA("Arial", fsNone, 14#, True, cp1252)
   Call clsPDF.WriteFTextA(taLeft, "This file is digitally signed with a self sign certificate." & _
   "The appearance of the signature field is created with normal DynaPDF functions. However, it " & _
   "would also be possible to import a PDF page, an EMF file, or an image into the " & _
   "appearance template." & Chr(13) & Chr(13) & _
   "When creating an individual signature appearance make sure to place the validation icon " & _
   "properly with PlaceSigFieldValidateIcon(). The appearance of the validation icon " & _
   "depends on the Acrobat version with which the file is opened. However, the unscaled size " & _
   "of that icon is always 100.0 x 100.0 Units. It can be scaled to every size you want " & _
   "but it is usually best to preserve the aspect ratio and the icon must be placed fully " & _
   "inside the appearance template.")

   ' ---------------------- Signature field appearance ----------------------
   
   Dim SigField As Long
   Dim sh As Long

   SigField = clsPDF.CreateSigField("Signature", -1, 200#, 500#, 200#, 80#)
   Call clsPDF.SetFieldColor(SigField, fcBorderColor, csDeviceRGB, NO_COLOR)
   ' Place the validation icon on the left side of the signature field.
   Call clsPDF.PlaceSigFieldValidateIcon(SigField, 0#, 15#, 50#, 50#)

'   This function creates a template into which you can draw whatever you want. The template
'   is already opened when calling the function; it must be closed when finish with EndTemplate().
'   An appearance template of a signature field is reserved for this field. It must not be placed
'   on a page!
'
'   In addition, it makes no sense to create an appearance template when the file is not digitally
'   signed later. Empty signature fields cannot contain a user defined appearance.
   Call clsPDF.CreateSigFieldAP(SigField)

   Call clsPDF.SaveGraphicState
   Call clsPDF.Rectangle(0#, 0#, 200#, 80#, fmNoFill)
   Call clsPDF.ClipPath(cmWinding, fmNoFill)
   sh = clsPDF.CreateAxialShading(0#, 0#, 200#, 0#, 0.5, RGB(120, 120, 220), vbWhite, True, True)
   Call clsPDF.ApplyShading(sh)
   Call clsPDF.RestoreGraphicState

   Call clsPDF.SaveGraphicState
   Call clsPDF.Ellipse(50.5, 1#, 148.5, 78#, fmNoFill)
   Call clsPDF.ClipPath(cmWinding, fmNoFill)
   sh = clsPDF.CreateAxialShading(0#, 0#, 0#, 78#, 2#, vbWhite, RGB(120, 120, 220), True, True)
   Call clsPDF.ApplyShading(sh)
   Call clsPDF.RestoreGraphicState

   Call clsPDF.SetFontA("Arial", fsBold Or fsUnderlined, 11#, True, cp1252)
   Call clsPDF.SetFillColor(RGB(120, 120, 220))
   Call clsPDF.WriteFTextExA(50#, 60#, 150#, -1#, taCenter, "Digitally signed by:")
   Call clsPDF.SetFontA("Arial", fsBold Or fsItalic, 18#, True, cp1252)
   Call clsPDF.SetFillColor(RGB(100, 100, 200))
   Call clsPDF.WriteFTextExA(50#, 45#, 150#, -1#, taCenter, "Jens Boschulte")

   Call clsPDF.EndTemplate ' Close the appearance template.

   ' ------------------------------------------------------------------------

   Call clsPDF.EndPage ' Close the open page

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      Dim outFile As String
      outFile = App.Path + "\out.pdf"
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      If Not clsPDF.CloseAndSignFile("../../test_files/test_cert.pfx", "test", "Test", "") Then
         ' Note: If the certificate cannot be found or when using a wrong password the PDF file is still
         ' in memory. This is required to enable entering another password or certificate file.
         clsPDF.FreePDF
      End If
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

