VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Signature Appearance"
   ClientHeight    =   2580
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4845
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2580
   ScaleWidth      =   4845
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   735
      Left            =   1200
      TabIndex        =   0
      Top             =   960
      Width           =   2535
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "This example signs a PDF/A 1b file digitally with a self sign certificate and creates a user defined signature field."
      Height          =   390
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4290
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   ' Error messages and warnings are passed to the error event function.
   If Not clsPDF.CreateNewPDFA("") Then ' The output file is opened later
      Exit Sub
   End If
   Call clsPDF.SetDocInfoA(diAuthor, "Jens Boschulte")
   Call clsPDF.SetDocInfoA(diCreator, "VB test application")
   Call clsPDF.SetDocInfoA(diTitle, "Custom digital signature appearance")
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone

   Call clsPDF.Append
   Call clsPDF.SetColorSpace(csDeviceRGB)
   Call clsPDF.SetFontA("Arial", fsNone, 10#, True, cp1252)
   Call clsPDF.WriteFTextA(taLeft, "This is a PDF/A 1b compatible PDF file that was digitally signed with " & _
      "a self sign certificate. Because PDF/A requires that all fonts are embedded it is important " & _
      "to avoid the usage of the 14 Standard fonts." & Chr(13) & Chr(13) & _
      "When signing a PDF/A compliant PDF file with the default settings (without creation of a user " & _
      "defined appearance) the font Arial must be available on the system because it is used to print " & _
      "the certificate properties into the signature field." & Chr(13) & Chr(13) & _
      "The font Arial must also be available if an empty signature field was added to the file " & _
      "without signing it when closing the PDF file. Yes, it is still possible to sign a PDF/A " & _
      "compliant PDF file later with Adobe's Acrobat. The signed PDF file is still compatible " & _
      "to PDF/A. If you use a third party solution to digitally sign the PDF file then test " & _
      "whether the signed file is still valid with the PDF/A 1b preflight tool included in Acrobat 8 " & _
      "Professional." & Chr(13) & Chr(13) & _
      "Signature fields must be visible and the print flag must be set (default). CheckConformance() " & _
      "adjusts these flags if necessary and produces a warning if changes were applied. If no changes " & _
      "should be allowed, just return -1 in the error callback function. If the error callback function " & _
      "returns 0, DynaPDF assumes that the prior changes were accepted and processing continues." & Chr(13) & Chr(13) & _
      "\FC[255]Notice:\FC[0]" & Chr(13) & _
      "It makes no sense to execute CheckConformance() without an error callback function or error event " & _
      "in VB. If you cannot see what happens during the execution of CheckConformance(), it is " & _
      "completely useless to use this function!" & Chr(13) & Chr(13) & _
      "CheckConformance() should be used to find the right settings to create PDF/A compatible PDF files. " & _
      "Once the the settings were found it is usually not longer recommended to execute this function. " & _
      "However, it is of course possible to use CheckConformance() as a general approach to make sure " & _
      "that files created with DynaPDF are PDF/A compatible.")

   ' ---------------------- Signature field appearance ----------------------

   Dim SigField As Long
   Dim sh As Long

   SigField = clsPDF.CreateSigField("Signature", -1, 200#, 400#, 200#, 80#)
   Call clsPDF.SetFieldColor(SigField, fcBorderColor, csDeviceRGB, NO_COLOR)
   ' Place the validation icon on the left side of the signature field.
   Call clsPDF.PlaceSigFieldValidateIcon(SigField, 0#, 15#, 50#, 50#)

'   This function creates a template into which you can draw whatever you want. The template
'   is already opened when calling the function; it must be closed when finish with EndTemplate().
'   An appearance template of a signature field is reserved for this field. It must not be placed
'   on a page!
'
'   In addition, it makes no sense to create an appearance template when the file is not digitally
'   signed later. Empty signature fields cannot contain a user defined appearance.
   Call clsPDF.CreateSigFieldAP(SigField)

   Call clsPDF.SaveGraphicState
   Call clsPDF.Rectangle(0#, 0#, 200#, 80#, fmNoFill)
   Call clsPDF.ClipPath(cmWinding, fmNoFill)
   sh = clsPDF.CreateAxialShading(0#, 0#, 200#, 0#, 0.5, RGB(120, 120, 220), vbWhite, True, True)
   Call clsPDF.ApplyShading(sh)
   Call clsPDF.RestoreGraphicState

   Call clsPDF.SaveGraphicState
   Call clsPDF.Ellipse(50.5, 1#, 148.5, 78#, fmNoFill)
   Call clsPDF.ClipPath(cmWinding, fmNoFill)
   sh = clsPDF.CreateAxialShading(0#, 0#, 0#, 78#, 2#, vbWhite, RGB(120, 120, 220), True, True)
   Call clsPDF.ApplyShading(sh)
   Call clsPDF.RestoreGraphicState

   Call clsPDF.SetFontA("Arial", fsBold Or fsUnderlined, 11#, True, cp1252)
   Call clsPDF.SetFillColor(RGB(120, 120, 220))
   Call clsPDF.WriteFTextExA(50#, 60#, 150#, -1#, taCenter, "Digitally signed by:")
   Call clsPDF.SetFontA("Arial", fsBold Or fsItalic, 18#, True, cp1252)
   Call clsPDF.SetFillColor(RGB(100, 100, 200))
   Call clsPDF.WriteFTextExA(50#, 45#, 150#, -1#, taCenter, "Jens Boschulte")

   Call clsPDF.EndTemplate ' Close the appearance template.

   ' ------------------------------------------------------------------------

   Call clsPDF.EndPage ' Close the open page

   ' Check whether the file is compatible to PDF/A 1b
   Select Case clsPDF.CheckConformance(ctPDFA_1b_2005, 0, 0, 0, 0)
      Case 1 And 3 ' RGB, Gray
         clsPDF.AddRenderingIntentA ("../../test_files/ColorMatchRGB.icc")
      Case 2 ' CMYK
         MsgBox "CMYK output is not configured in this example.", vbCritical, "Error"
         Return
   End Select

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      Dim outFile As String
      outFile = App.Path + "\out.pdf"
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      If Not clsPDF.CloseAndSignFile("../../test_files/test_cert.pfx", "test", "Test", "") Then
         ' Note: If the certificate cannot be found or when using a wrong password the PDF file is still
         ' in memory. This is required to enable entering another password or certificate file.
         clsPDF.FreePDF
      End If
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

