VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Text Extraction"
   ClientHeight    =   2580
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2580
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   855
      Left            =   840
      TabIndex        =   0
      Top             =   720
      Width           =   2895
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Command1_Click()
   On Error GoTo err
   ' Error messages and warnings are passed to the error event function.
   If Not clsPDF.CreateNewPDFA("") Then ' The output file is opened later
      Exit Sub
   End If

   ' External CMaps should always be loaded when processing text from PDF files.
   ' See the description of GetPageText() for further information.
   clsPDF.SetCMapDirA "../../../Resource/CMap/", True

   ' We avoid the conversion of pages to templates
   clsPDF.SetImportFlags ifImportAll Or ifImportAsPage
   If clsPDF.OpenImportFileA("../../../dynapdf_help.pdf", ptOpen, "") < 0 Then
      clsPDF.FreePDF
      Exit Sub
   End If
   clsPDF.ImportPDFFile 1, 1#, 1#
   clsPDF.CloseImportFile

   ' We flatten markup annotations and form fields so that we can extract the text in these objects too.
   clsPDF.FlattenAnnots affMarkupAnnots
   clsPDF.FlattenForm

   ' We write the output file into the current directory.
   Dim Path As String
   Path = App.Path + "\out.txt"
   Dim parser As New CTextExtraction
   parser.SetPDFInst clsPDF
   parser.OpenFile Path

   Dim i As Long
   For i = 1 To clsPDF.GetPageCount
      clsPDF.EditPage i
      parser.WritePageIdentifier i
      parser.ParsePage
      clsPDF.EndPage
   Next i
   parser.CloseFile
   clsPDF.FreePDF
   Set parser = Nothing
   ShellExecuteA Me.HWND, "open", Path, vbNullString, vbNullString, 1
   Exit Sub
err:
   clsPDF.FreePDF
   Set parser = Nothing
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Fatal error"
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub
