/*---------------------------------------------------------+
| DynaPDF 2.0                                              |
+----------------------------------------------------------+
| Copyright (C) 2003-2010                                  |
| Jens Boschulte, DynaForms GmbH.                          |
| All rights reserved.                                     |
+----------------------------------------------------------+
| Please report errors or other potential problems to      |
| support@dynaforms.com.                                   |
| The actual version is available at www.dynaforms.com.    |
+----------------------------------------------------------*/

#include "dynapdf.h"

#if defined(__cplusplus)
   using namespace DynaPDF;
#endif

/*
   Dummy decalrations to enable intellisense (code completion) in Microsoft's Visual C++ 6.0
   Due to the macro definitions of the ANSI and Unicode mappings it is not possible to declare
   these functions here with that name (e.g. pdfAddBookmark). Code completion does not work
   for these functions. However, just add the 'A' or 'W' at the end of the function name and
   remove it again when finished.

   Notice:
   The dummy declarations cannot be used with the static library of DynaPDF!
*/

#ifndef PDF_STATIC

LBOOL  PDF_CALL fntBuildFamilyNameAndStyle(const void* IFont, char Name[128], TFStyle ADDR Style){return 0;}
LBOOL  PDF_CALL fntGetFont(const void* IFont, struct TPDFFontObj* F){return 0;}
double PDF_CALL fntGetSpaceWidth(const void* IFont, double FontSize){return 0;}
double PDF_CALL fntGetTextWidth(const void* IFont, const BYTE* Text, UI32 Len, float CharSpacing, float WordSpacing, float TextScale){return 0;}
SI32   PDF_CALL fntTranslateRawCode(const void* IFont, const BYTE* Text, UI32 Len, double ADDR Width, UI16 OutText[32], SI32 ADDR OutLen, LBOOL ADDR Decoded, float CharSpacing, float WordSpacing, float TextScale){return 0;}
SI32   PDF_CALL fntTranslateString(struct TPDFStack* Stack, UI16* Buffer, UI32 Size, UI32 Flags){return 0;}
SI32   PDF_CALL fntTranslateString2(void* IFont, const BYTE* Text, UI32 Len, UI16* OutBuf, UI32 Size, UI32 Flags){return 0;}

LBOOL  PDF_CALL pdfAddActionToObj(const void* IPDF, TObjType ObjType, TObjEvent Event, UI32 ActHandle, UI32 ObjHandle){return 0;}
SI32   PDF_CALL pdfAddArticle(const void* IPDF, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfAddBookmarkA(const void* IPDF, const char* Title, SI32 Parent, UI32 DestPage, LBOOL Open){return 0;}
SI32   PDF_CALL pdfAddBookmarkW(const void* IPDF, const UI16* Title, SI32 Parent, UI32 DestPage, LBOOL Open){return 0;}
SI32   PDF_CALL pdfAddBookmarkExA(const void* IPDF, const char* Title, SI32 Parent, UI32 NamedDest, LBOOL Open){return 0;}
SI32   PDF_CALL pdfAddBookmarkExW(const void* IPDF, const UI16* Title, SI32 Parent, UI32 NamedDest, LBOOL Open){return 0;}
LBOOL  PDF_CALL pdfAddButtonImage(const void* IPDF, UI32 BtnHandle, TButtonState State, const char* Caption, const char* ImgFile){return 0;}
LBOOL  PDF_CALL pdfAddButtonImageEx(const void* IPDF, UI32 BtnHandle, TButtonState State, const char* Caption, void* hBitmap){return 0;}
LBOOL  PDF_CALL pdfAddContinueTextA(const void* IPDF, const char* AText){return 0;}
LBOOL  PDF_CALL pdfAddContinueTextW(const void* IPDF, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfAddDeviceNProcessColorants(const void* IPDF, UI32 DeviceNCS, const char** Colorants, UI32 NumColorants, TExtColorSpace CS, SI32 Handle){return 0;}
LBOOL  PDF_CALL pdfAddDeviceNSeparations(const void* IPDF, UI32 DeviceNCS, const char** Colorants, UI32* SeparationCS, UI32 NumColorants){return 0;}
LBOOL  PDF_CALL pdfAddFieldToFormAction(const void* IPDF, UI32 Action, UI32 AField, LBOOL Include){return 0;}
LBOOL  PDF_CALL pdfAddFieldToHideAction(const void* IPDF, UI32 HideAct, UI32 AField){return 0;}
LBOOL  PDF_CALL pdfAddFileCommentA(const void* IPDF, const char* AText){return 0;}
LBOOL  PDF_CALL pdfAddFileCommentW(const void* IPDF, const UI16* AText){return 0;}
SI32   PDF_CALL pdfAddFontSearchPathA(const void* IPDF, const char* APath, LBOOL Recursive){return 0;}
SI32   PDF_CALL pdfAddFontSearchPathW(const void* IPDF, const UI16* APath, LBOOL Recursive){return 0;}
LBOOL  PDF_CALL pdfAddImage(const void* IPDF, TCompressionFilter Filter, TImageConversionFlags Flags, struct TPDFImage* Image){return 0;}
SI32   PDF_CALL pdfAddJavaScriptA(const void* IPDF, const char* Name, const char* Script){return 0;}
SI32   PDF_CALL pdfAddJavaScriptW(const void* IPDF, const char* Name, const UI16* Script){return 0;}
LBOOL  PDF_CALL pdfAddObjectToLayer(const void* IPDF, UI32 OCG, TOCObject ObjType, UI32 Handle){return 0;}
SI32   PDF_CALL pdfAddPageLabelA(const void* IPDF, UI32 StartRange, TPageLabelFormat Format, const char* Prefix, SI32 AddNum){return 0;}
SI32   PDF_CALL pdfAddPageLabelW(const void* IPDF, UI32 StartRange, TPageLabelFormat Format, const UI16* Prefix, SI32 AddNum){return 0;}
SI32   PDF_CALL pdfAddRenderingIntentA(const void* IPDF, const char* ICCFile){return 0;}
SI32   PDF_CALL pdfAddRenderingIntentW(const void* IPDF, const UI16* ICCFile){return 0;}
SI32   PDF_CALL pdfAddRenderingIntentEx(const void* IPDF, const void* Buffer, UI32 BufSize){return 0;}
LBOOL  PDF_CALL pdfAddValToChoiceFieldA(const void* IPDF, UI32 Field, const char* ExpValue, const char* Value, LBOOL Selected){return 0;}
LBOOL  PDF_CALL pdfAddValToChoiceFieldW(const void* IPDF, UI32 Field, const char* ExpValue, const UI16* Value, LBOOL Selected){return 0;}
LBOOL  PDF_CALL pdfAppend(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfApplyPattern(const void* IPDF, SI32 PattHandle, TColorMode ColorMode, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfApplyShading(const void* IPDF, SI32 ShadHandle){return 0;}
SI32   PDF_CALL pdfAttachFileA(const void* IPDF, const char* FilePath, const char* Description, LBOOL Compress){return 0;}
SI32   PDF_CALL pdfAttachFileW(const void* IPDF, const UI16* FilePath, const UI16* Description, LBOOL Compress){return 0;}
SI32   PDF_CALL pdfAttachFileExA(const void* IPDF, const void* Buffer, UI32 BufSize, const char* FileName, const char* Description, LBOOL Compress){return 0;}
SI32   PDF_CALL pdfAttachFileExW(const void* IPDF, const void* Buffer, UI32 BufSize, const UI16* FileName, const UI16* Description, LBOOL Compress){return 0;}
LBOOL  PDF_CALL pdfAutoTemplate(const void* IPDF, UI32 Templ, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfBeginClipPath(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfBeginContinueText(const void* IPDF, double PosX, double PosY){return 0;}
LBOOL  PDF_CALL pdfBeginLayer(const void* IPDF, UI32 OCG){return 0;}
SI32   PDF_CALL pdfBeginPattern(const void* IPDF, TPatternType PatternType, TTilingType TilingType, double Width, double Height){return 0;}
SI32   PDF_CALL pdfBeginTemplate(const void* IPDF, double Width, double Height){return 0;}
SI32   PDF_CALL pdfBeginTemplateEx(const void* IPDF, struct TPDFRect* BBox, struct TCTM* Matrix){return 0;}
LBOOL  PDF_CALL pdfBezier_1_2_3(const void* IPDF, double x1, double y1, double x2, double y2, double x3, double y3){return 0;}
LBOOL  PDF_CALL pdfBezier_1_3(const void* IPDF, double x1, double y1, double x3, double y3){return 0;}
LBOOL  PDF_CALL pdfBezier_2_3(const void* IPDF, double x2, double y2, double x3, double y3){return 0;}
double PDF_CALL pdfCalcWidthHeight(const void* IPDF, double OrgWidth, double OrgHeight, double ScaledWidth, double ScaledHeight){return 0;}
LBOOL  PDF_CALL pdfChangeAnnotPos(const void* IPDF, UI32 Handle, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfChangeAnnotNameA(const void* IPDF, UI32 Handle, const char* Name){return 0;}
LBOOL  PDF_CALL pdfChangeAnnotNameW(const void* IPDF, UI32 Handle, const UI16* Name){return 0;}
LBOOL  PDF_CALL pdfChangeBookmarkA(const void* IPDF, SI32 ABmk, const char* Title, SI32 Parent, UI32 DestPage, LBOOL Open){return 0;}
LBOOL  PDF_CALL pdfChangeBookmarkW(const void* IPDF, SI32 ABmk, const UI16* Title, SI32 Parent, UI32 DestPage, LBOOL Open){return 0;}
LBOOL  PDF_CALL pdfChangeFont(const void* IPDF, SI32 Handle){return 0;}
LBOOL  PDF_CALL pdfChangeFontSize(const void* IPDF, double Size){return 0;}
LBOOL  PDF_CALL pdfChangeFontStyle(const void* IPDF, TFStyle Style){return 0;}
LBOOL  PDF_CALL pdfChangeFontStyleEx(const void* IPDF, TFStyle Style){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptA(const void* IPDF, UI32 Handle, const char* NewScript){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptW(const void* IPDF, UI32 Handle, const UI16* NewScript){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptActionA(const void* IPDF, UI32 Handle, const char* NewScript){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptActionW(const void* IPDF, UI32 Handle, const UI16* NewScript){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptNameA(const void* IPDF, UI32 Handle, const char* Name){return 0;}
LBOOL  PDF_CALL pdfChangeJavaScriptNameW(const void* IPDF, UI32 Handle, const UI16* Name){return 0;}
LBOOL  PDF_CALL pdfChangeLinkAnnot(const void* IPDF, UI32 Handle, const char* URL){return 0;}
SI32   PDF_CALL pdfCheckFieldNames(const void* IPDF){return 0;}
SI32   PDF_CALL pdfCheckAndRepairFonts(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfCheckCollection(const void* IPDF){return 0;}
SI32   PDF_CALL pdfCheckConformance(const void* IPDF, TConformanceType Type, TCheckOptions Options, const void* UserData, TOnFontNotFoundProc* OnFontNotFound, TOnReplaceICCProfile* OnReplaceICCProfile){return 0;}
LBOOL  PDF_CALL pdfClearAutoTemplates(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfClearHostFonts(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfClipPath(const void* IPDF, TClippingMode ClipMode, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfCloseAndSignFile(const void* IPDF, const char* CertFile, const char* Password, const char* Reason, const char* Location){return 0;}
LBOOL  PDF_CALL pdfCloseAndSignFileEx(const void* IPDF, const char* OpenPwd, const char* OwnerPwd, TKeyLen KeyLen, TRestrictions Restrict, const char* CertFile, const char* Password, const char* Reason, const char* Location){return 0;}
LBOOL  PDF_CALL pdfCloseAndSignFileExt(const void* IPDF, struct TPDFSigParms* SigParms){return 0;}
LBOOL  PDF_CALL pdfCloseFile(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfCloseFileEx(const void* IPDF, const char* OpenPwd, const char* OwnerPwd, TKeyLen KeyLen, TRestrictions Restrict){return 0;}
LBOOL  PDF_CALL pdfCloseImage(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfCloseImportFile(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfClosePath(const void* IPDF, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfCloseTag(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfComputeBBox(const void* IPDF, struct TPDFRect ADDR BBox, TCompBBoxFlags Flags){return 0;}
UI32   PDF_CALL pdfConvColor(const double* Color, UI32 NumComps, TExtColorSpace SourceCS, const void* IColorSpace, TExtColorSpace DestCS){return 0;}
LBOOL  PDF_CALL pdfConvertColors(const void* IPDF, TColorConvFlags Flags, const void* Reserved){return 0;}
UI16*  PDF_CALL pdfConvToUnicode(const void* IPDF, const char* AString, TCodepage CP){return 0;}
SI32   PDF_CALL pdfCopyMem(const void* Source, void* Dest, UI32 Len){return 0;}
void   PDF_CALL pdfCopyPtr(void* Source, void* &Dest){}
SI32   PDF_CALL pdfCreate3DAnnot(const void* IPDF, double PosX, double PosY, double Width, double Height, const char* Author, const char* Name, const char* U3DFile, const char* Image){return 0;}
LBOOL  PDF_CALL pdfCreate3DBackground(const void* IPDF, const void* IView, UI32 BackColor){return 0;}
SI32   PDF_CALL pdfCreate3DGotoViewAction(const void* IPDF, UI32 Base3DAnnot, const void* IView, T3DNamedAction Named){return 0;}
LBOOL  PDF_CALL pdfCreate3DProjection(const void* IPDF, const void* IView, T3DProjType ProjType, T3DScaleType ScaleType, double Diameter, double FOV){return 0;}
void*  PDF_CALL pdfCreate3DView(const void* IPDF, UI32 Base3DAnnot, const char* Name, LBOOL SetAsDefault, double* Matrix, double CamDistance, T3DRenderingMode RM, T3DLightingSheme LS){return 0;}
SI32   PDF_CALL pdfCreateAnnotAP(const void* IPDF, UI32 Annot){return 0;}
SI32   PDF_CALL pdfCreateArticleThreadA(const void* IPDF, const char* ThreadName){return 0;}
SI32   PDF_CALL pdfCreateArticleThreadW(const void* IPDF, const UI16* ThreadName){return 0;}
SI32   PDF_CALL pdfCreateAxialShading(const void* IPDF, double sX, double sY, double eX, double eY, double SCenter, UI32 SColor, UI32 EColor, LBOOL Extend1, LBOOL Extend2){return 0;}
SI32   PDF_CALL pdfCreateButtonA(const void* IPDF, const char* Name, const char* Caption, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateButtonW(const void* IPDF, const char* Name, const UI16* Caption, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateCheckBox(const void* IPDF, const char* Name, const char* ExpValue, LBOOL Checked, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateCIEColorSpace(const void* IPDF, TExtColorSpace Base, float* WhitePoint, float* BlackPoint, float* Gamma, float* Matrix){return 0;}
LBOOL  PDF_CALL pdfCreateCollection(const void* IPDF, TColView View){return 0;}
SI32   PDF_CALL pdfCreateCollectionFieldA(const void* IPDF, TColColumnType ColType, SI32 Column, const char* Name, const char* Key, LBOOL Visible, LBOOL Editable){return 0;}
SI32   PDF_CALL pdfCreateCollectionFieldW(const void* IPDF, TColColumnType ColType, SI32 Column, const UI16* Name, const char* Key, LBOOL Visible, LBOOL Editable){return 0;}
LBOOL  PDF_CALL pdfCreateColItemDate(const void* IPDF, UI32 EmbFile, const char* Key, long Date, const char* Prefix){return 0;}
LBOOL  PDF_CALL pdfCreateColItemNumber(const void* IPDF, UI32 EmbFile, const char* Key, double Value, const char* Prefix){return 0;}
LBOOL  PDF_CALL pdfCreateColItemStringA(const void* IPDF, UI32 EmbFile, const char* Key, const char* Value, const char* Prefix){return 0;}
LBOOL  PDF_CALL pdfCreateColItemStringW(const void* IPDF, UI32 EmbFile, const char* Key, const UI16* Value, const UI16* Prefix){return 0;}
SI32   PDF_CALL pdfCreateComboBox(const void* IPDF, const char* Name, LBOOL Sort, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateDeviceNColorSpace(const void* IPDF, const char** Colorants, UI32 NumColorants, const char* PostScriptFunc, TExtColorSpace Alternate, SI32 Handle){return 0;}
SI32   PDF_CALL pdfCreateExtGState(const void* IPDF, struct TPDFExtGState* GS){return 0;}
SI32   PDF_CALL pdfCreateGoToAction(const void* IPDF, TDestType DestType, UI32 PageNum, double a, double b, double c, double d){return 0;}
SI32   PDF_CALL pdfCreateGoToActionEx(const void* IPDF, UI32 NamedDest){return 0;}
SI32   PDF_CALL pdfCreateGoToRAction(const void* IPDF, const char* FileName, UI32 PageNum){return 0;}
SI32   PDF_CALL pdfCreateGoToRActionExA(const void* IPDF, const char* FileName, char* DestName, LBOOL NewWindow){return 0;}
SI32   PDF_CALL pdfCreateGoToRActionExW(const void* IPDF, const char* FileName, UI16* DestName, LBOOL NewWindow){return 0;}
SI32   PDF_CALL pdfCreateGroupField(const void* IPDF, const char* Name, SI32 Parent){return 0;}
SI32   PDF_CALL pdfCreateHideAction(const void* IPDF, UI32 AField, LBOOL Hide){return 0;}
SI32   PDF_CALL pdfCreateICCBasedColorSpaceA(const void* IPDF, const char* ICCProfile){return 0;}
SI32   PDF_CALL pdfCreateICCBasedColorSpaceW(const void* IPDF, const UI16* ICCProfile){return 0;}
LBOOL  PDF_CALL pdfCreateImageA(const void* IPDF, const char* FileName, TImageFormat Format){return 0;}
LBOOL  PDF_CALL pdfCreateImageW(const void* IPDF, const UI16* FileName, TImageFormat Format){return 0;}
SI32   PDF_CALL pdfCreateImpDataActionA(const void* IPDF, const char* DataFile){return 0;}
SI32   PDF_CALL pdfCreateImpDataActionW(const void* IPDF, const UI16* DataFile){return 0;}
SI32   PDF_CALL pdfCreateIndexedColorSpace(const void* IPDF, TExtColorSpace Base, SI32 Handle, const void* ColorTable, UI32 NumColors){return 0;}
SI32   PDF_CALL pdfCreateJSActionA(const void* IPDF, const char* Script){return 0;}
SI32   PDF_CALL pdfCreateJSActionW(const void* IPDF, const UI16* Script){return 0;}
SI32   PDF_CALL pdfCreateLaunchAction(const void* IPDF, TFileOP OP, const char* FileName, const char* DefDir, const char* Param, LBOOL NewWindow){return 0;}
SI32   PDF_CALL pdfCreateListBox(const void* IPDF, const char* Name, LBOOL Sort, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateNamedAction(const void* IPDF, TNamedAction Action){return 0;}
SI32   PDF_CALL pdfCreateNamedDestA(const void* IPDF, const char* Name, UI32 DestPage, TDestType DestType, double a, double b, double c, double d){return 0;}
SI32   PDF_CALL pdfCreateNamedDestW(const void* IPDF, const UI16* Name, UI32 DestPage, TDestType DestType, double a, double b, double c, double d){return 0;}
LBOOL  PDF_CALL pdfCreateNewPDFA(const void* IPDF, const char* OutPDF){return 0;}
LBOOL  PDF_CALL pdfCreateNewPDFW(const void* IPDF, const UI16* OutPDF){return 0;}
SI32   PDF_CALL pdfCreateOCGA(const void* IPDF, const char* Name, LBOOL DisplayInUI, LBOOL Visible, TOCGIntent Intent){return 0;}
SI32   PDF_CALL pdfCreateOCGW(const void* IPDF, const UI16* Name, LBOOL DisplayInUI, LBOOL Visible, TOCGIntent Intent){return 0;}
SI32   PDF_CALL pdfCreateOCMD(const void* IPDF, TOCVisibility Visibility, UI32* OCGs, UI32 Count){return 0;}
SI32   PDF_CALL pdfCreateRadialShading(const void* IPDF, double sX, double sY, double R1, double eX, double eY, double R2, double SCenter, UI32 SColor, UI32 EColor, LBOOL Extend1, LBOOL Extend2){return 0;}
SI32   PDF_CALL pdfCreateRadioButton(const void* IPDF, const char* Name, const char* ExpValue, SI32 Checked, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateResetAction(const void* IPDF){return 0;}
SI32   PDF_CALL pdfCreateSeparationCS(const void* IPDF, const char* Colorant, TExtColorSpace Alternate, SI32 Handle, UI32 Color){return 0;}
SI32   PDF_CALL pdfCreateSetOCGStateAction(const void* IPDF, UI32* On, UI32 OnCount, UI32* Off, UI32 OffCount, UI32* Toggle, UI32 ToggleCount, LBOOL PreserveRB){return 0;}
SI32   PDF_CALL pdfCreateSigField(const void* IPDF, const char* Name, SI32 Parent, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateSigFieldAP(const void* IPDF, UI32 SigField){return 0;}
SI32   PDF_CALL pdfCreateStdPattern(const void* IPDF, TStdPattern Pattern, double LineWidth, double Distance, UI32 LineColor, UI32 BackColor){return 0;}
LBOOL  PDF_CALL pdfCreateStructureTree(const void* IPDF){return 0;}
SI32   PDF_CALL pdfCreateSubmitAction(const void* IPDF, TSubmitFlags Flags, const char* URL){return 0;}
SI32   PDF_CALL pdfCreateTextField(const void* IPDF, const char* Name, SI32 Parent, LBOOL Multiline, SI32 MaxLen, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfCreateURIAction(const void* IPDF, const char* URL){return 0;}
SI32   PDF_CALL pdfDecryptPDFA(const void* IPDF, const char* FileName, TPwdType PwdType, const char* Password){return 0;}
SI32   PDF_CALL pdfDecryptPDFW(const void* IPDF, const UI16* FileName, TPwdType PwdType, const char* Password){return 0;}
void   PDF_CALL pdfDeleteAcroForm(const void* IPDF){}
LBOOL  PDF_CALL pdfDeleteActionFromObj(const void* IPDF, TObjType ObjType, UI32 ActHandle, UI32 ObjHandle){return 0;}
LBOOL  PDF_CALL pdfDeleteActionFromObjEx(const void* IPDF, TObjType ObjType, UI32 ObjHandle, UI32 ActIndex){return 0;}
LBOOL  PDF_CALL pdfDeleteAnnotation(const void* IPDF, UI32 Handle){return 0;}
SI32   PDF_CALL pdfDeleteBookmark(const void* IPDF, UI32 ABmk){return 0;}
LBOOL  PDF_CALL pdfDeleteEmbeddedFile(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfDeleteField(const void* IPDF, UI32 AField){return 0;}
LBOOL  PDF_CALL pdfDeleteFieldEx(const void* IPDF, const char* Name){return 0;}
void   PDF_CALL pdfDeleteJavaScripts(const void* IPDF, LBOOL DelJavaScriptActions){}
SI32   PDF_CALL pdfDeletePage(const void* IPDF, UI32 PageNum){return 0;}
void   PDF_CALL pdfDeletePageLabels(const void* IPDF){}
LBOOL  PDF_CALL pdfDeletePDF(void* IPDF){return 0;}
void   PDF_CALL pdfDeleteXFAForm(const void* IPDF){}
LBOOL  PDF_CALL pdfDeleteSeparationInfo(const void* IPDF, LBOOL AllPages){return 0;}
LBOOL  PDF_CALL pdfDeleteTemplate(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfDeleteTemplateEx(const void* IPDF, UI32 Index){return 0;}
LBOOL  PDF_CALL pdfDrawArc(const void* IPDF, double PosX, double PosY, double Radius, double StartAngle, double EndAngle){return 0;}
LBOOL  PDF_CALL pdfDrawArcEx(const void* IPDF, double PosX, double PosY, double Width, double Height, double StartAngle, double EndAngle){return 0;}
LBOOL  PDF_CALL pdfDrawChord(const void* IPDF, double PosX, double PosY, double Width, double Height, double StartAngle, double EndAngle, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfDrawCircle(const void* IPDF, double PosX, double PosY, double Radius, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfDrawPie(const void* IPDF, double PosX, double PosY, double Width, double Height, double StartAngle, double EndAngle, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfEditPage(const void* IPDF, SI32 PageNum){return 0;}
LBOOL  PDF_CALL pdfEditTemplate(const void* IPDF, UI32 Index){return 0;}
LBOOL  PDF_CALL pdfEditTemplate2(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfEllipse(const void* IPDF, double PosX, double PosY, double Width, double Height, TPathFillMode FillMode){return 0;}
SI32   PDF_CALL pdfEncryptPDFA(const void* IPDF, const char* FileName, const char* OpenPwd, const char* OwnerPwd, TKeyLen KeyLen, TRestrictions Restrict){return 0;}
SI32   PDF_CALL pdfEncryptPDFW(const void* IPDF, const UI16* FileName, const char* OpenPwd, const char* OwnerPwd, TKeyLen KeyLen, TRestrictions Restrict){return 0;}
LBOOL  PDF_CALL pdfEndContinueText(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfEndLayer(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfEndPage(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfEndPattern(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfEndTemplate(const void* IPDF){return 0;}
SI32   PDF_CALL pdfEnumDocFonts(const void* IPDF, const void* Data, TEnumFontProc2* EnumProc){return 0;}
SI32   PDF_CALL pdfEnumHostFonts(const void* IPDF, const void* Data, TEnumFontProc* EnumProc){return 0;}
SI32   PDF_CALL pdfEnumHostFontsEx(const void* IPDF, const void* Data, TEnumFontProcEx* EnumProc){return 0;}
LBOOL  PDF_CALL pdfExchangeBookmarks(const void* IPDF, SI32 Bmk1, SI32 Bmk2){return 0;}
LBOOL  PDF_CALL pdfExchangePages(const void* IPDF, UI32 First, UI32 Second){return 0;}
SI32   PDF_CALL pdfFileAttachAnnotA(const void* IPDF, double PosX, double PosY, TFileAttachIcon Icon, const char* Author, const char* Desc, const char* AFile, LBOOL Compress){return 0;}
SI32   PDF_CALL pdfFileAttachAnnotW(const void* IPDF, double PosX, double PosY, TFileAttachIcon Icon, const UI16* Author, const UI16* Desc, const UI16* AFile, LBOOL Compress){return 0;}
SI32   PDF_CALL pdfFileLinkA(const void* IPDF, double PosX, double PosY, double Width, double Height, const char* AFilePath){return 0;}
SI32   PDF_CALL pdfFileLinkW(const void* IPDF, double PosX, double PosY, double Width, double Height, const UI16* AFilePath){return 0;}
SI32   PDF_CALL pdfFindBookmarkA(const void* IPDF, SI32 DestPage, const char* Title){return 0;}
SI32   PDF_CALL pdfFindBookmarkW(const void* IPDF, SI32 DestPage, const UI16* Title){return 0;}
SI32   PDF_CALL pdfFindFieldA(const void* IPDF, const char* Name){return 0;}
SI32   PDF_CALL pdfFindFieldW(const void* IPDF, const UI16* Name){return 0;}
SI32   PDF_CALL pdfFindLinkAnnot(const void* IPDF, const char* URL){return 0;}
SI32   PDF_CALL pdfFindNextBookmark(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfFinishSignature(const void* IPDF, const void* PKCS7Obj, UI32 Length){return 0;}
SI32   PDF_CALL pdfFlattenAnnots(const void* IPDF, TAnnotFlattenFlags Flags){return 0;}
LBOOL  PDF_CALL pdfFlattenForm(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfFlushPageContent(const void* IPDF, struct TPDFStack* Stack){return 0;}
void   PDF_CALL pdfFreeImageBuffer(const void* IPDF){}
LBOOL  PDF_CALL pdfFreePDF(const void* IPDF){return 0;}
SI32   PDF_CALL pdfFreeTextAnnotA(const void* IPDF, double PosX, double PosY, double Width, double Height, const char* Author, const char* AText, TTextAlign Align){return 0;}
SI32   PDF_CALL pdfFreeTextAnnotW(const void* IPDF, double PosX, double PosY, double Width, double Height, const UI16* Author, const UI16* AText, TTextAlign Align){return 0;}
LBOOL  PDF_CALL pdfFreeUniBuf(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetActionCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetActionType(const void* IPDF, UI32 ActHandle){return 0;}
SI32   PDF_CALL pdfGetActionTypeEx(const void* IPDF, TObjType ObjType, UI32 ObjHandle, UI32 ActIndex){return 0;}
SI32   PDF_CALL pdfGetActiveFont(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetAllocBy(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetAnnot(const void* IPDF, UI32 Handle, struct TPDFAnnotation ADDR Annot){return 0;}
LBOOL  PDF_CALL pdfGetAnnotBBox(const void* IPDF, UI32 Handle, struct TPDFRect ADDR BBox){return 0;}
SI32   PDF_CALL pdfGetAnnotCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetAnnotEx(const void* IPDF, UI32 Handle, struct TPDFAnnotationEx ADDR Annot){return 0;}
SI32   PDF_CALL pdfGetAnnotFlags(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetAnnotLink(const void* IPDF, UI32 Handle){return 0;}
SI32   PDF_CALL pdfGetAnnotType(const void* IPDF, UI32 Handle){return 0;}
double PDF_CALL pdfGetAscent(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetBBox(const void* IPDF, TPageBoundary Boundary, struct TPDFRect ADDR BBox){return 0;}
SI32   PDF_CALL pdfGetBidiMode(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetBookmark(const void* IPDF, SI32 Handle, struct TBookmark ADDR Bmk){return 0;}
SI32   PDF_CALL pdfGetBookmarkCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetBorderStyle(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetBuffer(const void* IPDF, UI32 ADDR BufSize){return 0;}
double PDF_CALL pdfGetCapHeight(const void* IPDF){return 0;}
double PDF_CALL pdfGetCharacterSpacing(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetCheckBoxChar(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetCheckBoxCharEx(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetCheckBoxDefState(const void* IPDF, UI32 AField){return 0;}
LBOOL  PDF_CALL pdfGetCMap(const void* IPDF, UI32 Index, struct TPDFCMap* CMap){return 0;}
SI32   PDF_CALL pdfGetCMapCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetColorSpace(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetColorSpaceCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetColorSpaceObj(const void* IPDF, UI32 Handle, struct TPDFColorSpaceObj* CS){return 0;}
LBOOL  PDF_CALL pdfGetColorSpaceObjEx(const void* IColorSpace, struct TPDFColorSpaceObj* CS){return 0;}
SI32   PDF_CALL pdfGetCompressionFilter(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetCompressionLevel(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetContent(const void* IPDF, char* ADDR Buffer){return 0;}
SI32   PDF_CALL pdfGetDefBitsPerPixel(const void* IPDF){return 0;}
double PDF_CALL pdfGetDescent(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetDeviceNAttributes(void* IAttributes, struct TDeviceNAttributes* Attributes){return 0;}
SI32   PDF_CALL pdfGetDocInfo(const void* IPDF, TDocumentInfo DInfo, UI16* ADDR Value){return 0;}
SI32   PDF_CALL pdfGetDocInfoCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetDocInfoEx(const void* IPDF, UI32 Index, TDocumentInfo ADDR DInfo, char* ADDR Key, char* ADDR Value, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetDrawDirection(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetDynaPDFVersion(void){return 0;}
LBOOL  PDF_CALL pdfGetEmbeddedFile(const void* IPDF, UI32 Handle, struct TPDFFileSpec* FileSpec, LBOOL Decompress){return 0;}
SI32   PDF_CALL pdfGetEmbeddedFileCount(const void* IPDF){return 0;}
double PDF_CALL pdfGetEMFPatternDistance(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetErrorMessage(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetErrorMode(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetField(const void* IPDF, UI32 Handle, struct TPDFField* Field){return 0;}
UI32   PDF_CALL pdfGetFieldBackColor(const void* IPDF){return 0;}
UI32   PDF_CALL pdfGetFieldBorderColor(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetFieldBorderStyle(const void* IPDF, UI32 AField){return 0;}
double PDF_CALL pdfGetFieldBorderWidth(const void* IPDF, UI32 AField){return 0;}
LBOOL  PDF_CALL pdfGetFieldChoiceValue(const void* IPDF, UI32 AField, UI32 ValIndex, struct TPDFChoiceValue* Value){return 0;}
LBOOL  PDF_CALL pdfGetFieldColor(const void* IPDF, UI32 AField, TFieldColor ColorType, SI32 ADDR ColorSpace, UI32 ADDR Color){return 0;}
SI32   PDF_CALL pdfGetFieldCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetFieldEx(const void* IPDF, UI32 Handle, struct TPDFFieldEx* Field){return 0;}
LBOOL  PDF_CALL pdfGetFieldEx2(const void* IField, struct TPDFFieldEx* Field){return 0;}
SI32   PDF_CALL pdfGetFieldExpValCount(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldExpValue(const void* IPDF, UI32 AField, char* ADDR Value){return 0;}
LBOOL  PDF_CALL pdfGetFieldExpValueEx(const void* IPDF, UI32 AField, UI32 ValIndex, char* ADDR Value, char* ADDR ExpValue, LBOOL ADDR Selected){return 0;}
SI32   PDF_CALL pdfGetFieldFlags(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldGroupType(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldHighlightMode(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldIndex(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldMapName(const void* IPDF, UI32 AField, void* ADDR Value, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetFieldName(const void* IPDF, UI32 AField, char* ADDR Name){return 0;}
SI32   PDF_CALL pdfGetFieldOrientation(const void* IPDF, UI32 AField){return 0;}
SI32   PDF_CALL pdfGetFieldTextAlign(const void* IPDF, UI32 AField){return 0;}
UI32   PDF_CALL pdfGetFieldTextColor(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetFieldToolTip(const void* IPDF, UI32 AField, void* ADDR Value, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetFieldType(const void* IPDF, UI32 AField){return 0;}
UI32   PDF_CALL pdfGetFillColor(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetFontCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetFontEx(const void* IPDF, UI32 Handle, struct TPDFFontObj* F){return 0;}
SI32   PDF_CALL pdfGetFontOrigin(const void* IPDF){return 0;}
void   PDF_CALL pdfGetFontSearchOrder(const void* IPDF, TFontBaseType Order[4]){return;}
SI32   PDF_CALL pdfGetFontSelMode(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetFontWeight(const void* IPDF){return 0;}
double PDF_CALL pdfGetFTextHeightA(const void* IPDF, TTextAlign Align, const char* AText){return 0;}
double PDF_CALL pdfGetFTextHeightW(const void* IPDF, TTextAlign Align, const UI16* AText){return 0;}
double PDF_CALL pdfGetFTextHeightExA(const void* IPDF, double Width, TTextAlign Align, const char* AText){return 0;}
double PDF_CALL pdfGetFTextHeightExW(const void* IPDF, double Width, TTextAlign Align, const UI16* AText){return 0;}
UI32   PDF_CALL pdfGetGStateFlags(const void* IPDF){return 0;}
UI32   PDF_CALL pdfGetIconColor(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetImageBuffer(const void* IPDF, UI32 ADDR BufSize){return 0;}
SI32   PDF_CALL pdfGetImageCount(const void* IPDF, const char* FileName){return 0;}
SI32   PDF_CALL pdfGetImageCountEx(const void* IPDF, const void* Buffer, UI32 BufSize){return 0;}
SI32   PDF_CALL pdfGetImageHeight(const void* IPDF, UI32 Handle){return 0;}
SI32   PDF_CALL pdfGetImageWidth(const void* IPDF, UI32 Handle){return 0;}
UI32   PDF_CALL pdfGetImportFlags(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInBBox(const void* IPDF, UI32 PageNum, TPageBoundary Boundary, struct TPDFRect ADDR BBox){return 0;}
SI32   PDF_CALL pdfGetInDocInfo(const void* IPDF, TDocumentInfo DInfo, UI16* ADDR Value){return 0;}
SI32   PDF_CALL pdfGetInDocInfoCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetInDocInfoEx(const void* IPDF, UI32 Index, TDocumentInfo ADDR DInfo, char* ADDR Key, char* ADDR Value, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetInEncryptionFlags(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInIsCollection(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInIsEncrypted(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInIsSigned(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInIsTrapped(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInIsXFAForm(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInNamedDest(const void* IPDF, UI32 Index, struct TPDFNamedDest* Dest){return 0;}
SI32   PDF_CALL pdfGetInNamedDestCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetInOrientation(const void* IPDF, SI32 PageNum){return 0;}
SI32   PDF_CALL pdfGetInPageCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetInPDFVersion(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetInPrintSettings(const void* IPDF, struct TPDFPrintSettings* Settings){return 0;}
SI32   PDF_CALL pdfGetIsFixedPitch(const void* IPDF){return 0;}
double PDF_CALL pdfGetItalicAngle(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetJavaScript(const void* IPDF, UI32 Handle, UI32 ADDR Len, LBOOL ADDR Unicode){return 0;}
char*  PDF_CALL pdfGetJavaScriptAction(const void* IPDF, UI32 Handle, UI32 ADDR Len, LBOOL ADDR Unicode){return 0;}
char*  PDF_CALL pdfGetJavaScriptAction2(const void* IPDF, TObjType ObjType, UI32 ObjHandle, UI32 ActIndex, UI32 ADDR Len, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetJavaScriptCount(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetJavaScriptEx(const void* IPDF, const char* Name, UI32 ADDR Len, LBOOL ADDR Unicode){return 0;}
char*  PDF_CALL pdfGetJavaScriptName(const void* IPDF, UI32 Handle, UI32 ADDR Len, LBOOL ADDR Unicode){return 0;}
SI32   PDF_CALL pdfGetJPEGQuality(const void* IPDF){return 0;}
char*  PDF_CALL pdfGetLanguage(const void* IPDF){return 0;}
double PDF_CALL pdfGetLastTextPosX(const void* IPDF){return 0;}
double PDF_CALL pdfGetLastTextPosY(const void* IPDF){return 0;}
double PDF_CALL pdfGetLeading(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetLineCapStyle(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetLineJoinStyle(const void* IPDF){return 0;}
double PDF_CALL pdfGetLineWidth(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetLinkHighlightMode(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetLogMetafileSize(const void* IPDF, const char* FileName, struct TRectL* R){return 0;}
LBOOL  PDF_CALL pdfGetLogMetafileSizeEx(const void* IPDF, const void* Buffer, UI32 BufSize, struct TRectL* R){return 0;}
LBOOL  PDF_CALL pdfGetMatrix(const void* IPDF, struct TCTM* M){return 0;}
SI32   PDF_CALL pdfGetMaxFieldLen(const void* IPDF, UI32 TxtField){return 0;}
UI32   PDF_CALL pdfGetMetaConvFlags(const void* IPDF){return 0;}
UI32*  PDF_CALL pdfGetMissingGlyphs(const void* IPDF, UI32 ADDR Count){return 0;}
double PDF_CALL pdfGetMiterLimit(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetNeedAppearance(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetObjActionCount(const void* IPDF, TObjType ObjType, UI32 ObjHandle){return 0;}
double PDF_CALL pdfGetOpacity(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetOrientation(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPageAnnot(const void* IPDF, UI32 Index, struct TPDFAnnotation ADDR Annot){return 0;}
LBOOL  PDF_CALL pdfGetPageAnnotEx(const void* IPDF, UI32 Index, struct TPDFAnnotationEx ADDR Annot){return 0;}
SI32   PDF_CALL pdfGetPageAnnotCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPageCoords(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPageCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPageField(const void* IPDF, UI32 Index, struct TPDFField* Field){return 0;}
SI32   PDF_CALL pdfGetPageFieldCount(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPageFieldEx(const void* IPDF, UI32 Index, struct TPDFFieldEx* Field){return 0;}
double PDF_CALL pdfGetPageHeight(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPageLabel(const void* IPDF, UI32 Index, struct TPDFPageLabel* Label){return 0;}
SI32   PDF_CALL pdfGetPageLabelCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPageLayout(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPageMode(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPageNum(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPageText(const void* IPDF, struct TPDFStack* Stack){return 0;}
double PDF_CALL pdfGetPageWidth(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetPDFVersion(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetPrintSettings(const void* IPDF, struct TPDFPrintSettings* Settings){return 0;}
SI32   PDF_CALL pdfGetResolution(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetSaveNewImageFormat(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetSeparationInfo(const void* IPDF, char* ADDR Colorant, TExtColorSpace ADDR CS){return 0;}
UI32   PDF_CALL pdfGetStrokeColor(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetTabLen(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetTemplCount(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetTemplHandle(const void* IPDF){return 0;}
double PDF_CALL pdfGetTemplHeight(const void* IPDF, SI32 Handle){return 0;}
double PDF_CALL pdfGetTemplWidth(const void* IPDF, SI32 Handle){return 0;}
SI32   PDF_CALL pdfGetTextDrawMode(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetTextFieldValue(const void* IPDF, UI32 AField, char* ADDR Value, LBOOL ADDR ValIsUnicode, char* ADDR DefValue, LBOOL ADDR DefValIsUnicode){return 0;}
LBOOL  PDF_CALL pdfGetTextRect(const void* IPDF, double ADDR PosX, double ADDR PosY, double ADDR Width, double ADDR Height){return 0;}
double PDF_CALL pdfGetTextRise(const void* IPDF){return 0;}
double PDF_CALL pdfGetTextScaling(const void* IPDF){return 0;}
double PDF_CALL pdfGetTextWidthA(const void* IPDF, const char* AText){return 0;}
double PDF_CALL pdfGetTextWidthW(const void* IPDF, const UI16* AText){return 0;}
double PDF_CALL pdfGetTextWidthExA(const void* IPDF, const char* AText, UI32 Len){return 0;}
double PDF_CALL pdfGetTextWidthExW(const void* IPDF, const UI16* AText, UI32 Len){return 0;}
UI32   PDF_CALL pdfGetTransparentColor(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetTrapped(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseExactPwd(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseGlobalImpFiles(const void* IPDF){return 0;}
SI32   PDF_CALL pdfGetUserRights(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseStdFonts(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseSystemFonts(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseTransparency(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetUseVisibleCoords(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfGetViewerPrefrences(const void* IPDF, SI32 ADDR Preference, SI32 ADDR AddVal){return 0;}
LBOOL  PDF_CALL pdfGetWMFDefExtent(const void* IPDF, UI32 ADDR Width, UI32 ADDR Height){return 0;}
SI32   PDF_CALL pdfGetWMFPixelPerInch(const void* IPDF){return 0;}
double PDF_CALL pdfGetWordSpacing(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfHaveOpenDoc(const void* IPDF){return 0;}
SI32   PDF_CALL pdfHighlightAnnotA(const void* IPDF, TAnnotType SubType, double PosX, double PosY, double Width, double Height, UI32 Color, const char* Author, const char* Subject, const char* Comment){return 0;}
SI32   PDF_CALL pdfHighlightAnnotW(const void* IPDF, TAnnotType SubType, double PosX, double PosY, double Width, double Height, UI32 Color, const UI16* Author, const UI16* Subject, const UI16* Comment){return 0;}
SI32   PDF_CALL pdfImportBookmarks(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfImportCatalogObjects(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfImportDocInfo(const void* IPDF){return 0;}
SI32   PDF_CALL pdfImportPage(const void* IPDF, UI32 PageNum){return 0;}
SI32   PDF_CALL pdfImportPageEx(const void* IPDF, UI32 PageNum, double ScaleX, double ScaleY){return 0;}
SI32   PDF_CALL pdfImportPDFFile(const void* IPDF, UI32 DestPage, double ScaleX, double ScaleY){return 0;}
LBOOL  PDF_CALL pdfInitExtGState(struct TPDFExtGState* GS){return 0;}
LBOOL  PDF_CALL pdfInitStack(const void* IPDF, struct TPDFStack* Stack){return 0;}
SI32   PDF_CALL pdfInsertBMPFromBuffer(const void* IPDF, double PosX, double PosY, double ScaleWidth, double ScaleHeight, const void* Buffer){return 0;}
SI32   PDF_CALL pdfInsertBMPFromHandle(const void* IPDF, double PosX, double PosY, double ScaleWidth, double ScaleHeight, void* hBitmap){return 0;}
SI32   PDF_CALL pdfInsertImage(const void* IPDF, double PosX, double PosY, double ScaleWidth, double ScaleHeight, const char* AFile){return 0;}
SI32   PDF_CALL pdfInsertImageEx(const void* IPDF, double PosX, double PosY, double ScaleWidth, double ScaleHeight, const char* AFile, UI32 Index){return 0;}
SI32   PDF_CALL pdfInsertImageFromBuffer(const void* IPDF, double PosX, double PosY, double ScaleWidth, double ScaleHeight, const void* Buffer, UI32 BufSize, UI32 Index){return 0;}
LBOOL  PDF_CALL pdfInsertMetafile(const void* IPDF, const char* FileName, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfInsertMetafileEx(const void* IPDF, const void* Buffer, UI32 BufSize, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfInsertMetafileExt(const void* IPDF, const char* FileName, struct TRectL* View, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfInsertMetafileExtEx(const void* IPDF, const void* Buffer, UI32 BufSize, struct TRectL* View, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfInsertMetafileFromHandle(const void* IPDF, const void* hEnhMetafile, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfInsertMetafileFromHandleEx(const void* IPDF, const void* hEnhMetafile, struct TRectL* View, double PosX, double PosY, double Width, double Height){return 0;}
SI32   PDF_CALL pdfInsertRawImage(const void* IPDF, const void* Buffer, UI32 BitsPerPixel, UI32 ColorCount, UI32 ImgWidth, UI32 ImgHeight, double PosX, double PosY, double ScaleWidth, double ScaleHeight){return 0;}
SI32   PDF_CALL pdfIsBidiText(const void* IPDF, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfIsColorPage(const void* IPDF, LBOOL GrayIsColor){return 0;}
LBOOL  PDF_CALL pdfIsEmptyPage(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfLineTo(const void* IPDF, double PosX, double PosY){return 0;}
SI32   PDF_CALL pdfLoadCMap(const void* IPDF, const char* CMapName, LBOOL Embed){return 0;}
LBOOL  PDF_CALL pdfLoadFDFDataA(const void* IPDF, const char* FileName, const char* Password, UI32 Flags){return 0;}
LBOOL  PDF_CALL pdfLoadFDFDataW(const void* IPDF, const UI16* FileName, const char* Password, UI32 Flags){return 0;}
LBOOL  PDF_CALL pdfLoadFDFDataEx(const void* IPDF, const void* Buffer, UI32 BufSize, const char* Password, UI32 Flags){return 0;}
SI32   PDF_CALL pdfLoadFont(const void* IPDF, const void* Buffer, UI32 BufSize, TFStyle Style, double Size, LBOOL Embed, TCodepage CP){return 0;}
LBOOL  PDF_CALL pdfMovePage(const void* IPDF, UI32 Source, UI32 Dest){return 0;}
LBOOL  PDF_CALL pdfMoveTo(const void* IPDF, double PosX, double PosY){return 0;}
SI32   PDF_CALL pdfMultiplyMatrix(struct TCTM* M1, struct TCTM* M2, struct TCTM* NewMatrix){return 0;}
void*  PDF_CALL pdfNewPDF(void){return 0;}
SI32   PDF_CALL pdfOpenImportBuffer(const void* IPDF, const void* Buffer, UI32 BufSize, TPwdType PwdType, const char* Password){return 0;}
SI32   PDF_CALL pdfOpenImportFileA(const void* IPDF, const char* FileName, TPwdType PwdType, const char* Password){return 0;}
SI32   PDF_CALL pdfOpenImportFileW(const void* IPDF, const UI16* FileName, TPwdType PwdType, const char* Password){return 0;}
LBOOL  PDF_CALL pdfOpenOutputFileA(const void* IPDF, const char* OutPDF){return 0;}
LBOOL  PDF_CALL pdfOpenOutputFileW(const void* IPDF, const UI16* OutPDF){return 0;}
LBOOL  PDF_CALL pdfOpenTagA(const void* IPDF, TPDFBaseTag Tag, const char* Lang, const char* AltText, const char* Expansion){return 0;}
LBOOL  PDF_CALL pdfOpenTagW(const void* IPDF, TPDFBaseTag Tag, const char* Lang, const UI16* AltText, const UI16* Expansion){return 0;}
SI32   PDF_CALL pdfPageLink(const void* IPDF, double PosX, double PosY, double Width, double Height, UI32 DestPage){return 0;}
SI32   PDF_CALL pdfPageLink2(const void* IPDF, double PosX, double PosY, double Width, double Height, UI32 NamedDest){return 0;}
SI32   PDF_CALL pdfPageLinkEx(const void* IPDF, double PosX, double PosY, double Width, double Height, TDestType DestType, UI32 DestPage, double a, double b, double c, double d){return 0;}
LBOOL  PDF_CALL pdfParseContent(const void* IPDF, const void* Data, struct TPDFParseInterface* Stack, TParseFlags Flags){return 0;}
LBOOL  PDF_CALL pdfPlaceImage(const void* IPDF, SI32 ImgHandle, double PosX, double PosY, double ScaleWidth, double ScaleHeight){return 0;}
LBOOL  PDF_CALL pdfPlaceSigFieldValidateIcon(const void* IPDF, UI32 SigField, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfPlaceTemplate(const void* IPDF, SI32 TmplHandle, double PosX, double PosY, double ScaleWidth, double ScaleHeight){return 0;}
LBOOL  PDF_CALL pdfPlaceTemplateEx(const void* IPDF, SI32 TmplHandle, double PosX, double PosY, double ScaleWidth, double ScaleHeight){return 0;}
LBOOL  PDF_CALL pdfPlaceTemplByMatrix(const void* IPDF, SI32 TmplHandle){return 0;}
LBOOL  PDF_CALL pdfReadImageFormat(const void* IPDF, const char* FileName, UI32 ADDR Width, UI32 ADDR Height, SI32 ADDR BitsPerPixel, SI32 ADDR UseZip){return 0;}
LBOOL  PDF_CALL pdfReadImageFormat2(const void* IPDF, const char* FileName, UI32 Index, UI32 ADDR Width, UI32 ADDR Height, SI32 ADDR BitsPerPixel, SI32 ADDR UseZip){return 0;}
LBOOL  PDF_CALL pdfReadImageFormatEx(const void* IPDF, void* hBitmap, UI32 ADDR Width, UI32 ADDR Height, SI32 ADDR BitsPerPixel, SI32 ADDR UseZip){return 0;}
LBOOL  PDF_CALL pdfReadImageFormatFromBuffer(const void* IPDF, const void* Buffer, UI32 BufSize, UI32 Index, UI32 ADDR Width, UI32 ADDR Height, SI32 ADDR BitsPerPixel, SI32 ADDR UseZip){return 0;}
LBOOL  PDF_CALL pdfReadImageResolution(const void* IPDF, const char* FileName, UI32 Index, UI32 ADDR ResX, UI32 ADDR ResY){return 0;}
LBOOL  PDF_CALL pdfReadImageResolutionEx(const void* IPDF, const void* Buffer, UI32 BufSize, UI32 Index, UI32 ADDR ResX, UI32 ADDR ResY){return 0;}
LBOOL  PDF_CALL pdfRectangle(const void* IPDF, double PosX, double PosY, double Width, double Height, TPathFillMode FillMode){return 0;}
SI32   PDF_CALL pdfReEncryptPDFA(const void* IPDF, const char* FileName, TPwdType PwdType, const char* InPwd, const char* NewOpenPwd, const char* NewOwnerPwd, TKeyLen NewKeyLen, TRestrictions Restrict){return 0;}
SI32   PDF_CALL pdfReEncryptPDFW(const void* IPDF, const UI16* FileName, TPwdType PwdType, const char* InPwd, const char* NewOpenPwd, const char* NewOwnerPwd, TKeyLen NewKeyLen, TRestrictions Restrict){return 0;}
SI32   PDF_CALL pdfRenameSpotColor(const void* IPDF, const char* Colorant, const char* NewName){return 0;}
SI32   PDF_CALL pdfReplaceFontA(const void* IPDF, const void* PDFFont, const char* Name, TFStyle Style, LBOOL NameIsFamilyName){return 0;}
SI32   PDF_CALL pdfReplaceFontW(const void* IPDF, const void* PDFFont, const UI16* Name, TFStyle Style, LBOOL NameIsFamilyName){return 0;}
SI32   PDF_CALL pdfReplaceFontExA(const void* IPDF, const void* PDFFont, const char* FontFile, LBOOL Embed){return 0;}
SI32   PDF_CALL pdfReplaceFontExW(const void* IPDF, const void* PDFFont, const UI16* FontFile, LBOOL Embed){return 0;}
SI32   PDF_CALL pdfReplaceICCProfileA(const void* IPDF, UI32 ColorSpace, const char* ICCFile){return 0;}
SI32   PDF_CALL pdfReplaceICCProfileW(const void* IPDF, UI32 ColorSpace, const UI16* ICCFile){return 0;}
LBOOL  PDF_CALL pdfReplacePageTextA(const void* IPDF, const char* NewText, struct TPDFStack* Stack){return 0;}
LBOOL  PDF_CALL pdfReplacePageTextExA(const void* IPDF, const char* NewText, struct TPDFStack* Stack){return 0;}
LBOOL  PDF_CALL pdfReplacePageTextExW(const void* IPDF, const UI16* NewText, struct TPDFStack* Stack){return 0;}
LBOOL  PDF_CALL pdfResetLineDashPattern(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfRestoreGraphicState(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfRotateCoords(const void* IPDF, double alpha, double OriginX, double OriginY){return 0;}
LBOOL  PDF_CALL pdfRoundRect(const void* IPDF, double PosX, double PosY, double Width, double Height, double Radius, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfRoundRectEx(const void* IPDF, double PosX, double PosY, double Width, double Height, double rWidth, double rHeight, TPathFillMode FillMode){return 0;}
LBOOL  PDF_CALL pdfSaveGraphicState(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfScaleCoords(const void* IPDF, double sx, double sy){return 0;}
LBOOL  PDF_CALL pdfSelfTest(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfSet3DAnnotProps(const void* IPDF, UI32 Annot, T3DActivationType ActType, T3DDeActivateType DeActType, T3DInstanceType InstType, T3DDeActInstance DeInstType, LBOOL DisplToolbar, LBOOL DisplModelTree){return 0;}
LBOOL  PDF_CALL pdfSet3DAnnotScriptA(const void* IPDF, UI32 Annot, const char* Value, UI32 Len){return 0;}
SI32   PDF_CALL pdfSetAllocBy(const void* IPDF, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetAnnotBorderStyle(const void* IPDF, UI32 Handle, TBorderStyle Style){return 0;}
LBOOL  PDF_CALL pdfSetAnnotBorderWidth(const void* IPDF, UI32 Handle, double LineWidth){return 0;}
LBOOL  PDF_CALL pdfSetAnnotColor(const void* IPDF, UI32 Handle, TAnnotColor ColorType, TPDFColorSpace CS, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetAnnotFlags(const void* IPDF, TAnnotFlags Flags){return 0;}
LBOOL  PDF_CALL pdfSetAnnotFlagsEx(const void* IPDF, UI32 Handle, SI32 Flags){return 0;}
LBOOL  PDF_CALL pdfSetAnnotHighlightMode(const void* IPDF, UI32 Handle, THighlightMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetAnnotIcon(const void* IPDF, UI32 Handle, TAnnotIcon Icon){return 0;}
LBOOL  PDF_CALL pdfSetAnnotOpenState(const void* IPDF, UI32 Handle, LBOOL Open){return 0;}
LBOOL  PDF_CALL pdfSetAnnotStringA(const void* IPDF, UI32 Handle, TAnnotString StringType, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetAnnotStringW(const void* IPDF, UI32 Handle, TAnnotString StringType, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetAnnotSubjectA(const void* IPDF, UI32 Handle, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetAnnotSubjectW(const void* IPDF, UI32 Handle, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetBBox(const void* IPDF, TPageBoundary Boundary, double LeftX, double LeftY, double RightX, double RightY){return 0;}
LBOOL  PDF_CALL pdfSetBidiMode(const void* IPDF, TPDFBidiMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetBookmarkDest(const void* IPDF, SI32 ABmk, TDestType DestType, double a, double b, double c, double d){return 0;}
LBOOL  PDF_CALL pdfSetBookmarkStyle(const void* IPDF, SI32 ABmk, TFStyle Style, UI32 RGBColor){return 0;}
LBOOL  PDF_CALL pdfSetBorderStyle(const void* IPDF, TBorderStyle Style){return 0;}
LBOOL  PDF_CALL pdfSetCharacterSpacing(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetCheckBoxChar(const void* IPDF, TCheckBoxChar CheckBoxChar){return 0;}
LBOOL  PDF_CALL pdfSetCheckBoxDefState(const void* IPDF, UI32 AField, LBOOL Checked){return 0;}
LBOOL  PDF_CALL pdfSetCheckBoxState(const void* IPDF, UI32 AField, LBOOL Checked){return 0;}
SI32   PDF_CALL pdfSetCIDFontA(const void* IPDF, UI32 CMapHandle, const char* Name, TFStyle Style, double Size, LBOOL Embed){return 0;}
SI32   PDF_CALL pdfSetCIDFontW(const void* IPDF, UI32 CMapHandle, const UI16* Name, TFStyle Style, double Size, LBOOL Embed){return 0;}
SI32   PDF_CALL pdfSetCMapDirA(const void* IPDF, const char* Path, LBOOL Recursive){return 0;}
SI32   PDF_CALL pdfSetCMapDirW(const void* IPDF, const UI16* Path, LBOOL Recursive){return 0;}
LBOOL  PDF_CALL pdfSetColDefFile(const void* IPDF, UI32 EmbFile){return 0;}
LBOOL  PDF_CALL pdfSetColors(const void* IPDF, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetColorSpace(const void* IPDF, TPDFColorSpace ColorSpace){return 0;}
LBOOL  PDF_CALL pdfSetColSortField(const void* IPDF, UI32 ColField, LBOOL AscendingOrder){return 0;}
LBOOL  PDF_CALL pdfSetCompressionFilter(const void* IPDF, TCompressionFilter Filter){return 0;}
LBOOL  PDF_CALL pdfSetCompressionLevel(const void* IPDF, TCompressionLevel CompressLevel){return 0;}
LBOOL  PDF_CALL pdfSetContent(const void* IPDF, const char* Buffer, UI32 BufSize){return 0;}
LBOOL  PDF_CALL pdfSetDateTimeFormat(const void* IPDF, UI32 TxtField, TPDFDateTime Fmt){return 0;}
LBOOL  PDF_CALL pdfSetDefBitsPerPixel(const void* IPDF, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetDocInfoA(const void* IPDF, TDocumentInfo DInfo, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetDocInfoW(const void* IPDF, TDocumentInfo DInfo, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetDocInfoExA(const void* IPDF, TDocumentInfo DInfo, const char* Key, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetDocInfoExW(const void* IPDF, TDocumentInfo DInfo, const char* Key, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetDrawDirection(const void* IPDF, TDrawDirection Direction){return 0;}
LBOOL  PDF_CALL pdfSetEMFFrameDPI(const void* IPDF, UI32 DPIX, UI32 DPIY){return 0;}
LBOOL  PDF_CALL pdfSetEMFPatternDistance(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetErrorMode(const void* IPDF, TErrMode ErrMode){return 0;}
LBOOL  PDF_CALL pdfSetExtColorSpace(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfSetExtGState(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfSetFieldBackColor(const void* IPDF, UI32 AColor){return 0;}
LBOOL  PDF_CALL pdfSetFieldBBox(const void* IPDF, UI32 AField, struct TPDFRect* BBox){return 0;}
LBOOL  PDF_CALL pdfSetFieldBorderColor(const void* IPDF, UI32 AColor){return 0;}
LBOOL  PDF_CALL pdfSetFieldBorderWidth(const void* IPDF, UI32 AField, double LineWidth){return 0;}
LBOOL  PDF_CALL pdfSetFieldColor(const void* IPDF, UI32 AField, TFieldColor ColorType, TPDFColorSpace CS, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetFieldBorderStyle(const void* IPDF, UI32 AField, TBorderStyle Style){return 0;}
LBOOL  PDF_CALL pdfSetFieldExpValue(const void* IPDF, UI32 AField, UI32 ValIndex, const char* Value, const char* ExpValue, LBOOL Selected){return 0;}
LBOOL  PDF_CALL pdfSetFieldFlags(const void* IPDF, UI32 AField, TFieldFlags Flags, LBOOL Reset){return 0;}
LBOOL  PDF_CALL pdfSetFieldFontSize(const void* IPDF, UI32 AField, double FontSize){return 0;}
LBOOL  PDF_CALL pdfSetFieldHighlightMode(const void* IPDF, UI32 AField, THighlightMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetFieldIndex(const void* IPDF, UI32 AField, UI32 Index){return 0;}
LBOOL  PDF_CALL pdfSetFieldMapNameA(const void* IPDF, UI32 AField, const char* Name){return 0;}
LBOOL  PDF_CALL pdfSetFieldMapNameW(const void* IPDF, UI32 AField, const UI16* Name){return 0;}
LBOOL  PDF_CALL pdfSetFieldName(const void* IPDF, UI32 AField, const char* NewName){return 0;}
LBOOL  PDF_CALL pdfSetFieldOrientation(const void* IPDF, UI32 AField, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetFieldTextAlign(const void* IPDF, UI32 AField, TTextAlign Align){return 0;}
LBOOL  PDF_CALL pdfSetFieldTextColor(const void* IPDF, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetFieldToolTipA(const void* IPDF, UI32 AField, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetFieldToolTipW(const void* IPDF, UI32 AField, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetFillColor(const void* IPDF, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetFillColorEx(const void* IPDF, const BYTE* Color, UI32 NumComponents){return 0;}
LBOOL  PDF_CALL pdfSetFillColorSpace(const void* IPDF, TPDFColorSpace CS){return 0;}
SI32   PDF_CALL pdfSetFontA(const void* IPDF, const char* Name, TFStyle Style, double Size, LBOOL Embed, TCodepage CP){return 0;}
SI32   PDF_CALL pdfSetFontW(const void* IPDF, const UI16* Name, TFStyle Style, double Size, LBOOL Embed, TCodepage CP){return 0;}
SI32   PDF_CALL pdfSetFontExA(const void* IPDF, const char* Name, TFStyle Style, double Size, LBOOL Embed, TCodepage CP){return 0;}
SI32   PDF_CALL pdfSetFontExW(const void* IPDF, const UI16* Name, TFStyle Style, double Size, LBOOL Embed, TCodepage CP){return 0;}
LBOOL  PDF_CALL pdfSetFontOrigin(const void* IPDF, TOrigin Origin){return 0;}
void   PDF_CALL pdfSetFontSearchOrder(const void* IPDF, TFontBaseType Order[4]){return;}
LBOOL  PDF_CALL pdfSetFontSelMode(const void* IPDF, TFontSelMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetFontWeight(const void* IPDF, SI32 Weight){return 0;}
void   PDF_CALL pdfSetGStateFlags(const void* IPDF, TGStateFlags Flags, LBOOL Reset){}
LBOOL  PDF_CALL pdfSetIconColor(const void* IPDF, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetImportFlags(const void* IPDF, TImportFlags Flags){return 0;}
LBOOL  PDF_CALL pdfSetImportFlags2(const void* IPDF, TImportFlags2 Flags){return 0;}
LBOOL  PDF_CALL pdfSetItalicAngle(const void* IPDF, double Angle){return 0;}
LBOOL  PDF_CALL pdfSetJPEGQuality(const void* IPDF, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetLanguage(const void* IPDF, const char* ISOTag){return 0;}
LBOOL  PDF_CALL pdfSetLeading(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetLicenseKey(const void* IPDF, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetLineCapStyle(const void* IPDF, TLineCapStyle Style){return 0;}
LBOOL  PDF_CALL pdfSetLineDashPattern(const void* IPDF, const char* Dash, SI32 Phase){return 0;}
LBOOL  PDF_CALL pdfSetLineDashPatternEx(const void* IPDF, const double* Dash, UI32 NumValues, SI32 Phase){return 0;}
LBOOL  PDF_CALL pdfSetLineJoinStyle(const void* IPDF, TLineJoinStyle Style){return 0;}
LBOOL  PDF_CALL pdfSetLineWidth(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetLinkHighlightMode(const void* IPDF, THighlightMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetListFont(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfSetMatrix(const void* IPDF, struct TCTM* Matrix){return 0;}
LBOOL  PDF_CALL pdfSetMaxFieldLen(const void* IPDF, UI32 TxtField, SI32 MaxLen){return 0;}
LBOOL  PDF_CALL pdfSetMetaConvFlags(const void* IPDF, TMetaFlags Flags){return 0;}
LBOOL  PDF_CALL pdfSetMiterLimit(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetNeedAppearance(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetNumberFormat(const void* IPDF, UI32 TxtField, TDecSeparator Sep, UI32 DecPlaces, TNegativeStyle NegStyle, const char* CurrStr, LBOOL Prepend){return 0;}
LBOOL  PDF_CALL pdfSetOnErrorProc(const void* IPDF, const void* Data, const void* ErrProc){return 0;}
LBOOL  PDF_CALL pdfSetOnPageBreakProc(const void* IPDF, const void* Data, const void* OnBreakProc){return 0;}
LBOOL  PDF_CALL pdfSetOpacity(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetOrientation(const void* IPDF, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetOrientationEx(const void* IPDF, SI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetPageCoords(const void* IPDF, TPageCoord PageCoords){return 0;}
LBOOL  PDF_CALL pdfSetPageFormat(const void* IPDF, TPageFormat Value){return 0;}
LBOOL  PDF_CALL pdfSetPageHeight(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetPageLayout(const void* IPDF, TPageLayout Layout){return 0;}
LBOOL  PDF_CALL pdfSetPageMode(const void* IPDF, TPageMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetPageWidth(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetPDFVersion(const void* IPDF, TPDFVersion Version){return 0;}
LBOOL  PDF_CALL pdfSetPrintSettings(const void* IPDF, TDuplexMode Mode, SI32 PickTrayByPDFSize, UI32 NumCopies, TPrintScaling PrintScaling, UI32* PrintRanges, UI32 NumRanges){return 0;}
LBOOL  PDF_CALL pdfSetProgressProc(const void* IPDF, const void* Data, const void* InitProgress, const void* Progress){return 0;}
LBOOL  PDF_CALL pdfSetResolution(const void* IPDF, UI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetSaveNewImageFormat(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetSeparationInfo(const void* IPDF, UI32 Handle){return 0;}
LBOOL  PDF_CALL pdfSetStrokeColor(const void* IPDF, UI32 Color){return 0;}
LBOOL  PDF_CALL pdfSetStrokeColorEx(const void* IPDF, const BYTE* Color, UI32 NumComponents){return 0;}
LBOOL  PDF_CALL pdfSetStrokeColorSpace(const void* IPDF, TPDFColorSpace CS){return 0;}
LBOOL  PDF_CALL pdfSetTabLen(const void* IPDF, SI32 TabLen){return 0;}
LBOOL  PDF_CALL pdfSetTextDrawMode(const void* IPDF, TDrawMode Mode){return 0;}
LBOOL  PDF_CALL pdfSetTextFieldValueA(const void* IPDF, UI32 Field, const char* Value, const char* DefValue, TTextAlign Align){return 0;}
LBOOL  PDF_CALL pdfSetTextFieldValueW(const void* IPDF, UI32 Field, const UI16* Value, const UI16* DefValue, TTextAlign Align){return 0;}
LBOOL  PDF_CALL pdfSetTextFieldValueExA(const void* IPDF, UI32 Field, const char* Value){return 0;}
LBOOL  PDF_CALL pdfSetTextFieldValueExW(const void* IPDF, UI32 Field, const UI16* Value){return 0;}
LBOOL  PDF_CALL pdfSetTextRect(const void* IPDF, double PosX, double PosY, double Width, double Height){return 0;}
LBOOL  PDF_CALL pdfSetTextRise(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetTextScaling(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSetTransparentColor(const void* IPDF, UI32 AColor){return 0;}
void   PDF_CALL pdfSetTrapped(const void* IPDF, LBOOL Value){}
LBOOL  PDF_CALL pdfSetUseExactPwd(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetUseGlobalImpFiles(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetUseStdFonts(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetUseSwapFile(const void* IPDF, LBOOL SwapContents, UI32 SwapLimit){return 0;}
LBOOL  PDF_CALL pdfSetUseSwapFileEx(const void* IPDF, LBOOL SwapContents, UI32 SwapLimit, const char* SwapDir){return 0;}
LBOOL  PDF_CALL pdfSetUseSystemFonts(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetUseTransparency(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetUseVisibleCoords(const void* IPDF, LBOOL Value){return 0;}
LBOOL  PDF_CALL pdfSetViewerPreferences(const void* IPDF, TViewerPreference Value, TViewPrefAddVal AddVal){return 0;}
LBOOL  PDF_CALL pdfSetWMFDefExtent(const void* IPDF, UI32 Width, UI32 Height){return 0;}
LBOOL  PDF_CALL pdfSetWMFPixelPerInch(const void* IPDF, UI32 Value){return 0;}
LBOOL  PDF_CALL pdfSetWordSpacing(const void* IPDF, double Value){return 0;}
LBOOL  PDF_CALL pdfSkewCoords(const void* IPDF, double alpha, double beta, double OriginX, double OriginY){return 0;}
LBOOL  PDF_CALL pdfSortFieldsByIndex(const void* IPDF){return 0;}
LBOOL  PDF_CALL pdfSortFieldsByName(const void* IPDF){return 0;}
SI32   PDF_CALL pdfStrLenA(const char* AStr){return 0;}
SI32   PDF_CALL pdfStrLenW(const UI16* AStr){return 0;}
LBOOL  PDF_CALL pdfStrokePath(const void* IPDF){return 0;}
SI32   PDF_CALL pdfStampAnnotA(const void* IPDF, TRubberStamp SubType, double PosX, double PosY, double Width, double Height, const char* Author, const char* Subject, const char* Comment){return 0;}
SI32   PDF_CALL pdfStampAnnotW(const void* IPDF, TRubberStamp SubType, double PosX, double PosY, double Width, double Height, const UI16* Author, const UI16* Subject, const UI16* Comment){return 0;}
SI32   PDF_CALL pdfTextAnnotA(const void* IPDF, double PosX, double PosY, double Width, double Height, const char* Author, const char* Text, TAnnotIcon Icon, LBOOL Open){return 0;}
SI32   PDF_CALL pdfTextAnnotW(const void* IPDF, double PosX, double PosY, double Width, double Height, const UI16* Author, const UI16* Text, TAnnotIcon Icon, LBOOL Open){return 0;}
LBOOL  PDF_CALL pdfTranslateCoords(const void* IPDF, double OriginX, double OriginY){return 0;}
LBOOL  PDF_CALL pdfTriangle(const void* IPDF, double x1, double y1, double x2, double y2, double x3, double y3, TPathFillMode FillMode){return 0;}
UI32*  PDF_CALL pdfUTF16ToUTF32(const void* IPDF, const UI16* Source){return 0;}
UI32*  PDF_CALL pdfUTF16ToUTF32Ex(const void* IPDF, const UI16* Source, UI32 ADDR Len){return 0;}
UI16*  PDF_CALL pdfUTF32ToUTF16(const void* IPDF, const UI32* Source){return 0;}
UI16*  PDF_CALL pdfUTF32ToUTF16Ex(const void* IPDF, const UI32* Source, UI32 ADDR Len){return 0;}
SI32   PDF_CALL pdfWebLinkA(const void* IPDF, double PosX, double PosY, double Width, double Height, const char* URL){return 0;}
SI32   PDF_CALL pdfWebLinkW(const void* IPDF, double PosX, double PosY, double Width, double Height, const UI16* URL){return 0;}
LBOOL  PDF_CALL pdfWriteAngleTextA(const void* IPDF, const char* AText, double Angle, double PosX, double PosY, double Radius, double YOrigin){return 0;}
LBOOL  PDF_CALL pdfWriteAngleTextW(const void* IPDF, const UI16* AText, double Angle, double PosX, double PosY, double Radius, double YOrigin){return 0;}
LBOOL  PDF_CALL pdfWriteFTextA(const void* IPDF, TTextAlign Align, const char* AText){return 0;}
LBOOL  PDF_CALL pdfWriteFTextW(const void* IPDF, TTextAlign Align, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfWriteFTextExA(const void* IPDF, double PosX, double PosY, double Width, double Height, TTextAlign Align, const char* AText){return 0;}
LBOOL  PDF_CALL pdfWriteFTextExW(const void* IPDF, double PosX, double PosY, double Width, double Height, TTextAlign Align, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfWriteTextA(const void* IPDF, double PosX, double PosY, const char* AText){return 0;}
LBOOL  PDF_CALL pdfWriteTextW(const void* IPDF, double PosX, double PosY, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfWriteTextExA(const void* IPDF, double PosX, double PosY, const char* AText, UI32 Len){return 0;}
LBOOL  PDF_CALL pdfWriteTextExW(const void* IPDF, double PosX, double PosY, const UI16* AText, UI32 Len){return 0;}
LBOOL  PDF_CALL pdfWriteTextMatrixA(const void* IPDF, struct TCTM* M, const char* AText){return 0;}
LBOOL  PDF_CALL pdfWriteTextMatrixW(const void* IPDF, struct TCTM* M, const UI16* AText){return 0;}
LBOOL  PDF_CALL pdfWriteTextMatrixExA(const void* IPDF, struct TCTM* M, const char* AText, UI32 Len){return 0;}
LBOOL  PDF_CALL pdfWriteTextMatrixExW(const void* IPDF, struct TCTM* M, const UI16* AText, UI32 Len){return 0;}

#endif
