VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPDF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Wrapper class for DynaPDF 2.0"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'----------------------------------------------------------+
' DynaPDF 2.0                                              |
'----------------------------------------------------------+
' Copyright (C) 2003-2010                                  |
' Jens Boschulte, DynaForms GmbH.                          |
' All rights reserved.                                     |
'----------------------------------------------------------+
' Please report errors or other potential problems to      |
' support@dynaforms.com.                                   |
' The actual version is available at www.dynaforms.com.    |
'----------------------------------------------------------+
'             Creation date: December 04, 2010             |
'----------------------------------------------------------+

Implements IPDFCallBack
' Event procedures
Public Event EnumDocFont(ByVal PDFFont As Long, ByVal FontType As TFontType, ByVal BaseFont As String, ByVal FontName As String, ByVal Embedded As Boolean, ByVal IsFormFont As Boolean, ByVal Flags As Long, DoBreak As Boolean)
Public Event EnumFont(ByVal FamilyName As String, PostScriptName As String, ByVal Style As Long, DoBreak As Boolean)
Public Event EnumFontEx(ByVal FamilyName As String, ByVal PostScriptName As String, ByVal Style As Long, ByVal BaseType As TFontBaseType, ByVal Embeddable As Boolean, ByVal FilePath As String, DoBreak As Boolean)
Public Event Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
Public Event InitProgress(ByVal ProgType As Long, ByVal MaxCount As Long)
' The page break event is not connected when creating an instance of the wrapper class.
' If you want to use this event call the procedure ConnectPageBreakEvent().
Public Event PageBreak(ByVal LastPosX As Double, ByVal LastPosY As Double, ByVal PageBreak As Long, NewAlign As TNewAlign, DoBreak As Boolean)
Public Event Progress(ByVal ActivePage As Long, DoBreak As Boolean)

Enum TErrMode
   emIgnoreAll = 0
   emSyntaxError = 1
   emValueError = 2
   emWarning = 4
   emFileError = 8
   emFontError = 16
   emAllErrors = 65535
   emNoFuncNames = &H10000000 ' Do not print function names in error messages
End Enum

Const PDF_MAX_INT = &H7FFFFFFF

' ------------------------------------------------- Default types -----------------------------------------------

Enum T3DActivationType
   at3D_AppDefault
   at3D_PageOpen    ' The annotaiton should be activated when the page is opened.
   at3D_PageVisible ' The annotaiton should be activated when the page becomes visible.
   at3D_Explicit    ' The annotation should remain inactive until explicitely activated by a script or action (default).
End Enum

Enum T3DDeActivateType
   dt3D_AppDefault
   dt3D_PageClosed    ' The annotaiton should be deactivated as soon as the page is closed.
   dt3D_PageInvisible ' The annotaiton should be deactivated as soon as the page becomes invisible (default).
   dt3D_Explicit      ' The annotation should remain active until explicitely deactivated by a script or action.
End Enum

Enum T3DDeActInstance
   di3D_AppDefault
   di3D_UnInstantiated ' The annotation will be uninstantiated (default)
   di3D_Instantiated   ' The annotation is left instantiated
   di3D_Live           ' If the 3D artwork contains an animation then it will stay live
End Enum

Enum T3DInstanceType
   it3D_AppDefault
   it3D_Instantiated ' The annotation will be instantiated but animations are disabled.
   it3D_Live         ' The annotation will be instantiated and animations are enabled (default).
End Enum

Enum T3DLightingSheme
   lsArtwork
   lsBlue
   lsCAD
   lsCube
   lsDay
   lsHard
   lsHeadlamp
   lsNight
   lsNoLights
   lsPrimary
   lsRed
   lsWhite
   lsNotSet
End Enum

Enum T3DNamedAction
   naDefault
   naFirst
   naLast
   naNext
   naPrevious
End Enum

Enum T3DProjType
   pt3DOrthographic
   pt3DPerspective
End Enum

Enum T3DRenderingMode
   rmBoundingBox
   rmHiddenWireframe
   rmIllustration
   rmShadedIllustration
   rmShadedVertices
   rmShadedWireframe
   rmSolid
   rmSolidOutline
   rmSolidWireframe
   rmTransparent
   rmTranspBBox
   rmTranspBBoxOutline
   rmTranspWireframe
   rmVertices
   rmWireframe
   rmNotSet
End Enum

Enum T3DScaleType
   st3DValue
   st3DWidth
   st3DHeight
   st3DMin
   st3DMax
End Enum

Enum TAnnotColor
   acBackColor
   acBorderColor
   acTextColor
End Enum

Enum TActionType
   atGoTo
   atGoToR
   atHide
   atImportData
   atJavaScript
   atLaunch
   atMovie
   atNamed
   atRendition
   atReset
   atSetOCGState
   atSound
   atSubmit
   atThread
   atTransition
   atURI
   atGoTo3DView
End Enum

Enum TAnnotFlags
   afNone = &H0
   afInvisible = &H1
   afHidden = &H2
   afPrint = &H4
   afNoZoom = &H8
   afNoRotate = &H10
   afNoView = &H20
   afReadOnly = &H40
End Enum

'By default all annotations which have an appearance stream and which have the print flag set are flattened.
'All annotations are deleted when the function returns with the exception of file attachment annotations.
'If you want to flatten the view state then set the flag affUseViewState.
Enum TAnnotFlattenFlags
   affNone = &H0       ' Printable annotations independent of the type
   affUseViewState = &H1        ' If set, annotations which are visible in a viewer become flattened.
   affMarkupAnnots = &H2        ' If set, markup annotations are flattened only. Link, Sound, or FileAttach
                                ' annotations are no markup annotations. These types will be left intact.
End Enum

Enum TAnnotString
   asAuthor
   asContent
   asName
   asSubject
End Enum

Enum TButtonState
   bsUp
   bsDown
   bsRollOver
End Enum

Enum TCheckBoxChar
   ccCheck
   ccCircle
   ccCross1
   ccCross2
   ccCross3
   ccCross4
   ccDiamond
   ccSquare
   ccStar
End Enum

Enum TCheckOptions
   coDefault = &HFFF
   coEmbedSubsets = &H1
   coDeleteTransferFuncs = &H2
   coDeleteMultiMediaContents = &H4
   coDeleteActionsAndScripts = &H8
   coDeleteInvRenderingIntent = &H10
   coFlattenFormFields = &H20
   coReplaceV4ICCProfiles = &H40
   coDeleteEmbeddedFiles = &H80
   coDeleteOPIComments = &H100
   coDeleteSignatures = &H200
   coReplCCITTFaxWithFlate = &H10000
   coNoFontEmbedding = &H10000000
End Enum

Enum TClippingMode
  cmEvenOdd
  cmWinding
End Enum

Enum TCodepage
   cp1250
   cp1251
   cp1252
   cp1253
   cp1254
   cp1255
   cp1256
   cp1257
   cp1258
   cp8859_2
   cp8859_3
   cp8859_4
   cp8859_5
   cp8859_6
   cp8859_7
   cp8859_8
   cp8859_9
   cp8859_10
   cp8859_13
   cp8859_14
   cp8859_15
   cp8859_16
   cpSymbol
   cp437
   cp737
   cp775
   cp850
   cp852
   cp855
   cp857
   cp860
   cp861
   cp862
   cp863
   cp864
   cp865
   cp866
   cp869
   cp874
   cpUnicode
   cpCJK_Big5_Uni    ' Big5 plus HKSCS extension.
   cpCJK_EUC_JP_Uni  ' EUC-JP
   cpCJK_EUC_KR_Uni  ' EUC-KR
   cpCJK_EUC_TW_Uni  ' CNS-11643-1992 (Planes 1-15).
   cpCJK_GBK_Uni     ' GBK is the Microsoft code page 936 (GB2312 EUC-CN plus GBK extension).
   cpCJK_GB12345_Uni ' GB-12345-1990 (Traditional Chinese form of GB-2312).
   cpCJK_HZ_Uni      ' Mixed ASCII / GB-2312 encoding
   cpCJK_2022_CN_Uni ' ISO-2022-CN-EXT (GB-2312 plus ISO-11643 Planes 1-7).
   cpCJK_2022_JP_Uni ' ISO-2022-JP
   cpCJK_2022_KR_Uni ' ISO-2022-KR
   cpCJK_646_CN_Uni  ' ISO-646-CN (GB-1988-80)
   cpCJK_646_JP_Uni  ' ISO-646-JP (JIS_C6220-1969-RO).
   cpCJK_IR_165_Uni  ' ISO-IR-165 (extended version of GB-2312).
   cpCJK_932_Uni     ' Microsoft extended version of SHIFT_JIS.
   cpCJK_949_Uni     ' EUC-KR extended with UHC (Unified Hangul Codes).
   cpCJK_950_Uni     ' Microsoft extended version of Big5.
   cpCJK_JOHAB_Uni   ' JOHAB
   cpShiftJIS        ' ShiftJIS charset plus code page 932 ectension.
   cpBig5            ' Big5 plus HKSCS extension.
   cpGB2312          ' GB2312 charset plus GBK and cp936 extension.
   cpWansung         ' Wansung
   cpJohab           ' JOHAB
   cpMacRoman        ' Mac Roman
   cpAdobeStd        ' This is an encoding for Type1 fonts. It should normally not be used.
   cpInternal        ' Internal -> not usable
   cpGlyphIndexes    ' Can be used with TrueType and OpenType fonts only. DynaPDF creates a reverse mapping so that copy & paste will work.
   cpPDFDocEnc       ' Internal -> not usable. Used for form fonts. This is a superset of the code page 1252 and MacRoman.
   cpExtCMap         ' Internal -> not usable. This code page is set when a font was loaded with an external cmap.
   cpDingbats        ' Internal -> Special encoding for ZapfDingbats
End Enum

' The data for user defined columns is stored in collection items.
Enum TColColumnType
   cisCreationDate ' Data comes from the embedded file
   cisDescription  ' Data comes from the embedded file
   cisFileName     ' Data comes from the embedded file
   cisModDate      ' Data comes from the embedded file
   cisSize         ' Data comes from the embedded file
   cisCustomDate   ' User defined date.
   cisCustomNumber ' User defined nummber.
   cisCustomString ' User defined string.
End Enum

Enum TColorConvFlags
   ccfBW_To_Gray = 0   ' Default, RGB Black and White set with rg or RG inline operators are converted to gray
   ccfRGB_To_Gray = 1  ' If set, inline color operators rg and RG are converted to gray
End Enum

Enum TColorMode
   cmFill
   cmStroke
   cmFillStroke
End Enum

Enum TColView
   civNotSet
   civDetails
   civTile
   civHidden
End Enum

Enum TCompBBoxFlags
   cbfNone = 0
   cbfIgnoreWhiteAreas = 1 ' Ignore white vector graphics or text.
'  Please note that images must be decompressed if one of the following flags are set. Parsing gray or color images
'  is in most cases not useful and you should not parse such images if it is not really required.
   cbfParse1BitImages = 2  ' Find the visible area in 1 bit images. This is the most important case
                           ' since scanned faxes are usually 1 bit images.
   cbfParseGrayImages = 4  ' Find the visible area in gray images.
   cbfParseColorImages = 8 ' Find the visible area in color images. This is usually not required
                           ' and slow downs processing a lot.
   cbfParseAllImages = 14  ' Find the visible area in all images.
End Enum

Enum TCompressionLevel
   clNone
   clDefault
   clFastest
   clMax
End Enum

Enum TCompressionFilter
   cfFlate = 0  ' Flate or Zip compression
   cfJPEG = 1   ' JPEG compression
   cfCCITT3 = 2 ' CCITT Fax G3 compression
   cfCCITT4 = 3 ' CCITT Fax G4 compression
   cfJP2K = 7   ' JPEG2000 compression
End Enum

Enum TConformanceType
   ctPDFA_1b_2005
   ctNormalize
End Enum

Enum TDecSeparator
' per thousand separator, decimal separator
   dsCommaDot
   dsNoneDot
   dsDotComma
   dsNoneComma
End Enum

Enum TDocumentInfo
   diAuthor
   diCreator
   diKeywords
   diProducer
   diSubject
   diTitle
   diCompany
   diPDFX_Ver ' GetInDocInfo() only -> The PDF/X version is set by SetPDFVersion()!
   diCustom   ' User defined key
End Enum

Enum TDrawDirection
  ddCounterClockwise
  ddClockwise
End Enum

Enum TFieldColor
   fcBackColor
   fcBorderColor
   fcTextColor
End Enum

Enum TFileAttachIcon
   faiGraph
   faiPaperClip
   faiPushPin
   faiTag
End Enum

Enum TFileOP
   foOpen
   foPrint
End Enum

Enum TFontSelMode
   smFamilyName
   smPostScriptName
End Enum

Enum TGStateFlags
   gfCompatible = 0         ' Compatible graphics state to earlier DynaPDF versions -> default
   gfRestorePageCoords = 1  ' Restore the coordinate system with the graphics state (the value of PageCoords, see SetPageCoords())
   gfRealTopDownCoords = 2  ' If set, the page coordinate system is not reset to bottom-up when transforming
                            ' the coordinate system. However, real top-down coordinates require a large internal
                            ' overhead and where never fully implemented. The usage of this flag should be avoided
                            ' if possible.
   gfUseImageColorSpace = 8 ' If set, the active color space is ignored when inserting an image. The color space is taken
                            ' from the image file instead.
   gfIgnoreICCProfiles = 16 ' Meaningful only if the flag gfUseImageColorSpace is set. If set, an embedded profile is not used to
                            ' create an ICCBased color space for the image. The image is inserted in the corresponding device
                            ' color space instead.
End Enum

Enum TICCProfileType
   ictGray
   ictRGB
   ictCMYK
   ictLab
End Enum

Enum TImportFlags
   ifImportAll = &HFFFFFFE ' default
   ifContentOnly = &H0
   ' If this flag is set, only interactive objects are imported if any, Otherwise only empty pages are imported.
   ' This flag can be used to copy an interactive form to another PDF file.
   ifNoContent = &H1
   ' The imported page is not converted to a template if ifImportAsPage is set.
   ' Note that this flag can cause resource conflicts. Use this flag carefully!
   ifImportAsPage = &H80000000
   ' base objects
   ifCatalogAction = &H2
   ifPageActions = &H4
   ifBookmarks = &H8
   ifArticles = &H10
   ifPageLabels = &H20
   ifThumbs = &H40
   ifTranspGroups = &H80         ' This flag is not longer considered.
   ifSeparationInfo = &H100
   ifBoxColorInfo = &H200
   ifStructureTree = &H400
   ifTransition = &H800
   ifSearchIndex = &H1000
   ifJavaScript = &H2000
   ifJSActions = &H4000
   ifDocInfo = &H8000           ' Document info entries
   ifEmbeddedFiles = &H200000   ' File attachments
   ifFileCollections = &H400000 ' File collections (PDF 1.7)
   ' Annotations -> Only the most important annotation types can be selected directly.
   ' Note that all annotation types can be deleted with DeleteAnnotation.
   ifAllAnnots = &H9F0000
      ifFreeText = &H10000
      ifTextAnnot = &H20000
      ifLink = &H40000
      ifStamp = &H80000
      if3DAnnot = &H100000
      ifOtherAnnots = &H800000
   ' Interactive Form fields are also annotations but we handle this type separately!
   ifFormFields = &H1000000
' -------------------- Special flags --------------------
   ifPrepareForPDFA = &H10000000 ' Replace LZW compression with Flate, set the Interpolate key of images to false, do not import embedded files.
   ifEnumFonts = &H20000000      ' Import fonts for EnumDocFonts(). The document must be deleted when this flag is set!!!
   ifAllPageObjects = &H40000000 ' Import links when using ImportPageEx() within an open page. The entire document should be imported in this case.
End Enum

Enum TImportFlags2
   if2MergeLayers = &H1          ' If set, layers with identical name are merged. If this flag is absent DynaPDF
                                 ' imports such layers separately so that each layer refers still to the pages
                                 ' where it was orignally used.
   if2Normalize = &H2            ' Replace LZW compression with Flate, apply limit checks, repair errors if possible.
End Enum

Enum TLineCapStyle
  csButtCap
  csRoundCap
  csSquareCap
End Enum

Enum TLineJoinStyle
  jsMiterJoin
  jsRoundJoin
  jsBevelJoin
End Enum

Enum TMetaFlags
   mfDefault = 0                   ' Default conversion
   mfDebug = 1                     ' Write debug information into the content stream
   mfShowBounds = 2                ' Show the bounding boxes of text strings
   mfNoTextScaling = 4             ' Do not scale text
   mfClipView = 8                  ' Draw the file into a clipping rectangle
   mfUseRclBounds = 16             ' Use rclBounds instead of rclFrame
   mfNoClippingRgn = 64            ' Disables SelectClippingRegion and IntersectClipRect
   mfNoFontEmbedding = 128         ' Do not embed fonts -> Fonts should be embedded!!!
   mfNoImages = 256                ' Ignore image records
   mfNoStdPatterns = 512           ' Ignore standard patterns
   mfNoBmpPatterns = 1024          ' Ignore bitmap patterns
   mfNoText = 2048                 ' Ignore text records
   mfUseUnicode = 4096             ' Ignore ANSI_CHARSET
   mfUseTextScaling = 16384        ' Scale text instead of using the intercharacter spacing array
   mfNoUnicode = 32768             ' Avoid usage of Unicode fonts -> recommended to enable PDF 1.2 compability
   mfFullScale = 65536             ' Scale coordinates to the window size. Recommended if 32 bit coordinates are used.
   mfUseRclFrame = 131072          ' This flag should be set if the rclFrame rectangle is properly set
   mfDefBkModeTransp = 262144      ' Initialize the background mode to transparent (SetBkMode() overrides this state).
   mfApplyBidiAlgo = &H80000       ' Apply the bidirectional algorithm on Unicode strings
   mfGDIFontSelection = &H100000   ' Use the GDI to select fonts
   mfRclFrameEx = &H200000         ' If set, and if the rclBounds rectangle is larger than rclFrame, the function
                                   ' extends the output rectangle according to rclBounds and uses the resulting
                                   ' bounding box to calculate the image size (rclBounds represents the unscaled
                                   ' image size). This is probably the correct way to calculate the image size.
                                   ' However, to preserve backward compatibility the default calculation cannot
                                   ' be changed.
   mfNoTextClipping = &H400000     ' If set, the ETO_CLIPPED flag in text records is ignored.
   mfSrcCopy_Only = &H800000       ' If set, images which use a ROP code other than SRCCOPY are ignored. This is useful when processing Excel 2007 spool files.
   mfClipRclBounds = &H1000000     ' If set, the graphic is drawn into a clipping path with the size of rclBounds.
                                   ' This flag is useful if the graphic contains content outside of its bounding box.
   mfDisableRasterEMF = &H2000000  ' If set, EMF files which use unsupported ROP codes are not rastered.
   ' Obsolete flags -> these flags are ignored, do no longer use them!
   mfUseSpacingArray = 32     ' enabled by default -> can be disabled with mfUseTextScaling
   mfIntersectClipRect = 8192 ' enabled by default -> can be disabled with mfNoClippingRgn
End Enum

Enum TNamedAction
   naFirstPage
   naLastPage
   naNexPage
   naPrevPage
   naGoBack
   naOpenDlg
   naPrintDlg
   naGeneralInfo
   naFontsInfo
   naSaveAs
   naSecurityInfo
   naFitPage
   naFullScreen
   naDeletePages
   naQuit
End Enum

Enum TNegativeStyle
   nsMinusBlack
   nsRed
   nsParensBlack
   nsParensRed
End Enum

' All actions which should be applied to an event except On Mouse Upend Enum must be a JavaScript action!
Enum TObjEvent
   oeNoEvent           ' Internal use only -> DO NOT USE THIS VALUE!!!
   oeOnOpen            ' Catalog Pages
   oeOnClose           ' Pages only
   oeOnMouseUp         ' All fields page link annotations bookmarks
   oeOnMouseEnter      ' Form fields only
   oeOnMouseExit       ' Form fields only
   oeOnMouseDown       ' Form fields only
   oeOnFocus           ' Form fields only
   oeOnBlur            ' Form fields only
   oeOnKeyStroke       ' Text fields only
   oeOnFormat          ' Text fields only
   oeOnCalc            ' Text fields combo boxes list boxes
   oeOnValidate        ' All form fields except buttons
   oeOnPageVisible     ' PDF 1.5 -> Form fields only
   oeOnPageInVisible   ' PDF 1.5 -> Form fields only
   oeOnPageOpen        ' PDF 1.5 -> Form fields only
   oeOnPageClose       ' PDF 1.5 -> Form fields only
   oeOnBeforeClosing   ' PDF 1.4 -> Catalog only
   oeOnBeforeSaving    ' PDF 1.4 -> Catalog only
   oeOnAfterSaving     ' PDF 1.4 -> Catalog only
   oeOnBeforePrinting  ' PDF 1.4 -> Catalog only
   oeOnAfterPrinting   ' PDF 1.4 -> Catalog only
End Enum

Enum TOrigin
  orDownLeft
  orTopLeft
End Enum

Enum TObjType
   otAction
   otAnnotation
   otBookmark
   otCatalog           ' PDF 1.4
   otField
   otPage
   otPageLink
End Enum

Enum TOCObject
   ooAnnotation
   ooField
   ooImage
   ooTemplate
End Enum

Enum TOCGIntent
   oiDesign = 2
   oiView = 4   ' Default
   oiAll = 8
   oiEmpty = 16 ' Internal
End Enum

Enum TOCVisibility
   ovAllOff
   ovAllOn
   ovAnyOff
   ovAnyOn
   ovNotSet ' Internal
End Enum

Enum TPageBoundary
   pbArtBox
   pbBleedBox
   pbCropBox
   pbTrimBox
   pbMediaBox
End Enum

Enum TPageCoord
  pcBottomUp
  pcTopDown
End Enum

Enum TPageFormat
   pfDIN_A3
   pfDIN_A4
   pfDIN_A5
   pfDIN_B4
   pfDIN_B5
   pfDIN_B6
   pfDIN_C3
   pfDIN_C4
   pfDIN_C5
   pfDIN_C6
   pfDIN_C65
   pfDIN_DL
   pfDIN_E4
   pfDIN_E5
   pfDIN_E6
   pfDIN_E65
   pfDIN_M5
   pfDIN_M65
   pfUS_Legal
   pfUS_Letter
End Enum

Enum TPageLayout
   plSinglePage
   plOneColumn
   plTwoColumnLeft
   plTwoColumnRight
   plTwoPageLeft
   plTwoPageRight
   plDefault        ' Use viewer's default settings
End Enum

Enum TPageMode
   pmUseNone
   pmUseOutLines
   pmUseThumbs
   pmFullScreen
   pmUseOC          ' Optional Content (Layers)
   pmUseAttachments
End Enum

Enum TPathFillMode
   fmFillNoClose
   fmStrokeNoClose
   fmFillStrokeNoClose
   fmFill
   fmStroke
   fmFillStroke
   fmFillEvOdd
   fmFillStrokeEvOdd
   fmFillEvOddNoClose
   fmFillStrokeEvOddNoClose
   fmNoFill
   fmClose
End Enum

Enum TPatternType
   ptColored
   ptUnColored
   ptShadingPattern ' Cannot be created with DynaPDF
End Enum

' The tags have the same meaning as the corresponding HTML tags.
' See PDF Reference for further information.
Enum TPDFBaseTag
   btArt
   btArtifact
   btAnnot
   btBibEntry      ' BibEntry -> Bibliography entry
   btBlockQuote
   btCaption
   btCode
   btDiv
   btDocument
   btFigure
   btForm
   btFormula
   btH
   btH1
   btH2
   btH3
   btH4
   btH5
   btH6
   btIndex
   btLink
   btList          ' L
   btListElem      ' LI
   btListText      ' LBody
   btNote
   btP
   btPart
   btQuote
   btReference
   btSection       ' Sect
   btSpan
   btTable
   btTableDataCell ' TD
   btTableHeader   ' TH
   btTableRow      ' TR
   btTOC
   btTOCEntry      ' TOCI
End Enum

' Notice:
'   When using a bidirectional 8 bit code page the bidi algorithm is applied by default in Left to Right mode
'   also if the bidi mode is set to bmNone (default). This mode produces identical results in comparison to
'   applications like Edit or WordPad.
'
'   The Right to Left mode is available in applications which use Microsoft's Uniscribe, e.g. BabelPad. This
'   mode works very well with the Reference Bidi Algorithm which is used by DynaPDF.
'
'   However , Uniscribe 's Left to Right mode produces different results in comparison to the Reference Bidi
'   Algorithm. Because the bidi algorithm that is used in Uniscribe is not published it is practically
'   impossible to get the same result in Left to Right mode without using this library.

Enum TPDFBidiMode
   bmLeftToRight ' Apply the bidi algorithm on Unicode strings in Left to Right layout.
   bmRightToLeft ' Apply the bidi algorithm on Unicode strings in Right to Left layout.
   bmNone        ' Default -> not apply the bidi algorithm
End Enum

Enum TPDFDateTime
   dfMM_D
   dfM_D_YY
   dfMM_DD_YY
   dfMM_YY
   dfD_MMM
   dfD_MMM_YY
   dfDD_MMM_YY
   dfYY_MM_DD
   dfMMM_YY
   dfMMMM_YY
   dfMMM_D_YYYY
   dfMMMM_D_YYYY
   dfM_D_YY_H_MM_TT
   dfM_D_YY_HH_MM
   ' time formats
   df24HR_MM
   df12HR_MM
   df24HR_MM_SS
   df12HR_MM_SS
End Enum

Enum TPDFVersion
  pvPDF_1_0
  pvPDF_1_1
  pvPDF_1_2
  pvPDF_1_3
  pvPDF_1_4
  pvPDF_1_5
  pvPDF_1_6
  pvPDF_1_7
  pvPDF_1_8
  pvPDF_1_9
  pvPDFX1a_2001 ' PDF/X-1a:2001
  pvPDFX1a_2003 ' PDF/X-1a:2002
  pvPDFX3_2002  ' PDF/X-3:2002
  pvPDFX3_2003  ' PDF/X-3:2003
  pvPDFA_2005   ' PDF/A-1b 2005
End Enum

Enum TPwdType
   ptOpen
   ptOwner
End Enum

Enum TProgType
   ptImportPage = 0
   ptWritePage = 1
End Enum

Enum TRawImageFlags
   rifByteAligned = &H1000
   rifRGBData = &H2000
   rifCMYKData = &H4000
End Enum

Enum TShadingType
   stUnknown       ' cannot occur -> internal use
   stFunctionBased
   stAxial
   stRadial
   stFreeFormGouraud
   stLatticeFormGouraud
   stCoonsPatch
   stTensorProduct
End Enum

Enum TStdPattern
   spHorizontal ' -----
   spVertical   ' |||||
   spRDiagonal  ' \\\\\
   spLDiagonal  ' /////
   spCross      ' +++++
   spDiaCross   ' xxxxx
End Enum

Enum TSubmitFlags
   sfNone = &H0
   sfExlude = &H1                  ' if set, the fields in a sumbmit or reset form action are excluded
   sfInclNoValFields = &H2
   sfHTML = &H4
   sfGetMethod = &H8
   sfSubmCoords = &H10
   sfXML = &H24
   sfInclAppSaves = &H40
   sfInclAnnots = &H80
   sfPDF = &H100
   sfCanonicalFormat = &H200
   sfExlNonUserAnnots = &H400
   sfExlFKey = &H800
   sfEmbedForm = &H2000 ' PDF 1.5 embed the entire form into a file stream inside the FDF file -> requires
                        ' the full version of Adobe's Acrobat
End Enum

Enum TTilingType
   ttConstSpacing
   ttNoDistortion
   ttFastConstSpacing
End Enum

Enum TViewerPreference
  vpUseNone = &H0
  vpHideToolBar = &H1
  vpHideMenuBar = &H2
  vpHideWindowUI = &H4
  vpFitWindow = &H8
  vpCenterWindow = &H10
  vpDisplayDocTitle = &H20
  vpNonFullScrPageMode = &H40
  vpDirection = &H80
  vpViewArea = &H100
  vpViewClip = &H200
  vpPrintArea = &H400
  vpPrintClip = &H800
End Enum

Enum TViewPrefAddVal
  avNone = &H0
  avNonFullScrUseNone = &H1
  avNonFullScrUseOutlines = &H2
  avNonFullScrUseThumbs = &H4
  avNonFullScrUseOC = &H400 ' PDF 1.6
  avDirectionL2R = &H8
  avDirectionR2L = &H10
  avViewPrintArtBox = &H20
  avViewPrintBleedBox = &H40
  avViewPrintCropBox = &H80
  avViewPrintMediaBox = &H100
  avViewPrintTrimBox = &H200
End Enum

' ------------------------------------------------ Private Structures -------------------------------------------------

Private Type TBookmark_I
   Color As Long
   DestPage As Long
   DestPos As TPDFRect
   DestType As TDestType
   DoOpen As Long
   Parent As Long
   Style As Long
   Title As Long
   TitleLen As Long
   bUnicode As Long
End Type

Private Type TDeviceNAttributes_I
   IProcessColorSpace As Long    ' Pointer to process color space or NULL -> GetColorSpaceEx().
   ProcessColorants(7) As Long   ' UTF-8 Process colorant names
   ProcessColorantsCount As Long ' Number of process colorants in the array or zero if not set.
   Separations(31) As Long       ' Optional pointers to Separation color spaces -> GetColorSpaceEx().
   SeparationsCount As Long      ' Number of color spaces in the array.
   IMixingHints As Long          ' Optional mixing hints. There is no API function at this time to access mixing hints.
   Reserved01 As Long
   Reserved02 As Long
   Reserved03 As Long
   Reserved04 As Long
End Type

Private Type TTextRecordW_I
   Advance As Single ' Negative values move the cursor the right, positive to the left
   Text As Long      ' Pointer tp already translated Unicode string (not null-terminated)
   Length As Long    ' Length in characters
   Width As Single   ' String width measured in text space
End Type

Private Type TPDFAnnotation_I
   AnnotType As Long
   Deleted As Long
   BBox As TPDFRect
   BorderWidth As Double
   BorderColor As Long
   BorderStyle As Long
   BackColor As Long
   Handle As Long
   AuthorA As Long
   AuthorW As Long
   ContentA As Long
   ContentW As Long
   NameA As Long
   NameW As Long
   SubjectA As Long
   SubjectW As Long
   PageNum  As Long
   HighlightMode As Long
End Type

Private Type TPDFAnnotationEx_I
   AnnotType As Long
   Deleted As Long
   BBox As TPDFRect
   BorderWidth As Single
   BorderColor As Long
   BorderStyle As Long
   BackColor As Long
   Handle As Long
   AuthorA As Long
   AuthorW As Long
   ContentA As Long
   ContentW As Long
   NameA As Long
   NameW As Long
   SubjectA As Long
   SubjectW As Long
   PageNum As Long
   HighlightMode As Long
   ' Page link annotations only
   DestPage As Long
   DestPos As TPDFRect
   DestType As TDestType
   DestFile As Long      ' File link or web link annotations
   Icon As Long          ' The Icon type depends on the annotation type. If the annotation type is atText then the Icon
                         ' is of type TAnnotIcon. If the annotation type is atFileAttach then it is of type
                         ' TFileAttachIcon. If the annotation type is atStamp then the Icon is the stamp type (TRubberStamp).
                         ' For any other annotion type this value is not set (-1).
   StampName As Long     ' Set only, if Icon == rsUserDefined
   AnnotFlags As Long    ' See TAnnotFlags for available flags
   CreateDate As Long    ' Creation Date -> Optional
   ModDate As Long       ' Modification Date -> Optional
   Grouped As Long       ' (Reply type) Meaningful only if Parent != -1 and Type != atPopUp. If true,
                         ' the annotation is part of an annotation group. Properties like Content, CreateDate,
                         ' ModDate, BackColor, Subject, and Open must be taken from the parent annotation.
   Open As Long          ' Meaningful only for annotations which have a corresponding PopUp annotation.
   Parent As Long        ' Parent annotation handle of a PopUp Annotation or the parent annotation if
                         ' this annotation represents a state of a base annotation. In this case,
                         ' the annotation type is always atText and only the following members should
                         ' be considered:
                         '    State      // The current state
                         '    StateModel // Marked, Review, and so on
                         '    CreateDate // Creation Date
                         '    ModDate    // Modification Date
                         '    Author     // The user who has set the state
                         '    Content    // Not displayed in Adobe's Acrobat...
                         '    Subject    // Not displayed in Adobe's Acrobat...
                         ' The PopUp annotation of a text annotation which represent an Annotation State
                         ' must be ignored.
   PopUp As Long         ' Handle of the corresponding PopUp annotation if any.
   State As Long         ' The state of the annotation.
   StateModel As Long    ' The state model (Marked, Review, and so on).
   EmbeddedFile As Long  ' FileAttach annotations only. A handle of an embedded file -> GetEmbeddedFile().
   Subtype As Long       ' Set only, if Type = atUnknownAnnot
   ' Reserved fields for future extensions
   Reserved01 As Long
   Reserved02 As Long
   Reserved03 As Long
   Reserved04 As Long
   Reserved05 As Long
   Reserved06 As Long
   Reserved07 As Long
   Reserved08 As Long
   Reserved09 As Long
   Reserved10 As Long
   Reserved11 As Long
   Reserved12 As Long
   Reserved13 As Long
   Reserved14 As Long
   Reserved15 As Long
   Reserved16 As Long
   Reserved17 As Long
   Reserved18 As Long
   Reserved19 As Long
   Reserved20 As Long
   Reserved21 As Long
   Reserved22 As Long
   Reserved23 As Long
   Reserved24 As Long
   Reserved25 As Long
   Reserved26 As Long
   Reserved27 As Long
End Type

Private Type TPDFChoiceValue_I
   StructSize As Long ' Must be initialzed to sizeof(TPDFChoiceValue_I)
   ExpValueA As Long
   ExpValueW As Long
   ExpValueLen As Long
   ValueA As Long
   ValueW As Long
   ValueLen As Long
   Selected As Long
End Type

'The structure contains several duplicate fields because CMap files contain usually a DSC comment
'section which provides Postscript specific initialization code. With exception of DSCResName the
'strings in the DSC section should not differ from their CMap counterparts. The Identity mapping
'of a character collection should contain the DSC comment "%%BeginResource: CMap (Identity)".
'Otherwise the string should be set to the CMap name.
Private Type TPDFCMap_I
   StructSize As Long       ' Must be set to sizeof(TPDFCMap) before calling GetCMap()!
   BaseCMap As Long         ' If set, this base cmap is required when loading the cmap.
   CIDCount As Long         ' 0 if not set.
   CMapName As Long         ' The CMap name.
   CMapType As Long         ' Should be 1!
   CMapVersion As Single    ' The CMap version.
   DSCBaseCMap As Long      ' DSC comment.
   DSCCMapVersion As Single ' DSC comment.
   DSCResName As Long       ' DSC comment. If the CMap uses an Identity mapping this string should be set to Identity.
   DSCTitle As Long         ' DSC comment -> DSC CMap name + Registry + Ordering + Supplement, e.g. "GB-EUC-H Adobe GB1 0"
   FileNameA As Long        ' The file name and CMap name should be identical!
   FileNameW As Long        ' The file name and CMap name should be identical!
   FilePathA As Long        ' The Ansi string is set if the Ansi version of SetCMapDir() was used.
   FilePathW As Long        ' The Unicode string is set if the Unicode version of SetCMapDir() was used.
   Ordering As Long         ' CIDSystemInfo -> The Character Collection, e.g. Japan1.
   Registry As Long         ' CIDSystemInfo -> The registrant of the Character Collection is usually Adobe.
   Supplement As Long       ' CIDSystemInfo -> The Supplement number should be supported in the used PDF Version.
   WritingMode As Long      ' 0 == Horizontal, 1 == Vertical
End Type

Private Type TPDFColorSpaceObj_I
   ColorSpaceType As TExtColorSpace
   Alternate As TExtColorSpace      ' Alternate color space or base space of an Indexed or Pattern color space.
   IAlternate As Long               ' Only set if the color space contains an alternate or base color space -> GetColorSpaceObjEx().
   Buffer As Long                   ' Contains either an ICC profile or the color table of an Indexed color space.
   BufSize As Long                  ' Buffer length in bytes.
   BlackPoint As Long               ' CIE blackpoint. If set, the array contains exactly 3 values.
   WhitePoint As Long               ' CIE whitepoint. If set, the array contains exactly 3 values.
   Gamma As Long                    ' If set, one value per component.
   Range As Long                    ' min/max for each component or for the .a and .b components of a Lab color space.
   Matrix As Long                   ' XYZ matrix. If set, the array contains exactly 9 values.
   NumInComponents As Long          ' Number of input components.
   NumOutComponents As Long         ' Number of output components.
   NumColors As Long                ' HiVal + 1 as specified in the color space. Indexed color space only.
   Colorants(31) As Long            ' UTF-8 Colorant names (Separation, DeviceN, and NChannel only).
   ColorantsCount As Long           ' The number of colorants in the array.
   Metadata As Long                 ' Optional XMP metadata stream -> ICCBased only.
   MetadataSize As Long             ' Metadata length in bytes.
   IFunction As Long                ' Pointer to function object -> Separation, DeviceN, and NChannel only.
   IAttributes As Long              ' Optional attributes of DeviceN or NChannel color spaces -> GetNChannelAttributes().
   IColorSpaceObj As Long           ' Pointer of the corresponding color space object
   Reserved01 As Long
   Reserved02 As Long
   Reserved03 As Long
   Reserved04 As Long
   Reserved05 As Long
   Reserved06 As Long
   Reserved07 As Long
   Reserved08 As Long
   Reserved09 As Long
End Type

Private Type TPDFField_I
   FieldType As Long
   Deleted As Long
   BBox As TPDFRect
   Handle As Long
   FieldName As Long
   FieldNameLen As Long
   BackCS As Long
   TextCS As Long
   BackColor As Long
   BorderColor As Long
   TextColor As Long
   Checked As Long
   Parent As Long
   KidCount As Long
   FontName As Long
   FontSize As Double
   Value As Long
   UniVal As Long
   valLen As Long
   ToolTip As Long
   UniToolTip As Long
   ToolTipLen As Long
End Type

Private Type TPDFFieldEx_I
   StructSize As Long              ' Must be set to sizeof(TPDFFieldEx)
   Deleted As Long                 ' If true, the field was marked as deleted by DeleteField()
   BBox As TPDFRect                ' Bounding box of the field in bottom-up coordinates
   FieldType As TFieldType         ' Field type
   GroupType As TFieldType         ' If GroupType != FieldType the field is a terminal field of a field group
   Handle As Long                  ' Field handle
   BackColor As Long               ' Background color
   BackColorSP As TExtColorSpace   ' Color space of the background color
   BorderColor As Long             ' Border color
   BorderColorSP As TExtColorSpace ' Color space of the border color
   BorderStyle As TBorderStyle     ' Border style
   BorderWidth As Single           ' Border width
   CharSpacing As Single           ' Text fields only
   Checked As Long                 ' Check boxes only
   CheckBoxChar As Long            ' ZapfDingbats character that is used to display the on state
   DefState As TCheckBoxState      ' Check boxes only
   DefValueA As Long               ' Optional default value
   DefValueW As Long               ' Optional default value
   IEditFont As Long               ' Pointer to default editing font
   EditFont As Long                ' Postscript name of the editing font
   ExpValCount As Long             ' Combo and list boxes only. The values can be accessed with GetFieldExpValueEx()
   ExpValueA As Long               ' Check boxes only
   ExpValueW As Long               ' Check boxes only
   FieldFlags As TFieldFlags       ' Field flags
   IFieldFont As Long              ' Pointer to the font that is used by the field
   FieldFont As Long               ' Postscript name of the font
   Reserved1 As Long               ' Reserved field to avoid alignment errors
   FontSize As Double              ' Font size. 0.0 means auto font size
   FieldNameA As Long              ' Note that children of a field group or radio button have no name
   FieldNameW As Long              ' Field name length in characters
   HighlightMode As THighlightMode ' Highlight mode
   IsCalcField As Long             ' If true, the OnCalc event of the field is connected with a JavaScript action
   MapNameA As Long                ' Optional unique mapping name of the field
   MapNameW As Long                ' MapName length in characters
   MaxLen As Long                  ' Text fields only -> zero means not restricted
   Kids As Long                    ' Array of child fields -> GetFieldEx2()
   KidCount As Long                ' Number of fields in the array
   Parent As Long                  ' Pointer to parent field or NULL
   PageNum As Long                 ' Page on which the field is used or -1
   Rotate As Long                  ' Rotation angle in degrees
   TextAlign As TTextAlign         ' Text fields only
   TextColor As Long               ' Text color
   TextColorSP As TExtColorSpace   ' Color space of the field's text
   TextScaling As Single           ' Text fields only
   ToolTipA As Long                ' Optional tool tip
   ToolTipW As Long                ' Optional tool tip
   UniqueNameA As Long             ' Optional unique name (NM key)
   UniqueNameW As Long             ' Optional unique name (NM key)
   ValueA As Long                  ' Field value
   ValueW As Long                  ' Field value
   WordSpacing As Single           ' Text fields only
   Reserved2 As Long               ' Reserved field to avoid alignment errors
End Type

Private Type TPDFFileSpec_I
   Buffer As Long
   BufSize As Long
   Compressed As Long
   ColItem As Long
   Name As Long
   NameUnicode As Long
   FileName As Long
   IsURL As Long
   UF As Long
   UFUnicode As Long
   Desc As Long
   DescUnicode As Long
   FileSize As Long
   MIMEType As Long
   CreateDate As Long
   ModDate As Long
   CheckSum As Long
End Type

Private Type TPDFFontObj_I
   Ascent As Single      ' Ascent
   BaseFont As Long      ' PostScript Name or Family Name
   CapHeight As Single   ' Cap height
   Descent As Single     ' Descent
   Encoding As Long      ' Unicode mapping 0..255 -> not set if a CID font is selected
   FirstChar As Long     ' First char
   Flags As Long         ' Font flags -> font descriptor
   FontFamily As Long    ' Optional Font Family (Family Name)
   FontFamilyUni As Long ' Is FontFamily in Unicode format?
   FontName As Long      ' Font name -> font descriptor
   FontType As TFontType ' If ftType0 the font is a CID font. The Encoding is not set in this case.
   ItalicAngle As Single ' Italic angle
   LastChar As Long      ' Last char
   spaceWidth As Single  ' Space width in font units. A default value is set if the font contains no space character.
   Widths As Long        ' Glyph widths -> 0..WidthsCount -1
   WidthsCount As Long   ' Number of widths in the array
   XHeight As Single     ' x-height
   DefWidth As Single    ' Default character widths -> CID fonts only
   FontFile As Long      ' Font file buffer -> only imported fonts are returned.
   Length1 As Long       ' Length of the clear text portion of the Type1 font, or the length of the entire font program if FontType != ffType1.
   Length2 As Long       ' Length of the encrypted portion of the Type1 font program (Type1 fonts only).
   Length3 As Long       ' Length of the fixed-content portion of the Type1 font program or zero if not present.
   FontFileType As TFontFileSubtype  ' See description in the help file for further information.
End Type

Private Type TPDFNamedDest_I
   NameA As Long
   NameW As Long
   NameLen As Long
   DestPage As Long
   DestPos As TPDFRect
   DestType As TDestType
End Type

Private Type TPDFPageLabel_I
   StartRange As Long
   Format As TPageLabelFormat
   FirstPageNum As Long
   Prefix As Long
   PrefixLen As Long
   PrefixUni As Long
End Type

Private Type TPDFPrintSettings_I
   DuplexMode As Long
   NumCopies As Long             ' -1 means not set. Values larger than 5 are ignored in viewer applications.
   PickTrayByPDFSize As Long     ' -1 means not set. 0 == false, 1 == true.
   PrintRanges As Long           ' If set, the array contains PrintRangesCount * 2 values. Each pair consists
                                 ' of the first and last pages in the sub-range. The first page in the PDF file
                                 ' is denoted by 0.
   PrintRangesCount As Long      ' Number of ranges available in PrintRanges.
   PrintScaling As Long ' dpmNone means not set.
   ' Reserved fields for future extensions
   Reserved0 As Long
   Reserved1 As Long
   Reserved2 As Long
   Reserved3 As Long
   Reserved4 As Long
   Reserved5 As Long
   Reserved6 As Long
   Reserved7 As Long
   Reserved8 As Long
   Reserved9 As Long
End Type

Private Type TPDFSigParms_I
   StructSize As Long        ' Must be set to sizeof(TSignParms)
   PKCS7ObjLen As Long       ' The maximum length of the signed PKCS#7 object
   HashType As THashType     ' If set to htDetached, the bytes ranges of the PDF file will be returned.
   Range1 As Long            ' Out -> Contains either the hash or the first byte range to create a detached signature
   Range1Len As Long         ' Out -> Length of the buffer
   Range2 As Long            ' Out -> Set only if HashType == htDetached
   Range2Len As Long         ' Out -> Length of the buffer
   ContactInfoA As Long      ' Optional, e.g. an email address
   ContactInfoW As Long      ' Optional, e.g. an email address
   LocationA As Long         ' Optional location of the signer
   LocationW As Long         ' Optional location of the signer
   ReasonA As Long           ' Optional reason why the file was signed
   ReasonW As Long           ' Optional reason why the file was signed
   SignerA As Long           ' Optional, the issuer of the certificate takes precedence
   SignerW As Long           ' Optional, the issuer of the certificate takes precedence
   Encrypt As Long           ' If true, the file will be encrypted
   ' These members will be ignored if Encrypt is set to false
   OpenPwd As String         ' Open password
   OwnerPwd As String        ' Owner password to change the security settings
   KeyLen As TKeyLen         ' Key length to be used to encrypt the file
   Restrict As TRestrictions ' What should be restricted?
End Type

Private Type TPDFStack_I
   ctm As TCTM                ' Pre-multiplied global transformation matrix
   tm As TCTM                 ' Pre-multiplied text transformation matrix
   x As Double                ' Unused -> always 0.0
   y As Double                ' Unused -> always 0.0
   FontSize As Double         ' Font size
   CharSP As Double           ' Character spacing
   WordSP As Double           ' Word spacing
   HScale As Double           ' Horizontal text scaling
   TextRise As Double         ' Text rise -> always 0.0 because it is already included in the text transformation matrix
   Leading As Double          ' Leading
   LineWidth As Double        ' Line width
   DrawMode As TDrawMode      ' Text draw mode
   FillCS As TPDFColorSpace   ' Fill color space
   StrokeCS As TPDFColorSpace ' Stroke color space
   FillColor As Long          ' Fill color
   StrokeColor As Long        ' Stroke color
   BaseObject As Long         ' Internal
   CIDFont As Long            ' If true, ReplacePageText() can only be used to delete a string
   Text As Long               ' Raw text without kerning space
   TextLen As Long            ' Raw text length
   RawKern As Long            ' Raw kerning array
   Kerning As Long            ' Already translated Unicode kerning array
   KerningCount As Long       ' Number of kerning records
   TextWidth As Single        ' The width of the entire text record measured in text space
   IFont As Long              ' Font object used to print the string -> fntGetFont() can be used to return the font properties
   Embedded As Long           ' If true, the font is embedded
   spaceWidth As Single       ' Measured in text space
   'These members can be modified after the structure has been initialized with InitStack().
   'If the destination color space should be DeviceCMYK initialize FillColor and StrokeColor
   'with PDF_CMYK(0,0,0,255); which represents black.
   ConvColors As Long          ' If set to true (default), all colors are converted to the specified destination color space
   DestSpace As TPDFColorSpace ' Destination color space -> default == csDeviceRGB

   ' This member can be used in combination with ReplacePageText() to preserve a number
   ' of kerning records from deletion. All records above this value will be deleted.
   ' Take a look into the VB .Net demo examples/util/pdf_edit_text.vb to determine how this member
   ' can be used.
   DeleteKerningAt As Long
   FontFlags As Long           ' PDF font flags
   ' ------------------------------- Reserved fields -------------------------------
   Reserved1 As Long
   Reserved2 As Long
   Reserved3 As Long
   Reserved4 As Long
   Reserved5 As Long
   Reserved6 As Long
   Reserved7 As Long
   Reserved8 As Long
   Reserved9 As Long
   Reserved10 As Long
   Reserved11 As Long
   ContentPtr As Long
End Type

Private m_Instance As Long

' These variables are used to speed up processing
Private FBookmark As TBookmark_I
Private FField As TPDFField_I
Private FStack As TPDFStack_I

Private Declare Function fntGetFont Lib "dynapdf.dll" (ByVal IFont As Long, ByRef Font As TPDFFontObj_I) As Long
Private Declare Function fntGetSpaceWidth Lib "dynapdf.dll" (ByVal IFont As Long, ByVal FontSize As Double) As Double
Private Declare Function fntGetTextWidth Lib "dynapdf.dll" (ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByVal CharSpacing As Single, ByVal WordSpacing As Single, ByVal TextScale As Single) As Double
Private Declare Function fntTranslateRawCode Lib "dynapdf.dll" (ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByRef Width As Double, ByVal OutText As Long, ByRef OutLen As Long, ByRef Decoded As Long, ByVal CharSpacing As Single, ByVal WordSpacing As Single, ByVal TextScale As Single) As Long
Private Declare Function fntTranslateString Lib "dynapdf.dll" (ByRef Stack As TPDFStack_I, ByVal OutText As Long, ByVal Size As Long, ByVal Flags As Long) As Long
Private Declare Function fntTranslateString2 Lib "dynapdf.dll" (ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByVal OutText As Long, ByVal Size As Long, ByVal Flags As Long) As Long


Private Declare Function pdfAddActionToObj Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal AEvent As Long, ByVal ActHandle As Long, ByVal ObjHandle As Long) As Long
Private Declare Function pdfAddArticle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfAddBookmarkA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfAddBookmarkW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfAddBookmarkExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Title As String, ByVal Parent As Long, ByVal NamedDest As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfAddBookmarkExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Title As String, ByVal Parent As Long, ByVal NamedDest As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfAddButtonImage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal BtnHandle As Long, ByVal State As Long, ByVal Caption As String, ByVal ImgFile As String) As Long
Private Declare Function pdfAddButtonImageEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal BtnHandle As Long, ByVal State As Long, ByVal Caption As String, ByVal Handle As Long) As Long
Private Declare Function pdfAddContinueTextA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Long
Private Declare Function pdfAddContinueTextW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Long
Private Declare Function pdfAddDeviceNProcessColorants Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DeviceNCS As Long, ByVal Colorants As Long, ByVal NumColorants As Long, ByVal ProcessCS As Long, ByVal Handle As Long) As Long
Private Declare Function pdfAddDeviceNSeparations Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DeviceNCS As Long, ByVal Colorants As Long, ByVal SeparationCS As Long, ByVal NumColorants As Long) As Long
Private Declare Function pdfAddFieldToFormAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Action As Long, ByVal Field As Long, ByVal DoInclude As Long) As Long
Private Declare Function pdfAddFieldToHideAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal HideAct As Long, ByVal Field As Long) As Long
Private Declare Function pdfAddFileCommentA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Long
Private Declare Function pdfAddFileCommentW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Long
Private Declare Function pdfAddFontSearchPathA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal APath As String, ByVal Recursive As Long) As Long
Private Declare Function pdfAddFontSearchPathW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal APath As String, ByVal Recursive As Long) As Long
Private Declare Function pdfAddJavaScriptA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Script As String) As Long
Private Declare Function pdfAddJavaScriptW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Script As String) As Long
Private Declare Function pdfAddObjectToLayer Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OCG As Long, ByVal ObjType As TOCObject, ByVal Handle As Long) As Long
Private Declare Function pdfAddPageLabelA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal StartRange As Long, ByVal Format As Long, ByVal Prefix As String, ByVal AddNum As Long) As Long
Private Declare Function pdfAddPageLabelW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal StartRange As Long, ByVal Format As Long, ByVal Prefix As String, ByVal AddNum As Long) As Long
Private Declare Function pdfAddRenderingIntentA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ICCFile As String) As Long
Private Declare Function pdfAddRenderingIntentW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ICCFile As String) As Long
Private Declare Function pdfAddRenderingIntentEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long) As Long
Private Declare Function pdfAddValToChoiceFieldA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ExpValue As String, ByVal Value As String, ByVal Selected As Long) As Long
Private Declare Function pdfAddValToChoiceFieldW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ExpValue As String, ByVal Value As String, ByVal Selected As Long) As Long
Private Declare Function pdfAppend Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfApplyPattern Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PattHandle As Long, ByVal ColorMode As Long, ByVal Color As Long) As Long
Private Declare Function pdfApplyShading Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ShadHandle As Long) As Long
Private Declare Function pdfAttachFileA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FilePath As String, ByVal Description As String, ByVal Compress As Long) As Long
Private Declare Function pdfAttachFileW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FilePath As String, ByVal Description As String, ByVal Compress As Long) As Long
Private Declare Function pdfAttachFileExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal FileName As String, ByVal Description As String, ByVal Compress As Long) As Long
Private Declare Function pdfAttachFileExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal FileName As String, ByVal Description As String, ByVal Compress As Long) As Long
Private Declare Function pdfAutoTemplate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Templ As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfBeginClipPath Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfBeginContinueText Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double) As Long
Private Declare Function pdfBeginLayer Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OCG As Long) As Long
Private Declare Function pdfBeginPattern Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PatternType As Long, ByVal TilingType As Long, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfBeginTemplate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfBezier_1_2_3 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double) As Long
Private Declare Function pdfBezier_1_3 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal x1 As Double, ByVal y1 As Double, ByVal x3 As Double, ByVal y3 As Double) As Long
Private Declare Function pdfBezier_2_3 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double) As Long
Private Declare Function pdfCalcWidthHeight Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OrgWidth As Double, ByVal OrgHeight As Double, ByVal ScaledWidth As Double, ByVal ScaledHeight As Double) As Double
Private Declare Function pdfChangeAnnotNameA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Name As String) As Long
Private Declare Function pdfChangeAnnotNameW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Name As String) As Long
Private Declare Function pdfChangeAnnotPos Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfChangeBookmarkA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ABmk As Long, ByVal ATitle As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfChangeBookmarkW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ABmk As Long, ByVal ATitle As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfChangeFont Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfChangeFontSize Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Size As Double) As Long
Private Declare Function pdfChangeFontStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Style As Long) As Long
Private Declare Function pdfChangeFontStyleEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Style As Long) As Long
Private Declare Function pdfChangeJavaScriptA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal NewScript As String) As Long
Private Declare Function pdfChangeJavaScriptW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal NewScript As String) As Long
Private Declare Function pdfChangeJavaScriptActionA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal NewScript As String) As Long
Private Declare Function pdfChangeJavaScriptActionW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal NewScript As String) As Long
Private Declare Function pdfChangeJavaScriptNameA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Name As String) As Long
Private Declare Function pdfChangeJavaScriptNameW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Name As String) As Long
Private Declare Function pdfChangeLinkAnnot Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal URL As String) As Long
Private Declare Function pdfCheckFieldNames Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfCheckCollection Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfCheckConformance Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ConfType As Long, ByVal Options As Long, ByVal UserData As Long, ByVal OnFontNotFound As Long, ByVal OnReplaceICCProfile As Long) As Long
Private Declare Function pdfClearAutoTemplates Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfClearHostFonts Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfClipPath Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ClipMode As Long, ByVal FillMode As Long) As Long
Private Declare Function pdfCloseAndSignFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CertFile As String, ByVal Password As String, ByVal Reason As String, ByVal Location As String) As Long
Private Declare Function pdfCloseAndSignFileEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As Long, ByVal Restrict As Long, ByVal CertFile As String, ByVal Password As String, ByVal Reason As String, ByVal Location As String) As Long
Private Declare Function pdfCloseAndSignFileExt Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef SigParms As TPDFSigParms_I) As Long
Private Declare Function pdfCloseFile Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfCloseFileEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As Long, ByVal Restrict As Long) As Long
Private Declare Function pdfCloseImportFile Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfClosePath Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FillMode As Long) As Long
Private Declare Function pdfCloseTag Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfComputeBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef BBox As TPDFRect, ByVal Flags As Long) As Long
Private Declare Function pdfConvertColors Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long, ByVal Reserved As Long) As Long
Private Declare Function pdfConvToUnicode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AString As String, ByVal CP As Long) As Long
Private Declare Function pdfCreate3DAnnot Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Name As String, ByVal U3DFile As String, ByVal Image As String) As Long
Private Declare Function pdfCreate3DBackground Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal IView As Long, ByVal BackColor As Long) As Long
Private Declare Function pdfCreate3DGotoViewAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Base3DAnnot As Long, ByVal IView As Long, ByVal Named As Long) As Long
Private Declare Function pdfCreate3DProjection Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal IView As Long, ByVal ProjType As Long, ByVal ScaleType As Long, ByVal Diameter As Double, ByVal FOV As Double) As Long
Private Declare Function pdfCreate3DView Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Base3DAnnot As Long, ByVal Name As String, ByVal SetAsDefault As Long, ByRef Matrix As Any, ByVal CamDistance As Double, ByVal RM As Long, ByVal LS As Long) As Long
Private Declare Function pdfCreateAnnotAP Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Annot As Long) As Long
Private Declare Function pdfCreateArticleThreadA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ThreadName As String) As Long
Private Declare Function pdfCreateArticleThreadW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ThreadName As String) As Long
Private Declare Function pdfCreateAxialShading Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal sx As Double, ByVal sy As Double, ByVal eX As Double, ByVal eY As Double, ByVal SCenter As Double, ByVal SColor As Long, ByVal EColor As Long, ByVal Extend1 As Long, ByVal Extend2 As Long) As Long
Private Declare Function pdfCreateButtonA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Caption As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateButtonW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Caption As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateCheckBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal ExpValue As String, ByVal Checked As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateCIEColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Base As Long, ByVal WhitePoint As Long, ByVal BlackPoint As Long, ByVal Gamma As Long, ByVal Matrix As Long) As Long
Private Declare Function pdfCreateCollection Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal View As Long) As Long
Private Declare Function pdfCreateCollectionFieldA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColType As Long, ByVal Column As Long, ByVal Name As String, ByVal Key As String, ByVal Visible As Long, ByVal Editable As Long) As Long
Private Declare Function pdfCreateCollectionFieldW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColType As Long, ByVal Column As Long, ByVal Name As String, ByVal Key As String, ByVal Visible As Long, ByVal Editable As Long) As Long
Private Declare Function pdfCreateColItemDate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal EmbFile As Long, ByVal Key As String, ByVal DateVal As Long, ByVal Prefix As String) As Long
Private Declare Function pdfCreateColItemNumber Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal EmbFile As Long, ByVal Key As String, ByVal Value As Double, ByVal Prefix As String) As Long
Private Declare Function pdfCreateColItemStringA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal EmbFile As Long, ByVal Key As String, ByVal Value As String, ByVal Prefix As String) As Long
Private Declare Function pdfCreateColItemStringW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal EmbFile As Long, ByVal Key As String, ByVal Value As String, ByVal Prefix As String) As Long
Private Declare Function pdfCreateComboBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Sort As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateDeviceNColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Colorants As Long, ByVal NumColorants As Long, ByVal PostScriptFunc As String, ByVal Alternate As Long, ByVal Handle As Long) As Long
Private Declare Function pdfCreateExtGState Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef GS As TPDFExtGState) As Long
Private Declare Function pdfCreateGoToAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DestType As Long, ByVal PageNum As Long, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
Private Declare Function pdfCreateGoToActionEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal NamedDest As Long) As Long
Private Declare Function pdfCreateGoToRAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PageNum As Long) As Long
Private Declare Function pdfCreateGoToRActionExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal DestName As String, ByVal NewWindow As Long) As Long
Private Declare Function pdfCreateGoToRActionExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal DestName As String, ByVal NewWindow As Long) As Long
Private Declare Function pdfCreateGroupField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Parent As Long) As Long
Private Declare Function pdfCreateHideAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Hide As Long) As Long
Private Declare Function pdfCreateICCBasedColorSpaceA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ICCProfile As String) As Long
Private Declare Function pdfCreateICCBasedColorSpaceW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ICCProfile As String) As Long
Private Declare Function pdfCreateImpDataActionA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DataFile As String) As Long
Private Declare Function pdfCreateImpDataActionW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DataFile As String) As Long
Private Declare Function pdfCreateIndexedColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Base As Long, ByVal Handle As Long, ByRef ColorTable() As Byte, ByVal NumColors As Long) As Long
Private Declare Function pdfCreateJSActionA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Script As String) As Long
Private Declare Function pdfCreateJSActionW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Script As String) As Long
Private Declare Function pdfCreateLaunchAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OP As Long, ByVal FileName As String, ByVal DefDir As String, ByVal Param As String, ByVal NewWindow As Long) As Long
Private Declare Function pdfCreateListBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Sort As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateNamedAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Action As Long) As Long
Private Declare Function pdfCreateNamedDestA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal DestPage As Long, ByVal DestType As TDestType, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
Private Declare Function pdfCreateNamedDestW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal DestPage As Long, ByVal DestType As TDestType, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
Private Declare Function pdfCreateNewPDFA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OutPDF As String) As Long
Private Declare Function pdfCreateNewPDFW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OutPDF As String) As Long
Private Declare Function pdfCreateOCGA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal DisplayInUI As Long, ByVal Visible As Long, ByVal Intent As TOCGIntent) As Long
Private Declare Function pdfCreateOCGW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal DisplayInUI As Long, ByVal Visible As Long, ByVal Intent As TOCGIntent) As Long
Private Declare Function pdfCreateOCMD Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Visibility As TOCVisibility, ByRef OCGs As Any, ByVal Count As Long) As Long
Private Declare Function pdfCreateRadialShading Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal sx As Double, ByVal sy As Double, ByVal R1 As Double, ByVal eX As Double, ByVal eY As Double, ByVal R2 As Double, ByVal SCenter As Double, ByVal SColor As Long, ByVal EColor As Long, ByVal Extend1 As Long, ByVal Extend2 As Long) As Long
Private Declare Function pdfCreateRadioButton Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal ExpValue As String, ByVal Checked As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateResetAction Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfCreateSeparationCS Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Colorant As String, ByVal Alternate As Long, ByVal Handle As Long, ByVal Color As Long) As Long
Private Declare Function pdfCreateSigField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateSigFieldAP Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal SigField As Long) As Long
Private Declare Function pdfCreateSetOCGStateAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal On_ As Long, ByVal OnCount As Long, ByVal Off As Long, ByVal OffCount As Long, ByVal Toggle As Long, ByVal ToggleCount As Long, ByVal PreserveRB As Long) As Long
Private Declare Function pdfCreateStdPattern Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Pattern As Long, ByVal LineWidth As Double, ByVal distance As Double, ByVal LineColor As Long, ByVal BackColor As Long) As Long
Private Declare Function pdfCreateStructureTree Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfCreateSubmitAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long, ByVal URL As String) As Long
Private Declare Function pdfCreateTextField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Parent As Long, ByVal Multiline As Long, ByVal MaxLen As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfCreateURIAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal URL As String) As Long
Private Declare Function pdfDecryptPDFA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal Password As String) As Long
Private Declare Function pdfDecryptPDFW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal Password As String) As Long
Private Declare Sub pdfDeleteAcroForm Lib "dynapdf.dll" (ByVal IPDF As Long)
Private Declare Function pdfDeleteActionFromObj Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal ActHandle As Long, ByVal ObjHandle As Long) As Long
Private Declare Function pdfDeleteActionFromObjEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal ObjHandle As Long, ByVal ActIndex As Long) As Long
Private Declare Function pdfDeleteAnnotation Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfDeleteBookmark Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ABmk As Long) As Long
Private Declare Function pdfDeleteEmbeddedFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfDeleteField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfDeleteFieldEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String) As Long
Private Declare Sub pdfDeleteJavaScripts Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DelJavaScriptActions As Long)
Private Declare Function pdfDeletePage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long) As Long
Private Declare Sub pdfDeletePageLabels Lib "dynapdf.dll" (ByVal IPDF As Long)
Private Declare Function pdfDeletePDF Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfDeleteSeparationInfo Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AllPages As Long) As Long
Private Declare Function pdfDeleteTemplate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfDeleteTemplateEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long) As Long
Private Declare Sub pdfDeleteXFAForm Lib "dynapdf.dll" (ByVal IPDF As Long)
Private Declare Function pdfDrawArc Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal StartAngle As Double, ByVal EndAngle As Double) As Long
Private Declare Function pdfDrawArcEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double) As Long
Private Declare Function pdfDrawChord Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfDrawCircle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfDrawPie Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfEditPage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long) As Long
Private Declare Function pdfEditTemplate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long) As Long
Private Declare Function pdfEditTemplate2 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfEllipse Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfEncryptPDFA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As Long, ByVal Restrict As Long) As Long
Private Declare Function pdfEncryptPDFW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As Long, ByVal Restrict As Long) As Long
Private Declare Function pdfEndContinueText Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfEndLayer Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfEndPage Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfEndPattern Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfEndTemplate Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfEnumDocFonts Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal EnumProc As Long) As Long
Private Declare Function pdfEnumHostFonts Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal EnumProc As Long) As Long
Private Declare Function pdfEnumHostFontsEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal EnumProc As Long) As Long
Private Declare Function pdfExchangeBookmarks Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Bmk1 As Long, ByVal Bmk2 As Long) As Long
Private Declare Function pdfExchangePages Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal First As Long, ByVal Second As Long) As Long
Private Declare Function pdfFileAttachAnnotA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Icon As Long, ByVal Author As String, ByVal Desc As String, ByVal AFile As String, ByVal Compress As Long) As Long
Private Declare Function pdfFileAttachAnnotW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Icon As Long, ByVal Author As String, ByVal Desc As String, ByVal AFile As String, ByVal Compress As Long) As Long
Private Declare Function pdfFileLinkA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal AFilePath As String) As Long
Private Declare Function pdfFileLinkW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal AFilePath As String) As Long
Private Declare Function pdfFindBookmarkA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DestPage As Long, ByVal Title As String) As Long
Private Declare Function pdfFindBookmarkW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DestPage As Long, ByVal Title As String) As Long
Private Declare Function pdfFindFieldA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String) As Long
Private Declare Function pdfFindFieldW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String) As Long
Private Declare Function pdfFindLinkAnnot Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal URL As String) As Long
Private Declare Function pdfFindNextBookmark Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfFinishSignature Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef PKCS7Obj As Any, ByVal Length As Long) As Long
Private Declare Function pdfFlattenAnnots Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long) As Long
Private Declare Function pdfFlattenForm Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfFlushPageContent Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfFreePDF Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfFreeTextAnnotA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal AText As String, ByVal Align As Long) As Long
Private Declare Function pdfFreeTextAnnotW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal AText As String, ByVal Align As Long) As Long
Private Declare Function pdfFreeUniBuf Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetActionCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetActionType Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ActHandle As Long) As Long
Private Declare Function pdfGetActionTypeEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal ObjHandle As Long, ByVal ActIndex As Long) As Long
Private Declare Function pdfGetActiveFont Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetAllocBy Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetAnnot Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Annot As TPDFAnnotation_I) As Long
Private Declare Function pdfGetAnnotBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef BBox As TPDFRect) As Long
Private Declare Function pdfGetAnnotCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetAnnotEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Annot As TPDFAnnotationEx_I) As Long
Private Declare Function pdfGetAnnotFlags Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetAnnotLink Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfGetAnnotType Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfGetAscent Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Boundary As Long, ByRef BBox As TPDFRect) As Long
Private Declare Function pdfGetBidiMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetBookmark Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Bmk As TBookmark_I) As Long
Private Declare Function pdfGetBookmarkCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetBorderStyle Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetBuffer Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef BufSize As Long) As Long
Private Declare Function pdfGetCapHeight Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetCharacterSpacing Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetCheckBoxChar Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetCheckBoxCharEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AField As Long) As Long
Private Declare Function pdfGetCheckBoxDefState Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetCMap Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef CMap As TPDFCMap_I) As Long
Private Declare Function pdfGetCMapCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetColorSpaceCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetColorSpaceObj Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef CS As TPDFColorSpaceObj_I) As Long
Private Declare Function pdfGetColorSpaceObjEx Lib "dynapdf.dll" (ByVal IColorSpace As Long, ByRef CS As TPDFColorSpaceObj_I) As Long
Private Declare Function pdfGetCompressionFilter Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetCompressionLevel Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetContent Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Long) As Long
Private Declare Function pdfGetDefBitsPerPixel Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetDescent Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetDeviceNAttributes Lib "dynapdf.dll" (ByVal IAttributes As Long, ByRef Attributes As TDeviceNAttributes_I) As Long
Private Declare Function pdfGetDocInfo Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByRef Value As Long) As Long
Private Declare Function pdfGetDocInfoCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetDocInfoEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef DInfo As Long, ByRef Key As Long, ByRef Value As Long, ByRef Unicode As Long) As Long
Private Declare Function pdfGetDrawDirection Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetDynaPDFVersion Lib "dynapdf.dll" () As Long
Private Declare Function pdfGetEmbeddedFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef FileSpec As TPDFFileSpec_I, ByVal Decompress As Long) As Long
Private Declare Function pdfGetEmbeddedFileCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetEMFPatternDistance Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetErrorMessage Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetErrorMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Field As TPDFField_I) As Long
Private Declare Function pdfGetFieldBackColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFieldBorderColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFieldBorderStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldBorderWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Double
Private Declare Function pdfGetFieldChoiceValue Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ValIndex As Long, ByRef Value As TPDFChoiceValue_I) As Long
Private Declare Function pdfGetFieldColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ColorType As Long, ByRef ColorSpace As Long, ByRef Color As Long) As Long
Private Declare Function pdfGetFieldCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFieldEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Field As TPDFFieldEx_I) As Long
Private Declare Function pdfGetFieldEx2 Lib "dynapdf.dll" (ByVal IField As Long, ByRef Field As TPDFFieldEx_I) As Long
Private Declare Function pdfGetFieldExpValCount Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldExpValue Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef Value As Long) As Long
Private Declare Function pdfGetFieldExpValueEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ValIndex As Long, ByRef Value As Long, ByRef ExpValue As Long, ByRef Selected As Long) As Long
Private Declare Function pdfGetFieldFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldGroupType Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldHighlightMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldIndex Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldMapName Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef Value As Long, ByRef bUnicode As Long) As Long
Private Declare Function pdfGetFieldName Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef Name As Long) As Long
Private Declare Function pdfGetFieldOrientation Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldTextAlign Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFieldTextColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFieldToolTip Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef Value As Long, ByRef bUnicode As Long) As Long
Private Declare Function pdfGetFieldType Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long) As Long
Private Declare Function pdfGetFillColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFontCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFontEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Font As TPDFFontObj_I) As Long
Private Declare Function pdfGetFontOrigin Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Sub pdfGetFontSearchOrder Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Order As Any)
Private Declare Function pdfGetFontSelMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFontWeight Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetFTextHeightA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Align As Long, ByVal AText As String) As Double
Private Declare Function pdfGetFTextHeightW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Align As Long, ByVal AText As String) As Double
Private Declare Function pdfGetFTextHeightExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Width As Double, ByVal Align As Long, ByVal AText As String) As Double
Private Declare Function pdfGetFTextHeightExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Width As Double, ByVal Align As Long, ByVal AText As String) As Double
Private Declare Function pdfGetGStateFlags Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetIconColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetImageCount Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String) As Long
Private Declare Function pdfGetImageHeight Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfGetImageWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfGetImportFlags Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long, ByVal Boundary As Long, ByRef BBox As TPDFRect) As Long
Private Declare Function pdfGetInDocInfo Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByRef Value As Long) As Long
Private Declare Function pdfGetInDocInfoCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInDocInfoEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef DInfo As Long, ByRef Key As Long, ByRef Value As Long, ByRef Unicode As Long) As Long
Private Declare Function pdfGetInEncryptionFlags Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInIsCollection Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInIsEncrypted Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInIsSigned Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInIsTrapped Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInIsXFAForm Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInNamedDest Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef Dest As TPDFNamedDest_I) As Long
Private Declare Function pdfGetInNamedDestCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInOrientation Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long) As Long
Private Declare Function pdfGetInPageCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInPDFVersion Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetInPrintSettings Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Settings As TPDFPrintSettings_I) As Long
Private Declare Function pdfGetIsFixedPitch Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetItalicAngle Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetJavaScript Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef sLen As Long, ByRef bUnicode As Long) As Long
Private Declare Function pdfGetJavaScriptAction Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef sLen As Long, ByRef bUnicode As Long) As Long
Private Declare Function pdfGetJavaScriptAction2 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal ObjHandle As Long, ByVal ActIndex As Long, ByRef sLen As Long, ByRef bUnicode As Long, ByRef ObjEvent As Long) As Long
Private Declare Function pdfGetJavaScriptCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetJavaScriptEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByRef sLen As Long, ByRef bUnicode As Long) As Long
Private Declare Function pdfGetJavaScriptName Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef NameLen As Long, ByRef Unicode As Long) As Long
Private Declare Function pdfGetJPEGQuality Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetLanguage Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetLastTextPosX Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetLastTextPosY Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetLeading Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetLineCapStyle Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetLineJoinStyle Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetLineWidth Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetLinkHighlightMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetLogMetafileSize Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByRef r As TRectL) As Long
Private Declare Function pdfGetLogMetafileSizeEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByRef r As TRectL) As Long
Private Declare Function pdfGetMatrix Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM) As Long
Private Declare Function pdfGetMaxFieldLen Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TxtField As Long) As Long
Private Declare Function pdfGetMetaConvFlags Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetMissingGlyphs Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Count As Long) As Long
Private Declare Function pdfGetMiterLimit Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetNeedAppearance Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetObjActionCount Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ObjType As Long, ByVal ObjHandle As Long) As Long
Private Declare Function pdfGetOpacity Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetOrientation Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageAnnot Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Annot As TPDFAnnotation_I) As Long
Private Declare Function pdfGetPageAnnotCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageAnnotEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByRef Annot As TPDFAnnotationEx_I) As Long
Private Declare Function pdfGetPageCoords Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef Field As TPDFField_I) As Long
Private Declare Function pdfGetPageFieldCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageFieldEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef Field As TPDFFieldEx_I) As Long
Private Declare Function pdfGetPageHeight Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetPageLabel Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Index As Long, ByRef Lbl As TPDFPageLabel_I) As Long
Private Declare Function pdfGetPageLabelCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageLayout Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageNum Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPageText Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfGetPageWidth Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetPDFVersion Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetPrintSettings Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Settings As TPDFPrintSettings_I) As Long
Private Declare Function pdfGetResolution Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetSaveNewImageFormat Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetStrokeColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetTabLen Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetTemplCount Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetTemplHeight Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Double
Private Declare Function pdfGetTemplWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Double
Private Declare Function pdfGetTextDrawMode Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetTextFieldValue Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef Value As Long, ByRef ValIsUnicode As Long, ByRef DefValue As Long, ByRef DefValIsUnicode As Long) As Long
Private Declare Function pdfGetTextRect Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef PosX As Double, ByRef PosY As Double, ByRef Width As Double, ByRef Height As Double) As Long
Private Declare Function pdfGetTextRise Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetTextScaling Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfGetTextWidthA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Double
Private Declare Function pdfGetTextWidthW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Double
Private Declare Function pdfGetTextWidthExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String, ByVal sLen As Long) As Double
Private Declare Function pdfGetTextWidthExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String, ByVal sLen As Long) As Double
Private Declare Function pdfGetTransparentColor Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetTrapped Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseExactPwd Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseGlobalImpFiles Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUserRights Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseStdFonts Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseSystemFonts Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseTransparency Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetUseVisibleCoords Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetViewerPrefrences Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Preference As Long, ByRef AddVal As Long) As Long
Private Declare Function pdfGetWMFDefExtent Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Width As Long, ByRef Height As Long) As Long
Private Declare Function pdfGetWMFPixelPerInch Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfGetWordSpacing Lib "dynapdf.dll" (ByVal IPDF As Long) As Double
Private Declare Function pdfHaveOpenDoc Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfHighlightAnnotA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Subtype As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Color As Long, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
Private Declare Function pdfHighlightAnnotW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Subtype As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Color As Long, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
Private Declare Function pdfImportBookmarks Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfImportCatalogObjects Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfImportDocInfo Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfImportPage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long) As Long
Private Declare Function pdfImportPageEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageNum As Long, ByVal ScaleX As Double, ByVal ScaleY As Double) As Long
Private Declare Function pdfImportPDFFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DestPage As Long, ByVal ScaleX As Double, ByVal ScaleY As Double) As Long
Private Declare Function pdfInitExtGState Lib "dynapdf.dll" (ByRef GS As TPDFExtGState) As Long
Private Declare Function pdfInitStack Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfInsertBMPFromBuffer Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByRef Buffer As Any) As Long
Private Declare Function pdfInsertBMPFromHandle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal hBitmap As Long) As Long
Private Declare Function pdfInsertImage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal AFile As String) As Long
Private Declare Function pdfInsertImageEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal AFile As String, ByVal Index As Long) As Long
Private Declare Function pdfInsertImageFromBuffer Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByRef Buffer As Any, ByVal BufSize As Long, ByVal Index As Long) As Long
Private Declare Function pdfInsertMetafile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertMetafileEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertMetafileExt Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertMetafileExtEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertMetafileFromHandle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal hEnhMetafile As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertMetafileFromHandleEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal hEnhMetafile As Long, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfInsertRawImage Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BitsPerPixel As Long, ByVal ColorCount As Long, ByVal ImgWidth As Long, ByVal ImgHeight As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Long
Private Declare Function pdfIsBidiText Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String) As Long
Private Declare Function pdfIsColorPage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal GrayIsColor As Long) As Long
Private Declare Function pdfIsEmptyPage Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfLineTo Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double) As Long
Private Declare Function pdfLoadCMap Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CMapName As String, ByVal Embed As Long) As Long
Private Declare Function pdfLoadFDFDataA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal Password As String, ByVal Flags As Long) As Long
Private Declare Function pdfLoadFDFDataW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal Password As String, ByVal Flags As Long) As Long
Private Declare Function pdfLoadFDFDataEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal Password As String, ByVal Flags As Long) As Long
Private Declare Function pdfLoadFont Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal Style As Long, ByVal Size As Double, ByVal Embed As Long, ByVal CP As Long) As Long
Private Declare Function pdfMovePage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Source As Long, ByVal Dest As Long) As Long
Private Declare Function pdfMoveTo Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double) As Long
Private Declare Function pdfNewPDF Lib "dynapdf.dll" () As Long
Private Declare Function pdfOpenImportBuffer Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal PwdType As Long, ByVal Password As String) As Long
Private Declare Function pdfOpenImportFileA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal Password As String) As Long
Private Declare Function pdfOpenImportFileW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal Password As String) As Long
Private Declare Function pdfOpenOutputFileA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OutPDF As String) As Long
Private Declare Function pdfOpenOutputFileW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OutPDF As String) As Long
Private Declare Function pdfOpenTagA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Tag As Long, ByVal Lang As String, ByVal AltText As String, ByVal Expansion As String) As Long
Private Declare Function pdfOpenTagW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Tag As Long, ByVal Lang As String, ByVal AltText As String, ByVal Expansion As String) As Long
Private Declare Function pdfPageLink Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal DestPage As Long) As Long
Private Declare Function pdfPageLink2 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal NamedDest As Long) As Long
Private Declare Function pdfPageLinkEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal DestType As Long, ByVal DestPage As Long, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
Private Declare Function pdfPlaceImage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ImgHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Long
Private Declare Function pdfPlaceSigFieldValidateIcon Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal SigField As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfPlaceTemplate Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TmplHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Long
Private Declare Function pdfPlaceTemplateEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TmplHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Long
Private Declare Function pdfReadImageFormat Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByRef Width As Long, ByRef Height As Long, ByRef BitsPerPixel As Long, ByRef UseZip As Long) As Long
Private Declare Function pdfReadImageFormat2 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal Index As Long, ByRef Width As Long, ByRef Height As Long, ByRef BitsPerPixel As Long, ByRef UseZip As Long) As Long
Private Declare Function pdfReadImageFormatEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal hBitmap As Long, ByRef Width As Long, ByRef Height As Long, ByRef BitsPerPixel As Long, ByRef UseZip As Long) As Long
Private Declare Function pdfReadImageFormatFromBuffer Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal Index As Long, ByRef Width As Long, ByRef Height As Long, ByRef BitsPerPixel As Long, ByRef UseZip As Long) As Long
Private Declare Function pdfReadImageResolution Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal Index As Long, ByRef resX As Long, ByRef resY As Long) As Long
Private Declare Function pdfReadImageResolutionEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long, ByVal Index As Long, ByRef resX As Long, ByRef resY As Long) As Long
Private Declare Function pdfRectangle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfReEncryptPDFA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal InPwd As String, ByVal NewOpenPwd As String, ByVal NewOwnerPwd As String, ByVal NewKeyLen As Long, ByVal Restrict As Long) As Long
Private Declare Function pdfReEncryptPDFW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal FileName As String, ByVal PwdType As Long, ByVal InPwd As String, ByVal NewOpenPwd As String, ByVal NewOwnerPwd As String, ByVal NewKeyLen As Long, ByVal Restrict As Long) As Long
Private Declare Function pdfRenameSpotColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Colorant As String, ByVal NewName As String) As Long
Private Declare Function pdfReplaceFontA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PDFFont As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal NameIsFamilyName As Long) As Long
Private Declare Function pdfReplaceFontW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PDFFont As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal NameIsFamilyName As Long) As Long
Private Declare Function pdfReplaceFontExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PDFFont As Long, ByVal FontFile As String, ByVal Embed As Long) As Long
Private Declare Function pdfReplaceFontExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PDFFont As Long, ByVal FontFile As String, ByVal Embed As Long) As Long
Private Declare Function pdfReplaceICCProfileA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColorSpace As Long, ByVal ICCFile As String) As Long
Private Declare Function pdfReplaceICCProfileW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColorSpace As Long, ByVal ICCFile As String) As Long
Private Declare Function pdfReplacePageTextA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal NewText As String, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfReplacePageTextExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal NewText As String, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfReplacePageTextExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal NewText As String, ByRef Stack As TPDFStack_I) As Long
Private Declare Function pdfResetLineDashPattern Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfRestoreGraphicState Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfRotateCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal alpha As Double, ByVal OriginX As Double, ByVal OriginY As Double) As Long
Private Declare Function pdfRoundRect Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Radius As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfRoundRectEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal rWidth As Double, ByVal rHeight As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfSaveGraphicState Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfScaleCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal sx As Double, ByVal sy As Double) As Long
Private Declare Function pdfSelfTest Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfSet3DAnnotProps Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Annot As Long, ByVal ActType As Long, ByVal DeActType As Long, ByVal InstType As Long, ByVal DeInstType As Long, ByVal DisplToolbar As Long, ByVal DisplModelTree As Long) As Long
Private Declare Function pdfSet3DAnnotScriptA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Annot As Long, ByVal Value As String, ByVal sLen As Long) As Long
Private Declare Function pdfSetAllocBy Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetAnnotBorderStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Style As TBorderStyle) As Long
Private Declare Function pdfSetAnnotBorderWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal LineWidth As Double) As Long
Private Declare Function pdfSetAnnotColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal ColorType As TAnnotColor, ByVal CS As TPDFColorSpace, ByVal Color As Long) As Long
Private Declare Function pdfSetAnnotFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long) As Long
Private Declare Function pdfSetAnnotFlagsEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Flags As Long) As Long
Private Declare Function pdfSetAnnotHighlightMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Mode As THighlightMode) As Long
Private Declare Function pdfSetAnnotIcon Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Icon As TAnnotIcon) As Long
Private Declare Function pdfSetAnnotOpenState Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfSetAnnotStringA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal StringType As Long, ByVal Value As String) As Long
Private Declare Function pdfSetAnnotStringW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal StringType As Long, ByVal Value As String) As Long
Private Declare Function pdfSetAnnotSubjectA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Value As String) As Long
Private Declare Function pdfSetAnnotSubjectW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long, ByVal Value As String) As Long
Private Declare Function pdfSetBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Boundary As Long, ByVal LeftX As Double, ByVal LeftY As Double, ByVal RightX As Double, ByVal RightY As Double) As Long
Private Declare Function pdfSetBidiMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetBookmarkDest Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ABmk As Long, ByVal DestType As Long, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
Private Declare Function pdfSetBookmarkStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ABmk As Long, ByVal Style As Long, ByVal RGBColor As Long) As Long
Private Declare Function pdfSetBorderStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Style As Long) As Long
Private Declare Function pdfSetCharacterSpacing Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetCheckBoxChar Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CheckBoxChar As Long) As Long
Private Declare Function pdfSetCheckBoxDefState Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Checked As Long) As Long
Private Declare Function pdfSetCheckBoxState Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Checked As Long) As Long
Private Declare Function pdfSetCIDFontA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CMapHandle As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Long) As Long
Private Declare Function pdfSetCIDFontW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CMapHandle As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Long) As Long
Private Declare Function pdfSetCMapDirA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Path As String, ByVal Recursive As Long) As Long
Private Declare Function pdfSetCMapDirW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Path As String, ByVal Recursive As Long) As Long
Private Declare Function pdfSetColDefFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal EmbFile As Long) As Long
Private Declare Function pdfSetColors Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColorSpace As Long) As Long
Private Declare Function pdfSetColSortField Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ColField As Long, ByVal AscendingOrder As Long) As Long
Private Declare Function pdfSetCompressionFilter Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ComprFilter As Long) As Long
Private Declare Function pdfSetCompressionLevel Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal CompressLevel As Long) As Long
Private Declare Function pdfSetContent Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Buffer As Any, ByVal BufSize As Long) As Long
Private Declare Function pdfSetDateTimeFormat Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TxtField As Long, ByVal Fmt As Long) As Long
Private Declare Function pdfSetDefBitsPerPixel Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetDocInfoA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByVal Value As String) As Long
Private Declare Function pdfSetDocInfoW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByVal Value As String) As Long
Private Declare Function pdfSetDocInfoExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByVal Key As String, ByVal Value As String) As Long
Private Declare Function pdfSetDocInfoExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DInfo As Long, ByVal Key As String, ByVal Value As String) As Long
Private Declare Function pdfSetDrawDirection Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Direction As Long) As Long
Private Declare Function pdfSetEMFFrameDPI Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal DPIX As Long, ByVal DPIY As Long) As Long
Private Declare Function pdfSetEMFPatternDistance Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetErrorMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ErrMode As Long) As Long
Private Declare Function pdfSetExtColorSpace Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfSetExtGState Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfSetFieldBackColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AColor As Long) As Long
Private Declare Function pdfSetFieldBBox Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByRef BBox As TPDFRect) As Long
Private Declare Function pdfSetFieldBorderColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AColor As Long) As Long
Private Declare Function pdfSetFieldBorderStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Style As Long) As Long
Private Declare Function pdfSetFieldBorderWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal LineWidth As Double) As Long
Private Declare Function pdfSetFieldColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ColorType As Long, ByVal CS As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetFieldExpValue Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal ValIndex As Long, ByVal Value As String, ByVal ExpValue As String, ByVal Selected As Long) As Long
Private Declare Function pdfSetFieldFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Flags As Long, ByVal DoReset As Long) As Long
Private Declare Function pdfSetFieldFontSize Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal FontSize As Double) As Long
Private Declare Function pdfSetFieldHighlightMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetFieldIndex Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Index As Long) As Long
Private Declare Function pdfSetFieldMapNameA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetFieldMapNameW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetFieldName Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal NewName As String) As Long
Private Declare Function pdfSetFieldOrientation Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetFieldTextAlign Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Align As Long) As Long
Private Declare Function pdfSetFieldTextColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetFieldToolTipA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetFieldToolTipW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetFillColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetFillColorEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Color As Any, ByVal NumComponents As Long) As Long
Private Declare Function pdfSetFontA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Style As Long, ByVal Size As Double, ByVal Embed As Long, ByVal CP As Long) As Long
Private Declare Function pdfSetFontW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Style As Long, ByVal Size As Double, ByVal Embed As Long, ByVal CP As Long) As Long
Private Declare Function pdfSetFontExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Style As Long, ByVal Size As Double, ByVal Embed As Long, ByVal CP As Long) As Long
Private Declare Function pdfSetFontExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Name As String, ByVal Style As Long, ByVal Size As Double, ByVal Embed As Long, ByVal CP As Long) As Long
Private Declare Function pdfSetFontOrigin Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Origin As Long) As Long
Private Declare Sub pdfSetFontSearchOrder Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Order As Any)
Private Declare Function pdfSetFontSelMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetFontWeight Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Weight As Long) As Long
Private Declare Sub pdfSetGStateFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long, ByVal Reset As Long)
Private Declare Function pdfSetIconColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetImportFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long) As Long
Private Declare Function pdfSetImportFlags2 Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long) As Long
Private Declare Function pdfSetItalicAngle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Angle As Double) As Long
Private Declare Function pdfSetJPEGQuality Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetLanguage Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal ISOTag As String) As Long
Private Declare Function pdfSetLeading Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetLicenseKey Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As String) As Long
Private Declare Function pdfSetLineCapStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Style As Long) As Long
Private Declare Function pdfSetLineDashPattern Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Dash As String, ByVal Phase As Long) As Long
Private Declare Function pdfSetLineDashPatternEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Dash As Any, ByVal NumValues As Long, ByVal Phase As Long) As Long
Private Declare Function pdfSetLineJoinStyle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Style As Long) As Long
Private Declare Function pdfSetLineWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetLinkHighlightMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetListFont Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Handle As Long) As Long
Private Declare Function pdfSetMaxFieldLen Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TxtField As Long, ByVal MaxLen As Long) As Long
Private Declare Function pdfSetMatrix Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM) As Long
Private Declare Function pdfSetMetaConvFlags Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Flags As Long) As Long
Private Declare Function pdfSetMiterLimit Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetNeedAppearance Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetNumberFormat Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TxtField As Long, ByVal Sep As Long, ByVal DecPlaces As Long, ByVal NegStyle As Long, ByVal CurrStr As String, ByVal Prepend As Long) As Long
Private Declare Function pdfSetOnErrorProc Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal ErrProc As Long) As Long
Private Declare Function pdfSetOnPageBreakProc Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal OnBreakProc As Long) As Long
Private Declare Function pdfSetOpacity Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetOrientation Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetOrientationEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetPageCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PageCoords As Long) As Long
Private Declare Function pdfSetPageFormat Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetPageHeight Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetPageLayout Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Layout As Long) As Long
Private Declare Function pdfSetPageMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetPageWidth Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetPDFVersion Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Version As Long) As Long
Private Declare Function pdfSetPrintSettings Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long, ByVal PickTrayByPDFSize As Long, ByVal NumCopies As Long, ByVal PrintScaling As Long, ByVal PrintRanges As Long, ByVal NumRanges As Long) As Long
Private Declare Function pdfSetProgressProc Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Data As Long, ByVal InitProgress As Long, ByVal Progress As Long) As Long
Private Declare Function pdfSetResolution Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetSaveNewImageFormat Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetStrokeColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Color As Long) As Long
Private Declare Function pdfSetStrokeColorEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Color As Any, ByVal NumComponents As Long) As Long
Private Declare Function pdfSetTabLen Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal TabLen As Long) As Long
Private Declare Function pdfSetTextDrawMode Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Mode As Long) As Long
Private Declare Function pdfSetTextFieldValueA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String, ByVal DefValue As String, ByVal Align As Long) As Long
Private Declare Function pdfSetTextFieldValueW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String, ByVal DefValue As String, ByVal Align As Long) As Long
Private Declare Function pdfSetTextFieldValueExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetTextFieldValueExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Field As Long, ByVal Value As String) As Long
Private Declare Function pdfSetTextRect Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
Private Declare Function pdfSetTextRise Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetTextScaling Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSetTransparentColor Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AColor As Long) As Long
Private Declare Sub pdfSetTrapped Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long)
Private Declare Function pdfSetUseExactPwd Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetUseGlobalImpFiles Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetUseStdFonts Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetUseSwapFile Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal SwapContents As Long, ByVal SwapLimit As Long) As Long
Private Declare Function pdfSetUseSwapFileEx Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal SwapContents As Long, ByVal SwapLimit As Long, ByVal SwapDir As String) As Long
Private Declare Function pdfSetUseSystemFonts Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetUseTransparency Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetUseVisibleCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetViewerPreferences Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long, ByVal AddVal As Long) As Long
Private Declare Function pdfSetWMFDefExtent Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Width As Long, ByVal Height As Long) As Long
Private Declare Function pdfSetWMFPixelPerInch Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Long) As Long
Private Declare Function pdfSetWordSpacing Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Value As Double) As Long
Private Declare Function pdfSkewCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal alpha As Double, ByVal beta As Double, ByVal OriginX As Double, ByVal OriginY As Double) As Long
Private Declare Function pdfSortFieldsByIndex Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfSortFieldsByName Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfStampAnnotA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Subtype As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
Private Declare Function pdfStampAnnotW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Subtype As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
Private Declare Function pdfStrokePath Lib "dynapdf.dll" (ByVal IPDF As Long) As Long
Private Declare Function pdfTextAnnotA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Text As String, ByVal Icon As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfTextAnnotW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Text As String, ByVal Icon As Long, ByVal DoOpen As Long) As Long
Private Declare Function pdfTranslateCoords Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal OriginX As Double, ByVal OriginY As Double) As Long
Private Declare Function pdfTriangle Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double, ByVal FillMode As Long) As Long
Private Declare Function pdfWebLinkA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal URL As String) As Long
Private Declare Function pdfWebLinkW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal URL As String) As Long
Private Declare Function pdfWriteAngleTextA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String, ByVal Angle As Double, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal YOrigin As Double) As Long
Private Declare Function pdfWriteAngleTextW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal AText As String, ByVal Angle As Double, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal YOrigin As Double) As Long
Private Declare Function pdfWriteFTextA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Align As Long, ByVal AText As String) As Long
Private Declare Function pdfWriteFTextW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal Align As Long, ByVal AText As String) As Long
Private Declare Function pdfWriteFTextExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Align As Long, ByVal AText As String) As Long
Private Declare Function pdfWriteFTextExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Align As Long, ByVal AText As String) As Long
Private Declare Function pdfWriteTextA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String) As Long
Private Declare Function pdfWriteTextW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String) As Long
Private Declare Function pdfWriteTextExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String, ByVal sLen As Long) As Long
Private Declare Function pdfWriteTextExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String, ByVal sLen As Long) As Long
Private Declare Function pdfWriteTextMatrixA Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM, ByVal AText As String) As Long
Private Declare Function pdfWriteTextMatrixW Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM, ByVal AText As String) As Long
Private Declare Function pdfWriteTextMatrixExA Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM, ByVal AText As String, ByVal sLen As Long) As Long
Private Declare Function pdfWriteTextMatrixExW Lib "dynapdf.dll" (ByVal IPDF As Long, ByRef Matrix As TCTM, ByVal AText As String, ByVal sLen As Long) As Long

Private Declare Function MultiByteToWideChar Lib "kernel32.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cbMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long


Private Sub Class_Initialize()
   m_Instance = pdfNewPDF
   If m_Instance = 0 Then
      MsgBox "Out of Memory!", vbExclamation, "Fatal error!"
      Exit Sub
   End If
   pdfSetOnErrorProc m_Instance, ObjPtr(Me), AddressOf pdf_ErrorProc
   pdfSetProgressProc m_Instance, ObjPtr(Me), AddressOf pdf_InitProgress, AddressOf pdf_Progress
End Sub

Private Sub Class_Terminate()
   If pdfDeletePDF(m_Instance) <> 1 Then
      MsgBox "Cannot delete PDF instance!", vbExclamation, "Fatal error!"
   End If
End Sub

Friend Function AddActionToObj(ByVal ObjType As TObjType, ByVal ObjEvent As TObjEvent, ByVal ActHandle As Long, ByVal ObjHandle As Long) As Long
   AddActionToObj = pdfAddActionToObj(m_Instance, ObjType, ObjEvent, ActHandle, ObjHandle)
End Function

Friend Function AddArticle(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   AddArticle = pdfAddArticle(m_Instance, PosX, PosY, Width, Height) <> 0
End Function

Friend Function AddBookmarkA(ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Boolean) As Long
   AddBookmarkA = pdfAddBookmarkA(m_Instance, Title, Parent, DestPage, DoOpen)
End Function

Friend Function AddBookmarkW(ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Boolean) As Long
   Dim s As String
   s = StrConv(Title, vbUnicode)
   AddBookmarkW = pdfAddBookmarkW(m_Instance, s, Parent, DestPage, DoOpen)
End Function

Friend Function AddBookmarkExA(ByVal Title As String, ByVal Parent As Long, ByVal NamedDest As Long, ByVal DoOpen As Long) As Long
   AddBookmarkExA = pdfAddBookmarkExA(m_Instance, Title, Parent, NamedDest, CInt(DoOpen))
End Function

Friend Function AddBookmarkExW(ByVal Title As String, ByVal Parent As Long, ByVal NamedDest As Long, ByVal DoOpen As Long) As Long
   Dim s As String
   s = StrConv(Title, vbUnicode)
   AddBookmarkExW = pdfAddBookmarkExW(m_Instance, s, Parent, NamedDest, CInt(DoOpen))
End Function

Friend Function AddButtonImage(ByVal BtnHandle As Long, ByVal State As TButtonState, ByVal Caption As String, ByVal ImgFile As String) As Boolean
   AddButtonImage = pdfAddButtonImage(m_Instance, BtnHandle, State, Caption, ImgFile) <> 0
End Function

Friend Function AddButtonImageEx(ByVal BtnHandle As Long, ByVal State As TButtonState, ByVal Caption As String, ByVal hBitmap As Long) As Boolean
   AddButtonImageEx = pdfAddButtonImageEx(m_Instance, BtnHandle, State, Caption, hBitmap) <> 0
End Function

Friend Function AddContinueTextA(ByVal AText As String) As Boolean
   AddContinueTextA = pdfAddContinueTextA(m_Instance, AText) <> 0
End Function

Friend Function AddContinueTextW(ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   AddContinueTextW = pdfAddContinueTextW(m_Instance, s) <> 0
End Function

Friend Function AddDeviceNProcessColorants(ByVal DeviceNCS As Long, ByRef Colorants() As String, ByVal NumColorants As Long, ByVal ProcessCS As TExtColorSpace, ByVal Handle As Long) As Boolean
   Dim i As Long
   Dim c() As String
   ReDim c(NumColorants - 1)
   For i = 0 To NumColorants - 1
      c(i) = StrConv(Colorants(i), vbFromUnicode)
   Next i
   AddDeviceNProcessColorants = pdfAddDeviceNProcessColorants(m_Instance, DeviceNCS, VarPtr(c(0)), NumColorants, ProcessCS, Handle) <> 0
End Function

Friend Function AddDeviceNSeparations(ByVal DeviceNCS As Long, ByRef Colorants() As String, ByRef SeparationCS() As Long, ByVal NumColorants As Long) As Boolean
   Dim i As Long
   Dim c() As String
   ReDim c(NumColorants - 1)
   For i = 0 To NumColorants - 1
      c(i) = StrConv(Colorants(i), vbFromUnicode)
   Next i
   AddDeviceNSeparations = pdfAddDeviceNSeparations(m_Instance, DeviceNCS, VarPtr(c(0)), VarPtr(SeparationCS(0)), NumColorants) <> 0
End Function

Friend Function AddFieldToFormAction(ByVal Action As Long, ByVal Field As Long, ByVal DoInclude As Boolean) As Boolean
   AddFieldToFormAction = pdfAddFieldToFormAction(m_Instance, Action, Field, DoInclude) <> 0
End Function

Friend Function AddFieldToHideAction(ByVal HideAct As Long, ByVal Field As Long) As Boolean
   AddFieldToHideAction = pdfAddFieldToHideAction(m_Instance, HideAct, Field) <> 0
End Function

Friend Function AddFileCommentA(ByVal AText As String) As Boolean
   AddFileCommentA = pdfAddFileCommentA(m_Instance, AText) <> 0
End Function

Friend Function AddFileCommentW(ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   AddFileCommentW = pdfAddFileCommentW(m_Instance, s) <> 0
End Function

Friend Function AddFontSearchPathA(ByVal APath As String, ByVal Recursive As Boolean) As Long
   AddFontSearchPathA = pdfAddFontSearchPathA(m_Instance, APath, Recursive)
End Function

Friend Function AddFontSearchPathW(ByVal APath As String, ByVal Recursive As Boolean) As Long
   Dim s As String
   s = StrConv(APath, vbUnicode)
   AddFontSearchPathW = pdfAddFontSearchPathW(m_Instance, s, Recursive)
End Function

Friend Function AddJavaScriptA(ByVal Name As String, ByVal Script As String) As Long
   AddJavaScriptA = pdfAddJavaScriptA(m_Instance, Name, Script)
End Function

Friend Function AddJavaScriptW(ByVal Name As String, ByVal Script As String) As Long
   Dim s As String
   s = StrConv(Script, vbUnicode)
   AddJavaScriptW = pdfAddJavaScriptW(m_Instance, Name, s)
End Function

Friend Function AddObjectToLayer(ByVal OCG As Long, ByVal ObjType As TOCObject, ByVal Handle As Long) As Boolean
   AddObjectToLayer = pdfAddObjectToLayer(m_Instance, OCG, ObjType, Handle) <> 0
End Function

Friend Function AddPageLabelA(ByVal StartRange As Long, ByVal Format As TPageLabelFormat, ByVal Prefix As String, ByVal AddNum As Long) As Long
   AddPageLabelA = pdfAddPageLabelA(m_Instance, StartRange, Format, Prefix, AddNum)
End Function

Friend Function AddPageLabelW(ByVal StartRange As Long, ByVal Format As TPageLabelFormat, ByVal Prefix As String, ByVal AddNum As Long) As Long
   Dim s As String
   s = StrConv(Prefix, vbUnicode)
   AddPageLabelW = pdfAddPageLabelW(m_Instance, StartRange, Format, s, AddNum)
End Function

Friend Function AddRenderingIntentA(ByVal ICCFile As String) As Long
   AddRenderingIntentA = pdfAddRenderingIntentA(m_Instance, ICCFile)
End Function
Friend Function AddRenderingIntentW(ByVal ICCFile As String) As Long
   Dim s As String
   s = StrConv(ICCFile, vbUnicode)
   AddRenderingIntentW = pdfAddRenderingIntentW(m_Instance, s)
End Function

Friend Function AddRenderingIntentEx(ByRef Buffer() As Byte) As Long
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   AddRenderingIntentEx = pdfAddRenderingIntentEx(m_Instance, Buffer(0), BufSize + 1)
End Function

Friend Function AddValToChoiceFieldA(ByVal Field As Long, ByVal ExpValue As String, ByVal Value As String, ByVal Selected As Boolean) As Boolean
   AddValToChoiceFieldA = pdfAddValToChoiceFieldA(m_Instance, Field, ExpValue, Value, Selected) <> 0
End Function

Friend Function AddValToChoiceFieldW(ByVal Field As Long, ByVal ExpValue As String, ByVal Value As String, ByVal Selected As Boolean) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   AddValToChoiceFieldW = pdfAddValToChoiceFieldW(m_Instance, Field, ExpValue, s, Selected) <> 0
End Function

Friend Function Append() As Boolean
   Append = pdfAppend(m_Instance) <> 0
End Function

Friend Function ApplyPattern(ByVal PattHandle As Long, ByVal ColorMode As TColorMode, ByVal Color As Long) As Boolean
   ApplyPattern = pdfApplyPattern(m_Instance, PattHandle, ColorMode, Color) <> 0
End Function

Friend Function ApplyShading(ByVal ShadHandle As Long) As Boolean
   ApplyShading = pdfApplyShading(m_Instance, ShadHandle) <> 0
End Function

Friend Function AttachFileA(ByVal FilePath As String, ByVal Description As String, ByVal Compress As Boolean) As Long
   AttachFileA = pdfAttachFileA(m_Instance, FilePath, Description, Compress)
End Function

Friend Function AttachFileW(ByVal FilePath As String, ByVal Description As String, ByVal Compress As Boolean) As Long
   Dim s1 As String, s2 As String
   s1 = StrConv(FilePath, vbUnicode)
   s2 = StrConv(Description, vbUnicode)
   AttachFileW = pdfAttachFileW(m_Instance, s1, s2, Compress)
End Function

Friend Function AttachFileExA(ByRef Buffer() As Byte, ByVal FileName As String, ByVal Description As String, ByVal Compress As Boolean) As Long
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   AttachFileExA = pdfAttachFileExA(m_Instance, Buffer(0), BufSize + 1, FileName, Description, Compress)
End Function

Friend Function AttachFileExW(ByRef Buffer() As Byte, ByVal FileName As String, ByVal Description As String, ByVal Compress As Boolean) As Long
   Dim BufSize As Long
   Dim s1 As String, s2 As String
   s1 = StrConv(FileName, vbUnicode)
   s2 = StrConv(Description, vbUnicode)
   BufSize = UBound(Buffer)
   AttachFileExW = pdfAttachFileExW(m_Instance, Buffer(0), BufSize + 1, s1, s2, Compress)
End Function

Friend Function AutoTemplate(ByVal Templ As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   AutoTemplate = pdfAutoTemplate(m_Instance, Templ, PosX, PosY, Width, Height) <> 0
End Function

Friend Function BeginClipPath() As Boolean
   BeginClipPath = True ' Obsolete function! Nothing to do.
End Function

Friend Function BeginContinueText(ByVal PosX As Double, ByVal PosY As Double) As Boolean
   BeginContinueText = pdfBeginContinueText(m_Instance, PosX, PosY) <> 0
End Function

Friend Function BeginLayer(ByVal OCG As Long) As Long
   BeginLayer = pdfBeginLayer(m_Instance, OCG)
End Function

Friend Function BeginPattern(ByVal PatternType As TPatternType, ByVal TilingType As TTilingType, ByVal Width As Double, ByVal Height As Double) As Long
   BeginPattern = pdfBeginPattern(m_Instance, PatternType, TilingType, Width, Height)
End Function

Friend Function BeginTemplate(ByVal Width As Double, ByVal Height As Double) As Long
   BeginTemplate = pdfBeginTemplate(m_Instance, Width, Height)
End Function

Friend Function Bezier_1_2_3(ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double) As Boolean
   Bezier_1_2_3 = pdfBezier_1_2_3(m_Instance, x1, y1, x2, y2, x3, y3) <> 0
End Function

Friend Function Bezier_1_3(ByVal x1 As Double, ByVal y1 As Double, ByVal x3 As Double, ByVal y3 As Double) As Boolean
   Bezier_1_3 = pdfBezier_1_3(m_Instance, x1, y1, x3, y3) <> 0
End Function

Friend Function Bezier_2_3(ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double) As Boolean
   Bezier_2_3 = pdfBezier_2_3(m_Instance, x2, y2, x3, y3) <> 0
End Function

Friend Function CalcWidthHeight(ByVal OrgWidth As Double, ByVal OrgHeight As Double, ByVal ScaledWidth As Double, ByVal ScaledHeight As Double) As Double
   CalcWidthHeight = pdfCalcWidthHeight(m_Instance, OrgWidth, OrgHeight, ScaledWidth, ScaledHeight)
End Function

Friend Function ChangeAnnotNameA(ByVal Handle As Long, ByVal Name As String) As Boolean
   ChangeAnnotNameA = pdfChangeAnnotNameA(m_Instance, Handle, Name) <> 0
End Function

Friend Function ChangeAnnotNameW(ByVal Handle As Long, ByVal Name As String) As Boolean
   Dim s As String
   s = StrConv(Name, vbUnicode)
   ChangeAnnotNameW = pdfChangeAnnotNameW(m_Instance, Handle, s) <> 0
End Function

Friend Function ChangeAnnotPos(ByVal Handle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   ChangeAnnotPos = pdfChangeAnnotPos(m_Instance, Handle, PosX, PosY, Width, Height) <> 0
End Function

Friend Function ChangeBookmarkA(ByVal ABmk As Long, ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Boolean) As Boolean
   ChangeBookmarkA = pdfChangeBookmarkA(m_Instance, ABmk, Title, Parent, DestPage, DoOpen) <> 0
End Function

Friend Function ChangeBookmarkW(ByVal ABmk As Long, ByVal Title As String, ByVal Parent As Long, ByVal DestPage As Long, ByVal DoOpen As Boolean) As Boolean
   Dim s As String
   s = StrConv(Title, vbUnicode)
   ChangeBookmarkW = pdfChangeBookmarkW(m_Instance, ABmk, s, Parent, DestPage, DoOpen) <> 0
End Function

Friend Function ChangeFont(ByVal Handle As Long) As Boolean
   ChangeFont = pdfChangeFont(m_Instance, Handle) <> 0
End Function

Friend Function ChangeFontSize(ByVal Size As Double) As Boolean
   ChangeFontSize = pdfChangeFontSize(m_Instance, Size) <> 0
End Function

Friend Function ChangeFontStyle(ByVal Style As TFStyle) As Boolean
   ChangeFontStyle = pdfChangeFontStyle(m_Instance, Style) <> 0
End Function

Friend Function ChangeFontStyleEx(ByVal Style As TFStyle) As Boolean
   ChangeFontStyleEx = pdfChangeFontStyleEx(m_Instance, Style) <> 0
End Function

Friend Function ChangeJavaScriptA(ByVal Handle As Long, ByVal NewScript As String) As Boolean
   ChangeJavaScriptA = pdfChangeJavaScriptA(m_Instance, Handle, NewScript) <> 0
End Function

Friend Function ChangeJavaScriptW(ByVal Handle As Long, ByVal NewScript As String) As Boolean
   Dim s As String
   s = StrConv(NewScript, vbUnicode)
   ChangeJavaScriptW = pdfChangeJavaScriptW(m_Instance, Handle, s) <> 0
End Function

Friend Function ChangeJavaScriptActionA(ByVal Handle As Long, ByVal NewScript As String) As Boolean
   ChangeJavaScriptActionA = pdfChangeJavaScriptActionA(m_Instance, Handle, NewScript) <> 0
End Function

Friend Function ChangeJavaScriptActionW(ByVal Handle As Long, ByVal NewScript As String) As Boolean
   Dim s As String
   s = StrConv(NewScript, vbUnicode)
   ChangeJavaScriptActionW = pdfChangeJavaScriptActionW(m_Instance, Handle, s) <> 0
End Function

Friend Function ChangeJavaScriptNameA(ByVal Handle As Long, ByVal Name As String) As Long
   ChangeJavaScriptNameA = pdfChangeJavaScriptNameA(m_Instance, Handle, Name)
End Function

Friend Function ChangeJavaScriptNameW(ByVal Handle As Long, ByVal Name As String) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   ChangeJavaScriptNameW = pdfChangeJavaScriptNameW(m_Instance, Handle, s)
End Function

Friend Function ChangeLinkAnnot(ByVal Handle As Long, ByVal URL As String) As Boolean
    ChangeLinkAnnot = pdfChangeLinkAnnot(m_Instance, Handle, URL) <> 0
End Function

Friend Function CheckCollection() As Boolean
   CheckCollection = pdfCheckCollection(m_Instance) <> 0
End Function

Friend Function CheckConformance(ByVal ConfType As TConformanceType, ByVal Options As TCheckOptions, ByVal UserData As Long, ByVal OnFontNotFoundProc As Long, ByVal OnReplaceICCProfile As Long) As Long
   CheckConformance = pdfCheckConformance(m_Instance, ConfType, Options, UserData, OnFontNotFoundProc, OnReplaceICCProfile)
End Function

Friend Function CheckFieldNames() As Long
   CheckFieldNames = pdfCheckFieldNames(m_Instance)
End Function

Friend Function ClearAutoTemplates() As Boolean
   ClearAutoTemplates = pdfClearAutoTemplates(m_Instance) <> 0
End Function

Friend Function ClearHostFonts() As Boolean
   ClearHostFonts = pdfClearHostFonts(m_Instance) <> 0
End Function

Friend Function ClipPath(ByVal ClipMode As TClippingMode, ByVal FillMode As TPathFillMode) As Boolean
   ClipPath = pdfClipPath(m_Instance, ClipMode, FillMode) <> 0
End Function

Friend Function CloseAndSignFile(ByVal CertFile As String, ByVal Password As String, ByVal Reason As String, ByVal Location As String) As Boolean
   CloseAndSignFile = pdfCloseAndSignFile(m_Instance, CertFile, Password, Reason, Location) <> 0
End Function

Friend Function CloseAndSignFileEx(ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As TKeyLen, ByVal Restrict As TRestrictions, ByVal CertFile As String, ByVal Password As String, ByVal Reason As String, ByVal Location As String) As Boolean
   CloseAndSignFileEx = pdfCloseAndSignFileEx(m_Instance, OpenPwd, OwnerPwd, KeyLen, Restrict, CertFile, Password, Reason, Location) <> 0
End Function

Friend Function CloseAndSignFileExt(ByRef SigParms As TPDFSigParms) As Boolean
   Dim p As TPDFSigParms_I
   p.StructSize = LenB(p)
   p.ContactInfoW = StrPtr(SigParms.ContactInfo)
   p.Encrypt = SigParms.Encrypt
   p.KeyLen = SigParms.KeyLen
   p.HashType = SigParms.HashType
   p.LocationW = StrPtr(SigParms.Location)
   p.OpenPwd = SigParms.OpenPwd
   p.OwnerPwd = SigParms.OwnerPwd
   p.PKCS7ObjLen = SigParms.PKCS7ObjLen
   p.ReasonW = StrPtr(SigParms.Reason)
   p.SignerW = StrPtr(SigParms.Signer)
   p.Restrict = SigParms.Restrict
   If pdfCloseAndSignFileExt(m_Instance, p) = 0 Then Exit Function
   ReDim SigParms.Range1(p.Range1Len - 1)
   pdfCopyMem2 p.Range1, SigParms.Range1(0), p.Range1Len
   If p.Range2Len > 0 Then
      ReDim SigParms.Range2(p.Range2Len - 1)
      pdfCopyMem2 p.Range2, SigParms.Range2(0), p.Range2Len
   Else
      Erase SigParms.Range2
   End If
   CloseAndSignFileExt = True
End Function

Friend Function CloseFile() As Boolean
   CloseFile = pdfCloseFile(m_Instance) <> 0
End Function

Friend Function CloseFileEx(ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As TKeyLen, ByVal Restrict As TRestrictions) As Boolean
   CloseFileEx = pdfCloseFileEx(m_Instance, OpenPwd, OwnerPwd, KeyLen, Restrict) <> 0
End Function

Friend Function CloseImportFile() As Boolean
   CloseImportFile = pdfCloseImportFile(m_Instance) <> 0
End Function

Friend Function ClosePath(ByVal FillMode As TPathFillMode) As Boolean
   ClosePath = pdfClosePath(m_Instance, FillMode) <> 0
End Function

Friend Function CloseTag() As Boolean
   CloseTag = pdfCloseTag(m_Instance) <> 0
End Function

Friend Function CMYK(c As Byte, m As Byte, y As Byte, K As Byte) As Long
   If c >= &H80 Then
      CMYK = K Or (y * &H100&) Or (m * &H10000) Or ((c And &H7F) * &H1000000) Or &H80000000
   Else
      CMYK = K Or (y * &H100&) Or (m * &H10000) Or (c * &H1000000)
   End If
End Function

Friend Function ComputeBBox(ByRef BBox As TPDFRect, ByVal Flags As TCompBBoxFlags) As Boolean
   ComputeBBox = pdfComputeBBox(m_Instance, BBox, Flags) <> 0
End Function

Friend Sub ConnectPageBreakEvent(ByVal Connect As Boolean)
   If Connect Then
      pdfSetOnPageBreakProc m_Instance, ObjPtr(Me), AddressOf pdf_OnPageBreakProc
   Else
      pdfSetOnPageBreakProc m_Instance, 0&, 0&
   End If
End Sub

Friend Function ConvertColors(ByVal Flags As TColorConvFlags) As Boolean
   ConvertColors = pdfConvertColors(m_Instance, Flags, 0) <> 0
End Function

Friend Function ConvToUnicode(ByVal AString As String, ByVal CP As TCodepage) As String
   Dim ptr As Long
   ptr = pdfConvToUnicode(m_Instance, AString, CP)
   ConvToUnicode = ToString1(ptr, True)
End Function

Friend Function Create3DAnnot(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Name As String, ByVal U3DFile As String, ByVal Image As String) As Long
   Create3DAnnot = pdfCreate3DAnnot(m_Instance, PosX, PosY, Width, Height, Author, Name, U3DFile, Image)
End Function

Friend Function Create3DBackground(ByVal IView As Long, ByVal BackColor As Long) As Boolean
   Create3DBackground = pdfCreate3DBackground(m_Instance, IView, BackColor) <> 0
End Function

Friend Function Create3DGotoViewAction(ByVal Base3DAnnot As Long, ByVal IView As Long, ByVal Named As T3DNamedAction) As Long
   Create3DGotoViewAction = pdfCreate3DGotoViewAction(m_Instance, Base3DAnnot, IView, Named)
End Function

Friend Function Create3DProjection(ByVal IView As Long, ByVal ProjType As T3DProjType, ByVal ScaleType As T3DScaleType, ByVal Diameter As Double, ByVal FOV As Double) As Boolean
   Create3DProjection = pdfCreate3DProjection(m_Instance, IView, ProjType, ScaleType, Diameter, FOV) <> 0
End Function

Friend Function Create3DView(ByVal Base3DAnnot As Long, ByVal Name As String, ByVal SetAsDefault As Boolean, ByRef Matrix() As Double, ByVal CamDistance As Double, ByVal RM As T3DRenderingMode, ByVal LS As T3DLightingSheme) As Long
   On Error GoTo errf
   If UBound(Matrix) < 11 Then
      Create3DView = pdfCreate3DView(m_Instance, Base3DAnnot, Name, SetAsDefault, ByVal 0&, CamDistance, RM, LS)
   Else
      Create3DView = pdfCreate3DView(m_Instance, Base3DAnnot, Name, SetAsDefault, Matrix(0), CamDistance, RM, LS)
   End If
   Exit Function
errf:
   Create3DView = pdfCreate3DView(m_Instance, Base3DAnnot, Name, SetAsDefault, ByVal 0&, CamDistance, RM, LS)
   Resume Next
End Function

Friend Function CreateAnnotAP(ByVal Annot As Long) As Long
   CreateAnnotAP = pdfCreateAnnotAP(m_Instance, Annot)
End Function

Friend Function CreateArticleThreadA(ByVal ThreadName As String) As Long
   CreateArticleThreadA = pdfCreateArticleThreadA(m_Instance, ThreadName)
End Function

Friend Function CreateArticleThreadW(ByVal ThreadName As String) As Long
   Dim s As String
   s = StrConv(ThreadName, vbUnicode)
   CreateArticleThreadW = pdfCreateArticleThreadW(m_Instance, s)
End Function

Friend Function CreateAxialShading(ByVal sx As Double, ByVal sy As Double, ByVal eX As Double, ByVal eY As Double, ByVal SCenter As Double, ByVal SColor As Long, ByVal EColor As Long, ByVal Extend1 As Long, ByVal Extend2 As Long) As Long
   CreateAxialShading = pdfCreateAxialShading(m_Instance, sx, sy, eX, eY, SCenter, SColor, EColor, Extend1, Extend2)
End Function

Friend Function CreateButtonA(ByVal Name As String, ByVal Caption As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateButtonA = pdfCreateButtonA(m_Instance, Name, Caption, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateButtonW(ByVal Name As String, ByVal Caption As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   Dim s As String
   s = StrConv(Caption, vbUnicode)
   CreateButtonW = pdfCreateButtonW(m_Instance, Name, s, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateCheckBox(ByVal Name As String, ByVal ExpValue As String, ByVal Checked As Boolean, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateCheckBox = pdfCreateCheckBox(m_Instance, Name, ExpValue, Checked, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateCIEColorSpace(ByVal Base As TExtColorSpace, ByRef WhitePoint() As Single, ByRef BlackPoint() As Single, ByRef Gamma() As Single, ByRef Matrix() As Single) As Long
   CreateCIEColorSpace = pdfCreateCIEColorSpace(m_Instance, Base, VarPtr(WhitePoint(0)), VarPtr(BlackPoint(0)), VarPtr(Gamma(0)), VarPtr(Matrix(0)))
End Function

Friend Function CreateCollection(ByVal View As TColView) As Boolean
   CreateCollection = pdfCreateCollection(m_Instance, View) <> 0
End Function

Friend Function CreateCollectionFieldA(ByVal ColType As TColColumnType, ByVal Column As Long, ByVal Name As String, ByVal Key As String, ByVal Visible As Boolean, ByVal Editable As Boolean) As Long
   CreateCollectionFieldA = pdfCreateCollectionFieldA(m_Instance, ColType, Column, Name, Key, Visible, Editable)
End Function

Friend Function CreateCollectionFieldW(ByVal ColType As TColColumnType, ByVal Column As Long, ByVal Name As String, ByVal Key As String, ByVal Visible As Boolean, ByVal Editable As Boolean) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   CreateCollectionFieldW = pdfCreateCollectionFieldW(m_Instance, ColType, Column, s, Key, Visible, Editable)
End Function

Friend Function CreateColItemDate(ByVal EmbFile As Long, ByVal Key As String, ByVal DateVal As Long, ByVal Prefix As String) As Boolean
   CreateColItemDate = pdfCreateColItemDate(m_Instance, EmbFile, Key, DateVal, Prefix) <> 0
End Function

Friend Function CreateColItemNumber(ByVal EmbFile As Long, ByVal Key As String, ByVal Value As Double, ByVal Prefix As String) As Boolean
   CreateColItemNumber = pdfCreateColItemNumber(m_Instance, EmbFile, Key, Value, Prefix) <> 0
End Function

Friend Function CreateColItemStringA(ByVal EmbFile As Long, ByVal Key As String, ByVal Value As String, ByVal Prefix As String) As Boolean
   CreateColItemStringA = pdfCreateColItemStringA(m_Instance, EmbFile, Key, Value, Prefix) <> 0
End Function

Friend Function CreateColItemStringW(ByVal EmbFile As Long, ByVal Key As String, ByVal Value As String, ByVal Prefix As String) As Boolean
   Dim s1 As String, s2 As String
   s1 = StrConv(Value, vbUnicode)
   s2 = StrConv(Prefix, vbUnicode)
   CreateColItemStringW = pdfCreateColItemStringW(m_Instance, EmbFile, Key, s1, s2) <> 0
End Function

Friend Function CreateComboBox(ByVal Name As String, ByVal Sort As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateComboBox = pdfCreateComboBox(m_Instance, Name, Sort, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateDeviceNColorSpace(ByRef Colorants() As String, ByVal PostScriptFunc As String, ByVal Alternate As TExtColorSpace, ByVal Handle As Long) As Long
   Dim i As Long
   Dim c() As String
   ReDim c(UBound(Colorants))
   For i = 0 To UBound(Colorants)
      c(i) = StrConv(Colorants(i), vbFromUnicode)
   Next i
   CreateDeviceNColorSpace = pdfCreateDeviceNColorSpace(m_Instance, VarPtr(c(0)), UBound(Colorants) + 1, PostScriptFunc, Alternate, Handle)
   Erase c
End Function

Friend Function CreateExtGState(ByRef GS As TPDFExtGState) As Long
   CreateExtGState = pdfCreateExtGState(m_Instance, GS)
End Function

Friend Function CreateGoToAction(ByVal DestType As TDestType, ByVal PageNum As Long, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
   CreateGoToAction = pdfCreateGoToAction(m_Instance, DestType, PageNum, a, b, c, d)
End Function

Friend Function CreateGoToActionEx(ByVal NamedDest As Long) As Long
   CreateGoToActionEx = pdfCreateGoToActionEx(m_Instance, NamedDest)
End Function

Friend Function CreateGoToRAction(ByVal FileName As String, ByVal PageNum As Long) As Long
   CreateGoToRAction = pdfCreateGoToRAction(m_Instance, FileName, PageNum)
End Function

Friend Function CreateGoToRActionExA(ByVal FileName As String, ByVal DestName As String, ByVal NewWindow As Boolean) As Long
   CreateGoToRActionExA = pdfCreateGoToRActionExA(m_Instance, FileName, DestName, NewWindow)
End Function

Friend Function CreateGoToRActionExW(ByVal FileName As String, ByVal DestName As String, ByVal NewWindow As Boolean) As Long
   Dim s As String
   s = StrConv(DestName, vbUnicode)
   CreateGoToRActionExW = pdfCreateGoToRActionExW(m_Instance, FileName, s, NewWindow)
End Function

Friend Function CreateGroupField(ByVal Name As String, ByVal Parent As Long) As Long
   CreateGroupField = pdfCreateGroupField(m_Instance, Name, Parent)
End Function

Friend Function CreateHideAction(ByVal Field As Long, ByVal Hide As Long) As Long
   CreateHideAction = pdfCreateHideAction(m_Instance, Field, Hide)
End Function

Friend Function CreateICCBasedColorSpaceA(ByVal ICCProfile As String) As Long
   CreateICCBasedColorSpaceA = pdfCreateICCBasedColorSpaceA(m_Instance, ICCProfile)
End Function

Friend Function CreateICCBasedColorSpaceW(ByVal ICCProfile As String) As Long
   Dim s As String
   s = StrConv(ICCProfile, vbUnicode)
   CreateICCBasedColorSpaceW = pdfCreateICCBasedColorSpaceW(m_Instance, s)
End Function

Friend Function CreateImpDataActionA(ByVal DataFile As String) As Long
   CreateImpDataActionA = pdfCreateImpDataActionA(m_Instance, DataFile)
End Function

Friend Function CreateImpDataActionW(ByVal DataFile As String) As Long
   Dim s As String
   s = StrConv(DataFile, vbUnicode)
   CreateImpDataActionW = pdfCreateImpDataActionW(m_Instance, s)
End Function

Friend Function CreateIndexedColorSpace(ByVal Base As TExtColorSpace, ByVal Handle As Long, ByRef ColorTable() As Byte, ByVal NumColors As Long) As Long
   CreateIndexedColorSpace = pdfCreateIndexedColorSpace(m_Instance, Base, Handle, ColorTable, NumColors)
End Function

Friend Function CreateJSActionA(ByVal Script As String) As Long
   CreateJSActionA = pdfCreateJSActionA(m_Instance, Script)
End Function

Friend Function CreateJSActionW(ByVal Script As String) As Long
   Dim s As String
   s = StrConv(Script, vbUnicode)
   CreateJSActionW = pdfCreateJSActionW(m_Instance, s)
End Function

Friend Function CreateLaunchAction(ByVal OP As TFileOP, ByVal FileName As String, ByVal DefDir As String, ByVal Param As String, ByVal NewWindow As Long) As Long
   CreateLaunchAction = pdfCreateLaunchAction(m_Instance, OP, FileName, DefDir, Param, NewWindow)
End Function

Friend Function CreateListBox(ByVal Name As String, ByVal Sort As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateListBox = pdfCreateListBox(m_Instance, Name, Sort, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateNamedAction(ByVal Action As TNamedAction) As Long
   CreateNamedAction = pdfCreateNamedAction(m_Instance, Action)
End Function

Friend Function CreateNamedDestA(ByVal Name As String, ByVal DestPage As Long, ByVal DestType As TDestType, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
   CreateNamedDestA = pdfCreateNamedDestA(m_Instance, Name, DestPage, DestType, a, b, c, d)
End Function

Friend Function CreateNamedDestW(ByVal Name As String, ByVal DestPage As Long, ByVal DestType As TDestType, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   CreateNamedDestW = pdfCreateNamedDestW(m_Instance, s, DestPage, DestType, a, b, c, d)
End Function

Friend Function CreateNewPDFA(ByVal OutPDF As String) As Boolean
   CreateNewPDFA = pdfCreateNewPDFA(m_Instance, OutPDF) <> 0
End Function

Friend Function CreateNewPDFW(ByVal OutPDF As String) As Boolean
   Dim s As String
   s = StrConv(OutPDF, vbUnicode)
   CreateNewPDFW = pdfCreateNewPDFW(m_Instance, s) <> 0
End Function

Friend Function CreateOCGA(ByVal Name As String, ByVal DisplayInUI As Boolean, ByVal Visible As Boolean, ByVal Intent As TOCGIntent) As Long
   CreateOCGA = pdfCreateOCGA(m_Instance, Name, DisplayInUI, Visible, Intent)
End Function

Friend Function CreateOCGW(ByVal Name As String, ByVal DisplayInUI As Boolean, ByVal Visible As Boolean, ByVal Intent As TOCGIntent) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   CreateOCGW = pdfCreateOCGW(m_Instance, s, DisplayInUI, Visible, Intent)
End Function

Friend Function CreateOCMD(ByVal Visibility As TOCVisibility, ByRef OCGs() As Long) As Long
   CreateOCMD = pdfCreateOCMD(m_Instance, Visibility, OCGs(0), UBound(OCGs) + 1)
End Function

Friend Function CreateRadialShading(ByVal sx As Double, ByVal sy As Double, ByVal R1 As Double, ByVal eX As Double, ByVal eY As Double, ByVal R2 As Double, ByVal SCenter As Double, ByVal SColor As Long, ByVal EColor As Long, ByVal Extend1 As Long, ByVal Extend2 As Long) As Long
   CreateRadialShading = pdfCreateRadialShading(m_Instance, sx, sy, R1, eX, eY, R2, SCenter, SColor, EColor, Extend1, Extend2)
End Function

Friend Function CreateRadioButton(ByVal Name As String, ByVal ExpValue As String, ByVal Checked As Long, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateRadioButton = pdfCreateRadioButton(m_Instance, Name, ExpValue, Checked, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateResetAction() As Long
   CreateResetAction = pdfCreateResetAction(m_Instance)
End Function

Friend Function CreateSeparationCS(ByVal Colorant As String, ByVal Alternate As TExtColorSpace, ByVal Handle As Long, ByVal Color As Long) As Long
   CreateSeparationCS = pdfCreateSeparationCS(m_Instance, Colorant, Alternate, Handle, Color)
End Function

Friend Function CreateSetOCGStateAction(ByRef On_() As Long, ByRef Off() As Long, ByRef Toggle() As Long, ByVal PreserveRB As Boolean) As Long
   ' An empty array must be a non initialized variable, e.g. Dim n() as Long.
   On Error Resume Next
   Dim numOn As Long
   Dim onPtr As Long
   Dim numOff As Long
   Dim offPtr As Long
   Dim numToggle As Long
   Dim togglePtr As Long

   numOn = UBound(On_) + 1
   onPtr = VarPtr(On_(0))
   numOff = UBound(Off) + 1
   offPtr = VarPtr(Off(0))
   numToggle = UBound(Toggle) + 1
   togglePtr = VarPtr(Toggle(0))

   CreateSetOCGStateAction = pdfCreateSetOCGStateAction(m_Instance, onPtr, numOn, offPtr, numOff, togglePtr, numToggle, PreserveRB)
End Function

Friend Function CreateSigField(ByVal Name As String, ByVal Parent As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateSigField = pdfCreateSigField(m_Instance, Name, Parent, PosX, PosY, Width, Height)
End Function

Friend Function CreateSigFieldAP(ByVal SigField As Long) As Long
   CreateSigFieldAP = pdfCreateSigFieldAP(m_Instance, SigField)
End Function

Friend Function CreateStdPattern(ByVal Pattern As TStdPattern, ByVal LineWidth As Double, ByVal distance As Double, ByVal LineColor As Long, ByVal BackColor As Long) As Long
   CreateStdPattern = pdfCreateStdPattern(m_Instance, Pattern, LineWidth, distance, LineColor, BackColor)
End Function

Friend Function CreateStructureTree() As Boolean
   CreateStructureTree = pdfCreateStructureTree(m_Instance) <> 0
End Function

Friend Function CreateSubmitAction(ByVal Flags As TSubmitFlags, ByVal URL As String) As Long
   CreateSubmitAction = pdfCreateSubmitAction(m_Instance, Flags, URL)
End Function

Friend Function CreateTextField(ByVal Name As String, ByVal Parent As Long, ByVal Multiline As Long, ByVal MaxLen As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Long
   CreateTextField = pdfCreateTextField(m_Instance, Name, Parent, Multiline, MaxLen, PosX, PosY, Width, Height)
End Function

Friend Function CreateURIAction(ByVal URL As String) As Long
   CreateURIAction = pdfCreateURIAction(m_Instance, URL)
End Function

Friend Function DecryptPDFA(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal Password As String) As Long
   DecryptPDFA = pdfDecryptPDFA(m_Instance, FileName, PwdType, Password)
End Function

Friend Function DecryptPDFW(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal Password As String) As Long
   Dim s As String
   s = StrConv(FileName, vbUnicode)
   DecryptPDFW = pdfDecryptPDFW(m_Instance, s, PwdType, Password)
End Function

Friend Sub DeleteAcroForm()
   pdfDeleteAcroForm m_Instance
End Sub

Friend Function DeleteActionFromObj(ByVal ObjType As TObjType, ByVal ActHandle As Long, ByVal ObjHandle As Long) As Boolean
   DeleteActionFromObj = pdfDeleteActionFromObj(m_Instance, ObjType, ActHandle, ObjHandle) <> 0
End Function

Friend Function DeleteActionFromObjEx(ByVal ObjType As TObjType, ByVal ObjHandle As Long, ByVal ActIndex As Long) As Boolean
   DeleteActionFromObjEx = pdfDeleteActionFromObjEx(m_Instance, ObjType, ObjHandle, ActIndex) <> 0
End Function

Friend Function DeleteAnnotation(ByVal Handle As Long) As Boolean
   DeleteAnnotation = pdfDeleteAnnotation(m_Instance, Handle) <> 0
End Function

Friend Function DeleteBookmark(ByVal ABmk As Long) As Long
   DeleteBookmark = pdfDeleteBookmark(m_Instance, ABmk)
End Function

Friend Function DeleteEmbeddedFile(ByVal Handle As Long) As Boolean
   DeleteEmbeddedFile = pdfDeleteEmbeddedFile(m_Instance, Handle) <> 0
End Function

Friend Function DeleteField(ByVal Field As Long) As Boolean
   DeleteField = pdfDeleteField(m_Instance, Field) <> 0
End Function

Friend Function DeleteFieldEx(ByVal Name As String) As Boolean
   DeleteFieldEx = pdfDeleteFieldEx(m_Instance, Name) <> 0
End Function

Friend Sub DeleteJavaScripts(ByVal DelJavaScriptActions As Boolean)
   pdfDeleteJavaScripts m_Instance, DelJavaScriptActions
End Sub

Friend Function DeletePage(ByVal PageNum As Long) As Long
   DeletePage = pdfDeletePage(m_Instance, PageNum)
End Function

Friend Sub DeletePageLabels()
   pdfDeletePageLabels m_Instance
End Sub

Friend Function DeleteSeparationInfo(ByVal AllPages As Boolean) As Boolean
   DeleteSeparationInfo = pdfDeleteSeparationInfo(m_Instance, AllPages) <> 0
End Function

Friend Function DeleteTemplate(ByVal Handle As Long) As Boolean
   DeleteTemplate = pdfDeleteTemplate(m_Instance, Handle) <> 0
End Function

Friend Function DeleteTemplateEx(ByVal Index As Long) As Boolean
   DeleteTemplateEx = pdfDeleteTemplateEx(m_Instance, Index) <> 0
End Function

Friend Sub DeleteXFAForm()
   pdfDeleteXFAForm m_Instance
End Sub

Friend Function DrawArc(ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal StartAngle As Double, ByVal EndAngle As Double) As Boolean
   DrawArc = pdfDrawArc(m_Instance, PosX, PosY, Radius, StartAngle, EndAngle) <> 0
End Function

Friend Function DrawArcEx(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double) As Boolean
   DrawArcEx = pdfDrawArcEx(m_Instance, PosX, PosY, Width, Height, StartAngle, EndAngle) <> 0
End Function

Friend Function DrawChord(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double, ByVal FillMode As TPathFillMode) As Boolean
   DrawChord = pdfDrawChord(m_Instance, PosX, PosY, Width, Height, StartAngle, EndAngle, FillMode) <> 0
End Function

Friend Function DrawCircle(ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal FillMode As TPathFillMode) As Boolean
   DrawCircle = pdfDrawCircle(m_Instance, PosX, PosY, Radius, FillMode) <> 0
End Function

Friend Function DrawPie(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal StartAngle As Double, ByVal EndAngle As Double, ByVal FillMode As TPathFillMode) As Boolean
   DrawPie = pdfDrawPie(m_Instance, PosX, PosY, Width, Height, StartAngle, EndAngle, FillMode) <> 0
End Function

Friend Function EditPage(ByVal PageNum As Long) As Boolean
   EditPage = pdfEditPage(m_Instance, PageNum) <> 0
End Function

Friend Function EditTemplate(ByVal Index As Long) As Boolean
   EditTemplate = pdfEditTemplate(m_Instance, Index) <> 0
End Function

Friend Function EditTemplate2(ByVal Handle As Long) As Boolean
   EditTemplate2 = pdfEditTemplate2(m_Instance, Handle) <> 0
End Function

Friend Function Ellipse(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal FillMode As TPathFillMode) As Boolean
   Ellipse = pdfEllipse(m_Instance, PosX, PosY, Width, Height, FillMode) <> 0
End Function

Friend Function EncryptPDFA(ByVal FileName As String, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As TKeyLen, ByVal Restrict As TRestrictions) As Long
   EncryptPDFA = pdfEncryptPDFA(m_Instance, FileName, OpenPwd, OwnerPwd, KeyLen, Restrict)
End Function

Friend Function EncryptPDFW(ByVal FileName As String, ByVal OpenPwd As String, ByVal OwnerPwd As String, ByVal KeyLen As TKeyLen, ByVal Restrict As TRestrictions) As Long
   Dim s As String
   s = StrConv(FileName, vbUnicode)
   EncryptPDFW = pdfEncryptPDFW(m_Instance, s, OpenPwd, OwnerPwd, KeyLen, Restrict)
End Function

Friend Function EndContinueText() As Boolean
   EndContinueText = pdfEndContinueText(m_Instance) <> 0
End Function

Friend Function EndLayer() As Boolean
   EndLayer = pdfEndLayer(m_Instance) <> 0
End Function

Friend Function EndPage() As Boolean
   EndPage = pdfEndPage(m_Instance) <> 0
End Function

Friend Function EndPattern() As Boolean
   EndPattern = pdfEndPattern(m_Instance) <> 0
End Function

Friend Function EndTemplate() As Boolean
   EndTemplate = pdfEndTemplate(m_Instance) <> 0
End Function

Friend Function EnumDocFonts() As Long
   EnumDocFonts = pdfEnumDocFonts(m_Instance, ObjPtr(Me), AddressOf pdf_EnumFontsProc2)
End Function

Friend Function EnumHostFonts() As Long
   EnumHostFonts = pdfEnumHostFonts(m_Instance, ObjPtr(Me), AddressOf pdf_EnumFontsProc)
End Function

Friend Function EnumHostFontsEx() As Long
   EnumHostFontsEx = pdfEnumHostFontsEx(m_Instance, ObjPtr(Me), AddressOf pdf_EnumFontsProcEx)
End Function

Friend Function ExchangeBookmarks(ByVal Bmk1 As Long, ByVal Bmk2 As Long) As Boolean
   ExchangeBookmarks = pdfExchangeBookmarks(m_Instance, Bmk1, Bmk2) <> 0
End Function

Friend Function ExchangePages(ByVal First As Long, ByVal Second As Long) As Boolean
   ExchangePages = pdfExchangePages(m_Instance, First, Second) <> 0
End Function

Friend Function FileAttachAnnotA(ByVal PosX As Double, ByVal PosY As Double, ByVal Icon As TFileAttachIcon, ByVal Author As String, ByVal Desc As String, ByVal AFile As String, ByVal Compress As Boolean) As Long
   FileAttachAnnotA = pdfFileAttachAnnotA(m_Instance, PosX, PosY, Icon, Author, Desc, AFile, Compress)
End Function

Friend Function FileAttachAnnotW(ByVal PosX As Double, ByVal PosY As Double, ByVal Icon As TFileAttachIcon, ByVal Author As String, ByVal Desc As String, ByVal AFile As String, ByVal Compress As Boolean) As Long
   Dim s1 As String, s2 As String, s3 As String
   s1 = StrConv(Author, vbUnicode)
   s2 = StrConv(Desc, vbUnicode)
   s3 = StrConv(AFile, vbUnicode)
   FileAttachAnnotW = pdfFileAttachAnnotW(m_Instance, PosX, PosY, Icon, s1, s2, s3, Compress)
End Function

Friend Function FileLinkA(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal AFilePath As String) As Long
   FileLinkA = pdfFileLinkA(m_Instance, PosX, PosY, Width, Height, AFilePath)
End Function

Friend Function FileLinkW(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal AFilePath As String) As Long
   Dim s As String
   s = StrConv(AFilePath, vbUnicode)
   FileLinkW = pdfFileLinkW(m_Instance, PosX, PosY, Width, Height, s)
End Function

Friend Function FindBookmarkA(ByVal DestPage As Long, ByVal Title As String) As Long
   FindBookmarkA = pdfFindBookmarkA(m_Instance, DestPage, Title)
End Function

Friend Function FindBookmarkW(ByVal DestPage As Long, ByVal Title As String) As Long
   Dim s As String
   s = StrConv(Title, vbUnicode)
   FindBookmarkW = pdfFindBookmarkW(m_Instance, DestPage, s)
End Function

Friend Function FindFieldA(ByVal Name As String) As Long
   FindFieldA = pdfFindFieldA(m_Instance, Name)
End Function

Friend Function FindFieldW(ByVal Name As String) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   FindFieldW = pdfFindFieldW(m_Instance, s)
End Function

Friend Function FindLinkAnnot(ByVal URL As String) As Long
    FindLinkAnnot = pdfFindLinkAnnot(m_Instance, URL)
End Function

Friend Function FindNextBookmark() As Long
   FindNextBookmark = pdfFindNextBookmark(m_Instance)
End Function

Friend Function FinishSignature(ByRef PKCS7Obj() As Byte) As Boolean
   FinishSignature = pdfFinishSignature(m_Instance, PKCS7Obj(0), UBound(PKCS7Obj) + 1) <> 0
End Function

Friend Function FlattenAnnots(ByVal Flags As TAnnotFlattenFlags) As Long
   FlattenAnnots = pdfFlattenAnnots(m_Instance, Flags)
End Function

Friend Function FlattenForm() As Boolean
   FlattenForm = pdfFlattenForm(m_Instance) <> 0
End Function

Friend Function FlushPageContent() As Boolean
   FlushPageContent = pdfFlushPageContent(m_Instance, FStack) <> 0
End Function

Friend Function FreePDF() As Boolean
   FreePDF = pdfFreePDF(m_Instance) <> 0
End Function

Friend Function FreeTextAnnotA(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal AText As String, ByVal Align As TTextAlign) As Long
   FreeTextAnnotA = pdfFreeTextAnnotA(m_Instance, PosX, PosY, Width, Height, Author, AText, Align)
End Function

Friend Function FreeTextAnnotW(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal AText As String, ByVal Align As TTextAlign) As Long
   Dim s1 As String, s2 As String
   s1 = StrConv(Author, vbUnicode)
   s2 = StrConv(AText, vbUnicode)
   FreeTextAnnotW = pdfFreeTextAnnotW(m_Instance, PosX, PosY, Width, Height, s1, s2, Align)
End Function

Friend Function FreeUniBuf() As Boolean
   FreeUniBuf = pdfFreeUniBuf(m_Instance) <> 0
End Function

Friend Function GetActionCount() As Long
   GetActionCount = pdfGetActionCount(m_Instance)
End Function

Friend Function GetActionType(ByVal ActHandle As Long) As Long
   GetActionType = pdfGetActionType(m_Instance, ActHandle)
End Function

Friend Function GetActionTypeEx(ByVal ObjType As TObjType, ByVal ObjHandle As Long, ByVal ActIndex As Long) As Long
   GetActionTypeEx = pdfGetActionTypeEx(m_Instance, ObjType, ObjHandle, ActIndex)
End Function

Friend Function GetActiveFont() As Long
   GetActiveFont = pdfGetActiveFont(m_Instance)
End Function

Friend Function GetAllocBy() As Long
   GetAllocBy = pdfGetAllocBy(m_Instance)
End Function

Friend Function GetAnnot(ByVal Handle As Long, ByRef Annot As TPDFAnnotation) As Boolean
   Dim retval As TPDFAnnotation_I
   If pdfGetAnnot(m_Instance, Handle, retval) = 0 Then Exit Function
   GetIntAnnot retval, Annot
   GetAnnot = True
End Function

Friend Function GetAnnotBBox(ByVal Handle As Long, ByRef BBox As TPDFRect) As Boolean
   GetAnnotBBox = pdfGetAnnotBBox(m_Instance, Handle, BBox) <> 0
End Function

Friend Function GetAnnotCount() As Long
   GetAnnotCount = pdfGetAnnotCount(m_Instance)
End Function

Friend Function GetAnnotEx(ByVal Handle As Long, ByRef Annot As TPDFAnnotationEx) As Boolean
   Dim retval As TPDFAnnotationEx_I
   If pdfGetAnnotEx(m_Instance, Handle, retval) = 0 Then Exit Function
   GetIntAnnotEx retval, Annot
   GetAnnotEx = True
End Function

Friend Function GetAnnotFlags() As Long
   GetAnnotFlags = pdfGetAnnotFlags(m_Instance)
End Function

Friend Function GetAnnotLink(ByVal Handle As Long) As String
   Dim ptr As Long
   ptr = pdfGetAnnotLink(m_Instance, Handle)
   GetAnnotLink = ToString1(ptr, False)
End Function

Friend Function GetAnnotType(ByVal Handle As Long) As Long
   GetAnnotType = pdfGetAnnotType(m_Instance, Handle)
End Function

Friend Function GetAscent() As Double
   GetAscent = pdfGetAscent(m_Instance)
End Function

Friend Function GetBBox(ByVal Boundary As TPageBoundary, BBox As TPDFRect) As Long
   GetBBox = pdfGetBBox(m_Instance, Boundary, BBox)
End Function

Friend Function GetBidiMode() As TPDFBidiMode
   GetBidiMode = pdfGetBidiMode(m_Instance)
End Function

Friend Function GetBookmark(ByVal Handle As Long, Bmk As TBookmark) As Boolean
   If pdfGetBookmark(m_Instance, Handle, FBookmark) = 0 Then Exit Function
   Bmk.Color = FBookmark.Color
   Bmk.DestPage = FBookmark.DestPage
   Bmk.DestPos.rBottom = FBookmark.DestPos.rBottom
   Bmk.DestPos.rLeft = FBookmark.DestPos.rLeft
   Bmk.DestPos.rRight = FBookmark.DestPos.rRight
   Bmk.DestPos.rTop = FBookmark.DestPos.rTop
   Bmk.DestType = FBookmark.DestType
   Bmk.DoOpen = FBookmark.DoOpen <> 0
   Bmk.Parent = FBookmark.Parent
   Bmk.Style = FBookmark.Style
   Bmk.Title = ToString2(FBookmark.Title, FBookmark.TitleLen, FBookmark.bUnicode <> 0)
   GetBookmark = True
End Function

Friend Function GetBookmarkCount() As Long
   GetBookmarkCount = pdfGetBookmarkCount(m_Instance)
End Function

Friend Function GetBorderStyle() As Long
   GetBorderStyle = pdfGetBorderStyle(m_Instance)
End Function

Friend Function GetBuffer() As Byte()
   Dim pBuffer As Long
   Dim BufSize As Long
   Dim retval() As Byte

   pBuffer = pdfGetBuffer(m_Instance, BufSize)
   If (BufSize = 0) Or (pBuffer = 0) Then Exit Function
   ReDim retval(BufSize - 1)
   pdfCopyMem2 pBuffer, retval(0), BufSize
   GetBuffer = retval
   pdfFreePDF m_Instance
End Function

Friend Function GetCapHeight() As Double
   GetCapHeight = pdfGetCapHeight(m_Instance)
End Function

Friend Function GetCharacterSpacing() As Double
   GetCharacterSpacing = pdfGetCharacterSpacing(m_Instance)
End Function

Friend Function GetCheckBoxChar() As Long
   GetCheckBoxChar = pdfGetCheckBoxChar(m_Instance)
End Function

Friend Function GetCheckBoxCharEx(ByVal AField As Long) As Long
   GetCheckBoxCharEx = pdfGetCheckBoxCharEx(m_Instance, AField)
End Function

Friend Function GetCheckBoxDefState(ByVal Field As Long) As Long
   GetCheckBoxDefState = pdfGetCheckBoxDefState(m_Instance, Field)
End Function

Friend Function GetCMap(ByVal Index As Long, ByRef CMap As TPDFCMap) As Boolean
   Dim m As TPDFCMap_I
   m.StructSize = LenB(m)
   If pdfGetCMap(m_Instance, Index, m) <> 0 Then
      CMap.BaseCMap = ToString1(m.BaseCMap, False)
      CMap.CIDCount = m.CIDCount
      CMap.CMapName = ToString1(m.CMapName, False)
      CMap.CMapType = m.CMapType
      CMap.CMapVersion = m.CMapVersion
      CMap.DSCBaseCMap = ToString1(m.DSCBaseCMap, False)
      CMap.DSCCMapVersion = m.DSCCMapVersion
      CMap.DSCResName = ToString1(m.DSCResName, False)
      CMap.DSCTitle = ToString1(m.DSCTitle, False)
      CMap.FileName = ToStringEx(m.FileNameA, m.FileNameW)
      CMap.FilePath = ToStringEx(m.FilePathA, m.FilePathW)
      CMap.Ordering = ToString1(m.Ordering, False)
      CMap.Registry = ToString1(m.Registry, False)
      CMap.Supplement = m.Supplement
      CMap.WritingMode = m.WritingMode
      GetCMap = True
   Else
      GetCMap = False
   End If
End Function

Friend Function GetCMapCount() As Long
   GetCMapCount = pdfGetCMapCount(m_Instance)
End Function

Friend Function GetColorSpace() As Long
   GetColorSpace = pdfGetColorSpace(m_Instance)
End Function

Friend Function GetColorSpaceCount() As Long
   GetColorSpaceCount = pdfGetColorSpaceCount(m_Instance)
End Function

Friend Function GetColorSpaceObj(ByVal Handle As Long, ByRef CS As TPDFColorSpaceObj) As Boolean
   Dim ics As TPDFColorSpaceObj_I
   If pdfGetColorSpaceObj(m_Instance, Handle, ics) = 0 Then Exit Function
   GetIntColorSpaceObj ics, CS
   GetColorSpaceObj = True
End Function

Friend Function GetColorSpaceObjEx(ByVal IColorSpace As Long, ByRef CS As TPDFColorSpaceObj) As Boolean
   Dim ics As TPDFColorSpaceObj_I
   If pdfGetColorSpaceObjEx(IColorSpace, ics) = 0 Then Exit Function
   GetIntColorSpaceObj ics, CS
   GetColorSpaceObjEx = True
End Function

Friend Function GetCompressionFilter() As Long
   GetCompressionFilter = pdfGetCompressionFilter(m_Instance)
End Function

Friend Function GetCompressionLevel() As Long
   GetCompressionLevel = pdfGetCompressionLevel(m_Instance)
End Function

Friend Function GetContent(ByRef Buffer() As Byte) As Boolean
   Dim BufSize As Long
   Dim pBuffer As Long

   BufSize = pdfGetContent(m_Instance, pBuffer)
   If BufSize < 0 Then Exit Function
   ReDim Buffer(BufSize - 1)
   pdfCopyMem2 pBuffer, Buffer(0), BufSize
   GetContent = True
End Function

Friend Function GetDefBitsPerPixel() As Long
   GetDefBitsPerPixel = pdfGetDefBitsPerPixel(m_Instance)
End Function

Friend Function GetDescent() As Double
   GetDescent = pdfGetDescent(m_Instance)
End Function

Friend Function GetDeviceNAttributes(ByVal IAttributes As Long, ByRef Attributes As TDeviceNAttributes) As Boolean
   Dim i As Long
   Dim attr As TDeviceNAttributes_I
   If pdfGetDeviceNAttributes(IAttributes, attr) = 0 Then Exit Function
   Attributes.IProcessColorSpace = attr.IProcessColorSpace
   Attributes.ProcessColorantsCount = attr.ProcessColorantsCount
   Attributes.SeparationsCount = attr.SeparationsCount
   Attributes.IMixingHints = attr.IMixingHints
   Erase Attributes.ProcessColorants
   For i = 0 To Attributes.ProcessColorantsCount - 1
      Attributes.ProcessColorants(i) = UTF8ToString(attr.ProcessColorants(i))
   Next i
   For i = 0 To Attributes.SeparationsCount - 1
      Attributes.Separations(i) = attr.Separations(i)
   Next i
   GetDeviceNAttributes = True
End Function

Friend Function GetDocInfo(ByVal DInfo As TDocumentInfo, Value As String) As Boolean
   Dim BufSize As Long
   Dim pBuffer As Long

   BufSize = pdfGetDocInfo(m_Instance, DInfo, pBuffer)
   If BufSize < 0 Then Exit Function
   Value = ToString2(pBuffer, BufSize, True)
   GetDocInfo = True
End Function

Friend Function GetDocInfoCount() As Long
   GetDocInfoCount = pdfGetDocInfoCount(m_Instance)
End Function

Friend Function GetDocInfoEx(ByVal Index As Long, ByRef DInfo As TDocumentInfo, ByRef Key As String, ByRef Value As String) As Boolean
   Dim valName As Long
   Dim keyName As Long
   Dim valLen As Long
   Dim uni As Long
   Dim info As Long

   valLen = pdfGetDocInfoEx(m_Instance, Index, info, keyName, valName, uni)
   If valLen <= 0 Then
      Key = ""
      Value = ""
      GetDocInfoEx = False
      Exit Function
   End If
   DInfo = info
   Key = ToString1(keyName, False)
   Value = ToString2(valName, valLen, uni <> 0)
   GetDocInfoEx = True
End Function

Friend Function GetDrawDirection() As Long
   GetDrawDirection = pdfGetDrawDirection(m_Instance)
End Function

Friend Function GetDynaPDFVersion() As String
   Dim ptr As Long
   ptr = pdfGetDynaPDFVersion
   GetDynaPDFVersion = ToString1(ptr, False)
End Function

Friend Function GetEmbeddedFile(ByVal Handle As Long, ByRef FileSpec As TPDFFileSpec, ByVal Decompress As Boolean) As Boolean
   Dim fSpec As TPDFFileSpec_I
   If pdfGetEmbeddedFile(m_Instance, Handle, fSpec, Decompress) = 0 Then Exit Function
   If fSpec.Buffer > 0 Then
      ReDim FileSpec.Buffer(fSpec.BufSize - 1)
      FileSpec.BufSize = fSpec.BufSize
      pdfCopyMem2 fSpec.Buffer, FileSpec.Buffer(0), fSpec.BufSize
   Else
      Erase FileSpec.Buffer
      FileSpec.BufSize = 0
   End If
   FileSpec.ColItem = fSpec.ColItem
   FileSpec.Compressed = fSpec.Compressed <> 0
   FileSpec.FileSize = fSpec.FileSize
   FileSpec.IsURL = fSpec.IsURL <> 0
   If fSpec.CheckSum <> 0 Then
      ReDim FileSpec.CheckSum(15)
      pdfCopyMem2 fSpec.CheckSum, FileSpec.CheckSum(0), 16
   Else
      Erase FileSpec.CheckSum
   End If
   FileSpec.CreateDate = ToString1(fSpec.CreateDate, False)
   FileSpec.Desc = ToString1(fSpec.Desc, fSpec.DescUnicode <> 0)
   FileSpec.FileName = ToString1(fSpec.FileName, False)
   FileSpec.MIMEType = ToString1(fSpec.MIMEType, False)
   FileSpec.ModDate = ToString1(fSpec.ModDate, False)
   FileSpec.Name = ToString1(fSpec.Name, fSpec.NameUnicode <> 0)
   FileSpec.UF = ToString1(fSpec.UF, fSpec.UFUnicode <> 0)
   GetEmbeddedFile = True
End Function

Friend Function GetEmbeddedFileCount() As Long
   GetEmbeddedFileCount = pdfGetEmbeddedFileCount(m_Instance)
End Function

Friend Function GetEMFPatternDistance() As Double
   GetEMFPatternDistance = pdfGetEMFPatternDistance(m_Instance)
End Function

Friend Function GetErrorMessage() As String
   Dim ptr As Long
   ptr = pdfGetErrorMessage(m_Instance)
   GetErrorMessage = ToString1(ptr, False)
End Function

Friend Function GetErrorMode() As Long
   GetErrorMode = pdfGetErrorMode(m_Instance)
End Function

Friend Function GetField(ByVal Handle As Long, Field As TPDFField) As Boolean
   If pdfGetField(m_Instance, Handle, FField) = 0 Then Exit Function
   GetIntField Field
   GetField = True
End Function

Friend Function GetFieldBackColor() As Long
   GetFieldBackColor = pdfGetFieldBackColor(m_Instance)
End Function

Friend Function GetFieldBorderColor() As Long
   GetFieldBorderColor = pdfGetFieldBorderColor(m_Instance)
End Function

Friend Function GetFieldBorderStyle(ByVal Field As Long) As Long
   GetFieldBorderStyle = pdfGetFieldBorderStyle(m_Instance, Field)
End Function

Friend Function GetFieldBorderWidth(ByVal Field As Long) As Double
   GetFieldBorderWidth = pdfGetFieldBorderWidth(m_Instance, Field)
End Function

Friend Function GetFieldChoiceValue(ByVal Field As Long, ByVal ValIndex As Long, ByRef Value As TPDFChoiceValue) As Boolean
      Dim v As TPDFChoiceValue_I
      v.StructSize = LenB(v)
      If pdfGetFieldChoiceValue(m_Instance, Field, ValIndex, v) = 0 Then Exit Function
      Value.ExpValue = ToStringEx(v.ExpValueA, v.ExpValueW, v.ExpValueLen)
      Value.Value = ToStringEx(v.ValueA, v.ValueW, v.ValueLen)
      Value.Selected = v.Selected <> 0
End Function

Friend Function GetFieldColor(ByVal Field As Long, ByVal ColorType As TFieldColor, ColorSpace As Long, Color As Long) As Boolean
   GetFieldColor = pdfGetFieldColor(m_Instance, Field, ColorType, ColorSpace, Color) <> 0
End Function

Friend Function GetFieldCount() As Long
   GetFieldCount = pdfGetFieldCount(m_Instance)
End Function

Friend Function GetFieldEx(ByVal Handle As Long, ByRef Field As TPDFFieldEx) As Boolean
   Dim f As TPDFFieldEx_I
   f.StructSize = LenB(f)
   If pdfGetFieldEx(m_Instance, Handle, f) = 0 Then Exit Function
   GetIntFieldEx f, Field
   GetFieldEx = True
End Function

Friend Function GetFieldEx2(ByVal IField As Long, ByRef Field As TPDFFieldEx) As Boolean
   Dim f As TPDFFieldEx_I
   f.StructSize = LenB(f)
   If pdfGetFieldEx2(IField, f) = 0 Then Exit Function
   GetIntFieldEx f, Field
   GetFieldEx2 = True
End Function

Friend Function GetFieldExpValCount(ByVal Field As Long) As Long
   GetFieldExpValCount = pdfGetFieldExpValCount(m_Instance, Field)
End Function

Friend Function GetFieldExpValue(ByVal Field As Long, ByRef Value As String) As Boolean
   Dim pBuffer As Long
   Dim BufSize As Long

   BufSize = pdfGetFieldExpValue(m_Instance, Field, pBuffer)
   If BufSize < 0 Then
      Value = ""
      Exit Function
   End If
   Value = ToString2(pBuffer, BufSize, False)
   GetFieldExpValue = True
End Function

Friend Function GetFieldExpValueEx(ByVal Field As Long, ByVal ValIndex As Long, ByRef Value As String, ByRef ExpValue As String, ByRef bSelected As Long) As Boolean
   Dim valPtr As Long
   Dim expPtr As Long
   If pdfGetFieldExpValueEx(m_Instance, Field, ValIndex, valPtr, expPtr, bSelected) = 0 Then
      Value = ""
      ExpValue = ""
      bSelected = False
      Exit Function
   End If
   Value = ToString1(valPtr, False)
   ExpValue = ToString1(expPtr, False)
   GetFieldExpValueEx = True
End Function

Friend Function GetFieldFlags(ByVal Field As Long) As Long
   GetFieldFlags = pdfGetFieldFlags(m_Instance, Field)
End Function

Friend Function GetFieldGroupType(ByVal Field As Long) As Long
   GetFieldGroupType = pdfGetFieldGroupType(m_Instance, Field)
End Function

Friend Function GetFieldHighlightMode(ByVal Field As Long) As Long
   GetFieldHighlightMode = pdfGetFieldHighlightMode(m_Instance, Field)
End Function

Friend Function GetFieldIndex(ByVal Field As Long) As Long
   GetFieldIndex = pdfGetFieldIndex(m_Instance, Field)
End Function

Friend Function GetFieldMapName(ByVal Field As Long, Value As String) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   BufSize = pdfGetFieldMapName(m_Instance, Field, pBuffer, uni)
   If BufSize < 0 Then
      Value = ""
      Exit Function
   End If
   Value = ToString2(pBuffer, BufSize, uni <> 0)
   GetFieldMapName = True
End Function

Friend Function GetFieldName(ByVal Field As Long, Name As String) As Boolean
   Dim pBuffer As Long
   Dim BufSize As Long

   BufSize = pdfGetFieldName(m_Instance, Field, pBuffer)
   If BufSize < 0 Then
      Name = ""
      Exit Function
   End If
   Name = ToString3(pBuffer, BufSize)
   GetFieldName = True
End Function

Friend Function GetFieldOrientation(ByVal Field As Long) As Long
   GetFieldOrientation = pdfGetFieldOrientation(m_Instance, Field)
End Function

Friend Function GetFieldTextAlign(ByVal Field As Long) As TTextAlign
   GetFieldTextAlign = pdfGetFieldTextAlign(m_Instance, Field)
End Function

Friend Function GetFieldTextColor() As Long
   GetFieldTextColor = pdfGetFieldTextColor(m_Instance)
End Function

Friend Function GetFieldToolTip(ByVal Field As Long, Value As String) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   BufSize = pdfGetFieldToolTip(m_Instance, Field, pBuffer, uni)
   If BufSize < 0 Then
      Value = ""
      Exit Function
   End If
   Value = ToString2(pBuffer, BufSize, uni <> 0)
   GetFieldToolTip = True
End Function

Friend Function GetFieldType(ByVal Field As Long, ByRef Value As TFieldType) As Boolean
   Dim retval As Long
   retval = pdfGetFieldType(m_Instance, Field)
   If retval < 0 Then Exit Function
   Value = retval
   GetFieldType = True
End Function

Friend Function GetFillColor() As Long
   GetFillColor = pdfGetFillColor(m_Instance)
End Function

Friend Function GetFont(ByVal IFont As Long, ByRef Font As TPDFFontObj) As Boolean
   Dim fnt As TPDFFontObj_I
   If fntGetFont(IFont, fnt) = 0 Then Exit Function
   GetIntFont fnt, Font
   GetFont = True
End Function

Friend Function GetFontCount() As Long
   GetFontCount = pdfGetFontCount(m_Instance)
End Function

Friend Function GetFontEx(ByVal Handle As Long, ByRef Font As TPDFFontObj) As Boolean
   Dim fnt As TPDFFontObj_I
   If pdfGetFontEx(m_Instance, Handle, fnt) = 0 Then Exit Function
   GetIntFont fnt, Font
   GetFontEx = True
End Function

Friend Function GetFontOrigin() As TOrigin
   GetFontOrigin = pdfGetFontOrigin(m_Instance)
End Function

Friend Sub GetFontSearchOrder(ByRef Order() As TFontBaseType)
   pdfGetFontSearchOrder m_Instance, Order(0)
End Sub

Friend Function GetFontSelMode() As TFontSelMode
   GetFontSelMode = pdfGetFontSelMode(m_Instance)
End Function

Friend Function GetFontWeight() As Long
   GetFontWeight = pdfGetFontWeight(m_Instance)
End Function

Friend Function GetFTextHeightA(ByVal Align As TTextAlign, ByVal AText As String) As Double
   GetFTextHeightA = pdfGetFTextHeightA(m_Instance, Align, AText)
End Function

Friend Function GetFTextHeightW(ByVal Align As TTextAlign, ByVal AText As String) As Double
   Dim s As String
   s = StrConv(AText, vbUnicode)
   GetFTextHeightW = pdfGetFTextHeightW(m_Instance, Align, s)
End Function

Friend Function GetFTextHeightExA(ByVal Width As Double, ByVal Align As TTextAlign, ByVal AText As String) As Double
   GetFTextHeightExA = pdfGetFTextHeightExA(m_Instance, Width, Align, AText)
End Function

Friend Function GetFTextHeightExW(ByVal Width As Double, ByVal Align As TTextAlign, ByVal AText As String) As Double
   Dim s As String
   s = StrConv(AText, vbUnicode)
   GetFTextHeightExW = pdfGetFTextHeightExW(m_Instance, Width, Align, s)
End Function

Friend Function GetGStateFlags() As Long
   GetGStateFlags = pdfGetGStateFlags(m_Instance)
End Function

Friend Function GetIconColor() As Long
   GetIconColor = pdfGetIconColor(m_Instance)
End Function

Friend Function GetImageCount(ByVal FileName As String) As Long
   GetImageCount = pdfGetImageCount(m_Instance, FileName)
End Function

Friend Function GetImageHeight(ByVal Handle As Long) As Long
   GetImageHeight = pdfGetImageHeight(m_Instance, Handle)
End Function

Friend Function GetImageWidth(ByVal Handle As Long) As Long
   GetImageWidth = pdfGetImageWidth(m_Instance, Handle)
End Function

Friend Function GetImportFlags() As Long
   GetImportFlags = pdfGetImportFlags(m_Instance)
End Function

Friend Function GetInBBox(ByVal PageNum As Long, ByVal Boundary As TPageBoundary, BBox As TPDFRect) As Boolean
   GetInBBox = pdfGetInBBox(m_Instance, PageNum, Boundary, BBox) <> 0
End Function

Friend Function GetInDocInfo(ByVal DInfo As TDocumentInfo, Value As String) As Boolean
   Dim BufSize As Long
   Dim pBuffer As Long
   BufSize = pdfGetInDocInfo(m_Instance, DInfo, pBuffer)
   If BufSize < 0 Then
      Value = ""
      Exit Function
   End If
   Value = ToString2(pBuffer, BufSize, True)
   GetInDocInfo = True
End Function

Friend Function GetInDocInfoCount() As Long
   GetInDocInfoCount = pdfGetInDocInfoCount(m_Instance)
End Function

Friend Function GetInDocInfoEx(ByVal Index As Long, ByRef DInfo As TDocumentInfo, ByRef Key As String, ByRef Value As String) As Boolean
   Dim info As Long
   Dim uni As Long
   Dim keyBuf As Long
   Dim KeyLen As Long
   Dim valBuf As Long
   Dim valLen As Long
   valLen = pdfGetInDocInfoEx(m_Instance, Index, info, keyBuf, valBuf, uni)
   If valLen <= 0 Then
      Key = ""
      Value = ""
      Exit Function
   End If
   DInfo = info
   Key = ToString1(keyBuf, False)
   Value = ToString2(valBuf, valLen, uni <> 0)
   GetInDocInfoEx = True
End Function

Friend Function GetInEncryptionFlags() As Long
   GetInEncryptionFlags = pdfGetInEncryptionFlags(m_Instance)
End Function

Friend Function GetInIsCollection() As Boolean
   Dim retval As Long
   retval = pdfGetInIsCollection(m_Instance)
   If retval < 0 Then Exit Function
   GetInIsCollection = retval <> 0
End Function

Friend Function GetInIsEncrypted() As Boolean
   Dim retval As Long
   retval = pdfGetInIsEncrypted(m_Instance) <> 0
   If retval < 0 Then Exit Function
   GetInIsEncrypted = retval <> 0
End Function

Friend Function GetInIsSigned() As Boolean
   Dim retval As Long
   retval = pdfGetInIsSigned(m_Instance) <> 0
   If retval < 0 Then Exit Function
   GetInIsSigned = retval <> 0
End Function

Friend Function GetInIsTrapped() As Boolean
   Dim retval As Long
   retval = pdfGetInIsTrapped(m_Instance) <> 0
   If retval < 0 Then Exit Function
   GetInIsTrapped = retval <> 0
End Function

Friend Function GetInIsXFAForm() As Boolean
   GetInIsXFAForm = pdfGetInIsXFAForm(m_Instance) <> 0
End Function

Friend Function GetInPageCount() As Long
   GetInPageCount = pdfGetInPageCount(m_Instance)
End Function

Friend Function GetInNamedDest(ByVal Index As Long, ByRef Dest As TPDFNamedDest) As Boolean
   Dim d As TPDFNamedDest_I
   If pdfGetInNamedDest(m_Instance, Index, d) = 0 Then Exit Function
   Dest.Name = ToStringEx(d.NameA, d.NameW, d.NameLen)
   Dest.DestPage = d.DestPage
   Dest.DestPos = d.DestPos
   Dest.DestType = d.DestType
   GetInNamedDest = True
End Function

Friend Function GetInNamedDestCount() As Long
   GetInNamedDestCount = pdfGetInNamedDestCount(m_Instance)
End Function

Friend Function GetInOrientation(ByVal PageNum As Long) As Long
   GetInOrientation = pdfGetInOrientation(m_Instance, PageNum)
End Function

Friend Function GetInPDFVersion() As Long
   GetInPDFVersion = pdfGetInPDFVersion(m_Instance)
End Function

Friend Function GetInPrintSettings(ByRef Settings As TPDFPrintSettings) As Boolean
   Dim s As TPDFPrintSettings_I
   If pdfGetInPrintSettings(m_Instance, s) = 0 Then Exit Function
   Settings.DuplexMode = s.DuplexMode
   Settings.NumCopies = s.NumCopies
   Settings.PickTrayByPDFSize = s.PickTrayByPDFSize
   Settings.PrintScaling = s.PrintScaling
   If s.PrintRangesCount > 0 Then
      ReDim Settings.PrintRanges(s.PrintRangesCount * 2 - 1)
      pdfCopyMem2 s.PrintRanges, Settings.PrintRanges(0), s.PrintRangesCount * 2 * 4
   Else
      Erase Settings.PrintRanges
   End If
   GetInPrintSettings = True
End Function

Friend Function GetIsFixedPitch() As Boolean
   GetIsFixedPitch = pdfGetIsFixedPitch(m_Instance) <> 0
End Function

Friend Function GetItalicAngle() As Double
   GetItalicAngle = pdfGetItalicAngle(m_Instance)
End Function

Friend Function GetJavaScript(ByVal Handle As Long, Script As String) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   pBuffer = pdfGetJavaScript(m_Instance, Handle, BufSize, uni)
   If pBuffer = 0 Then
      Script = ""
      Exit Function
   End If
   Script = ToString2(pBuffer, BufSize, uni <> 0)
   GetJavaScript = True
End Function

Friend Function GetJavaScriptAction(ByVal Handle As Long, Script As String) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   pBuffer = pdfGetJavaScriptAction(m_Instance, Handle, BufSize, uni)
   If pBuffer = 0 Then
      Script = ""
      Exit Function
   End If
   Script = ToString2(pBuffer, BufSize, uni <> 0)
   GetJavaScriptAction = True
End Function

Friend Function GetJavaScriptAction2(ByVal ObjType As TObjType, ByVal ObjHandle As Long, ByVal ActIndex As Long, Script As String, ByRef ObjEvent As TObjEvent) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   pBuffer = pdfGetJavaScriptAction2(m_Instance, ObjType, ObjHandle, ActIndex, BufSize, uni, ObjEvent)
   If pBuffer = 0 Then
      Script = ""
      Exit Function
   End If
   Script = ToString2(pBuffer, BufSize, uni <> 0)
   GetJavaScriptAction2 = True
End Function

Friend Function GetJavaScriptCount() As Long
   GetJavaScriptCount = pdfGetJavaScriptCount(m_Instance)
End Function

Friend Function GetJavaScriptEx(ByVal Name As String, Script As String) As Boolean
   Dim uni As Long
   Dim pBuffer As Long
   Dim BufSize As Long

   pBuffer = pdfGetJavaScriptEx(m_Instance, Name, BufSize, uni)
   If pBuffer = 0 Then
      Script = ""
      Exit Function
   End If
   Script = ToString2(pBuffer, BufSize, uni <> 0)
   GetJavaScriptEx = True
End Function

Friend Function GetJavaScriptName(ByVal Handle As Long) As String
   Dim uni As Long
   Dim BufSize As Long
   Dim pBuffer As Long
   pBuffer = pdfGetJavaScriptName(m_Instance, Handle, BufSize, uni)
   GetJavaScriptName = ToString2(pBuffer, BufSize, uni <> 0)
End Function

Friend Function GetJPEGQuality() As Long
   GetJPEGQuality = pdfGetJPEGQuality(m_Instance)
End Function

Friend Function GetLanguage() As String
   Dim ptr As Long
   ptr = pdfGetLanguage(m_Instance)
   GetLanguage = ToString1(ptr, False)
End Function

Friend Function GetLastTextPosX() As Double
   GetLastTextPosX = pdfGetLastTextPosX(m_Instance)
End Function

Friend Function GetLastTextPosY() As Double
   GetLastTextPosY = pdfGetLastTextPosY(m_Instance)
End Function

Friend Function GetLeading() As Double
   GetLeading = pdfGetLeading(m_Instance)
End Function

Friend Function GetLineCapStyle() As TLineCapStyle
   GetLineCapStyle = pdfGetLineCapStyle(m_Instance)
End Function

Friend Function GetLineJoinStyle() As TLineJoinStyle
   GetLineJoinStyle = pdfGetLineJoinStyle(m_Instance)
End Function

Friend Function GetLineWidth() As Double
   GetLineWidth = pdfGetLineWidth(m_Instance)
End Function

Friend Function GetLinkHighlightMode() As THighlightMode
   GetLinkHighlightMode = pdfGetLinkHighlightMode(m_Instance)
End Function

Friend Function GetLogMetafileSize(ByVal FileName As String, ARect As TRectL) As Boolean
   GetLogMetafileSize = pdfGetLogMetafileSize(m_Instance, FileName, ARect) <> 0
End Function

Friend Function GetLogMetafileSizeEx(Buffer() As Byte, ARect As TRectL) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   GetLogMetafileSizeEx = pdfGetLogMetafileSizeEx(m_Instance, Buffer(0), BufSize + 1, ARect) <> 0
End Function

Friend Function GetMatrix(ByRef Matrix As TCTM) As Boolean
   GetMatrix = pdfGetMatrix(m_Instance, Matrix) <> 0
End Function

Friend Function GetMaxFieldLen(ByVal TxtField As Long) As Long
   GetMaxFieldLen = pdfGetMaxFieldLen(m_Instance, TxtField)
End Function

Friend Function GetMetaConvFlags() As Long
   GetMetaConvFlags = pdfGetMetaConvFlags(m_Instance)
End Function

Friend Function GetMissingGlyphs(ByRef Glyphs() As Long) As Long
   Dim ptr As Long, Count As Long
   ptr = pdfGetMissingGlyphs(m_Instance, Count)
   If ptr = 0 Then
      Erase Glyphs
      Exit Function
   End If
   ReDim Glyphs(Count - 1)
   Call pdfCopyMem2(ptr, Glyphs(0), Count * 4)
   GetMissingGlyphs = Count
End Function

Friend Function GetMiterLimit() As Double
   GetMiterLimit = pdfGetMiterLimit(m_Instance)
End Function

Friend Function GetNeedAppearance() As Boolean
   GetNeedAppearance = pdfGetNeedAppearance(m_Instance) <> 0
End Function

Friend Function GetObjActionCount(ByVal ObjType As TObjType, ByVal ObjHandle As Long) As Long
   GetObjActionCount = pdfGetObjActionCount(m_Instance, ObjType, ObjHandle)
End Function

Friend Function GetOpacity() As Double
   GetOpacity = pdfGetOpacity(m_Instance)
End Function

Friend Function GetOrientation() As Long
   GetOrientation = pdfGetOrientation(m_Instance)
End Function

Friend Function GetPageAnnot(ByVal Index As Long, ByRef Annot As TPDFAnnotation) As Boolean
   Dim retval As TPDFAnnotation_I
   If pdfGetPageAnnot(m_Instance, Index, retval) = 0 Then Exit Function
   GetIntAnnot retval, Annot
   GetPageAnnot = True
End Function

Friend Function GetPageAnnotCount() As Long
   GetPageAnnotCount = pdfGetPageAnnotCount(m_Instance)
End Function

Friend Function GetPageAnnotEx(ByVal Index As Long, ByRef Annot As TPDFAnnotationEx) As Boolean
   Dim retval As TPDFAnnotationEx_I
   If pdfGetPageAnnotEx(m_Instance, Index, retval) = 0 Then Exit Function
   GetIntAnnotEx retval, Annot
   GetPageAnnotEx = True
End Function

Friend Function GetPageCoords() As Long
   GetPageCoords = pdfGetPageCoords(m_Instance)
End Function

Friend Function GetPageCount() As Long
   GetPageCount = pdfGetPageCount(m_Instance)
End Function

Friend Function GetPageField(ByVal Index As Long, Field As TPDFField) As Boolean
   If pdfGetPageField(m_Instance, Index, FField) = 0 Then Exit Function
   GetIntField Field
   GetPageField = True
End Function

Friend Function GetPageFieldCount() As Long
   GetPageFieldCount = pdfGetPageFieldCount(m_Instance)
End Function

Friend Function GetPageFieldEx(ByVal Index As Long, ByRef Field As TPDFFieldEx) As Boolean
   Dim f As TPDFFieldEx_I
   If pdfGetPageFieldEx(m_Instance, Index, f) = 0 Then Exit Function
   GetIntFieldEx f, Field
   GetPageFieldEx = True
End Function

Friend Function GetPageHeight() As Double
   GetPageHeight = pdfGetPageHeight(m_Instance)
End Function

Friend Function GetPageLabel(ByVal Index As Long, ByRef Lbl As TPDFPageLabel) As Boolean
   Dim pLabel As TPDFPageLabel_I
   If pdfGetPageLabel(m_Instance, Index, pLabel) = 0 Then Exit Function
   Lbl.FirstPageNum = pLabel.FirstPageNum
   Lbl.Format = pLabel.Format
   Lbl.StartRange = pLabel.StartRange
   Lbl.Prefix = ToString2(pLabel.Prefix, pLabel.PrefixLen, pLabel.PrefixUni <> 0)
   GetPageLabel = True
End Function
 
Friend Function GetPageLabelCount() As Long
   GetPageLabelCount = pdfGetPageLabelCount(m_Instance)
End Function

Friend Function GetPageLayout() As Long
   GetPageLayout = pdfGetPageLayout(m_Instance)
End Function

Friend Function GetPageMode() As Long
   GetPageMode = pdfGetPageMode(m_Instance)
End Function

Friend Function GetPageNum() As Long
   GetPageNum = pdfGetPageNum(m_Instance)
End Function

Friend Function GetPageText(Stack As TPDFStack) As Boolean
   FStack.ConvColors = Stack.ConvColors
   FStack.DestSpace = Stack.DestSpace
   GetPageText = pdfGetPageText(m_Instance, FStack) <> 0
   Stack.ctm = FStack.ctm
   Stack.tm = FStack.tm
   Stack.x = FStack.x
   Stack.y = FStack.y
   Stack.FontSize = FStack.FontSize
   Stack.CharSP = FStack.CharSP
   Stack.WordSP = FStack.WordSP
   Stack.HScale = FStack.HScale
   Stack.TextRise = FStack.TextRise
   Stack.Leading = FStack.Leading
   Stack.LineWidth = FStack.LineWidth
   Stack.DrawMode = FStack.DrawMode
   Stack.FillCS = FStack.FillCS
   Stack.FillColor = FStack.FillColor
   Stack.StrokeCS = FStack.StrokeCS
   Stack.StrokeColor = FStack.StrokeColor
   Stack.TextWidth = FStack.TextWidth
   Stack.spaceWidth = FStack.spaceWidth
   Stack.IFont = FStack.IFont
   Stack.Embedded = FStack.Embedded <> 0
   Stack.FontFlags = FStack.FontFlags
   If FStack.TextLen > 0 Then
      Dim i As Long
      Dim Kerning() As TTextRecordW_I
      ReDim Kerning(FStack.KerningCount - 1)
      ReDim Stack.RawKern(FStack.KerningCount - 1)
      ReDim Stack.Kerning(FStack.KerningCount - 1)

      Stack.Text = ToString2(FStack.Text, FStack.TextLen, False)
      Call pdfCopyMem2(FStack.RawKern, Stack.RawKern(0), FStack.KerningCount * 12)
      Call pdfCopyMem2(FStack.Kerning, Kerning(0), FStack.KerningCount * 16)
      For i = 0 To FStack.KerningCount - 1
         Stack.Kerning(i).Advance = Kerning(i).Advance
         Stack.Kerning(i).Width = Kerning(i).Width
         Stack.Kerning(i).Text = ToString2(Kerning(i).Text, Kerning(i).Length, True)
      Next i
   Else
      Stack.Text = ""
      Erase Stack.RawKern
      Erase Stack.Kerning
   End If
End Function

Friend Function GetPageWidth() As Double
   GetPageWidth = pdfGetPageWidth(m_Instance)
End Function

Friend Function GetPDFVersion() As Long
   GetPDFVersion = pdfGetPDFVersion(m_Instance)
End Function

Friend Function GetPrintSettings(ByRef Settings As TPDFPrintSettings) As Boolean
   Dim s As TPDFPrintSettings_I
   If pdfGetPrintSettings(m_Instance, s) = 0 Then Exit Function
   Settings.DuplexMode = s.DuplexMode
   Settings.NumCopies = s.NumCopies
   Settings.PickTrayByPDFSize = s.PickTrayByPDFSize
   Settings.PrintScaling = s.PrintScaling
   If s.PrintRangesCount > 0 Then
      ReDim Settings.PrintRanges(s.PrintRangesCount * 2 - 1)
      pdfCopyMem2 s.PrintRanges, Settings.PrintRanges(0), s.PrintRangesCount * 2 * 4
   Else
      Erase Settings.PrintRanges
   End If
   GetPrintSettings = True
End Function

Friend Function GetResolution() As Long
   GetResolution = pdfGetResolution(m_Instance)
End Function

Friend Function GetSaveNewImageFormat() As Boolean
   GetSaveNewImageFormat = pdfGetSaveNewImageFormat(m_Instance) <> 0
End Function

Friend Function GetStrokeColor() As Long
   GetStrokeColor = pdfGetStrokeColor(m_Instance)
End Function

Friend Function GetTabLen() As Long
   GetTabLen = pdfGetTabLen(m_Instance)
End Function

Friend Function GetTemplCount() As Long
   GetTemplCount = pdfGetTemplCount(m_Instance)
End Function

Friend Function GetTemplHeight(ByVal Handle As Long) As Double
   GetTemplHeight = pdfGetTemplHeight(m_Instance, Handle)
End Function

Friend Function GetTemplWidth(ByVal Handle As Long) As Double
   GetTemplWidth = pdfGetTemplWidth(m_Instance, Handle)
End Function

Friend Function GetTextDrawMode() As TDrawMode
   GetTextDrawMode = pdfGetTextDrawMode(m_Instance)
End Function

Friend Function GetTextFieldValue(ByVal AField As Long, ByRef Value As String, ByRef DefValue As String) As Boolean
   Dim valUni As Long
   Dim defValUni As Long
   Dim val As Long
   Dim defVal As Long
   If pdfGetTextFieldValue(m_Instance, AField, val, valUni, defVal, defValUni) <> 0 Then
      Value = ""
      DefValue = ""
      Exit Function
   End If
   Value = ToString1(val, valUni <> 0)
   DefValue = ToString1(defVal, defValUni <> 0)
   GetTextFieldValue = True
End Function

Friend Function GetTextRect(PosX As Double, PosY As Double, Width As Double, Height As Double) As Boolean
   GetTextRect = pdfGetTextRect(m_Instance, PosX, PosY, Width, Height) <> 0
End Function

Friend Function GetTextRise() As Double
   GetTextRise = pdfGetTextRise(m_Instance)
End Function

Friend Function GetTextScaling() As Double
   GetTextScaling = pdfGetTextScaling(m_Instance)
End Function

Friend Function GetTextWidth(ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByVal CharSpacing As Single, ByVal WordSpacing As Single, ByVal TextScale As Single) As Double
   GetTextWidth = fntGetTextWidth(IFont, Text, sLen, CharSpacing, WordSpacing, TextScale)
End Function

Friend Function GetTextWidthA(ByVal AText As String) As Double
   GetTextWidthA = pdfGetTextWidthA(m_Instance, AText)
End Function

Friend Function GetTextWidthW(ByVal AText As String) As Double
   Dim s As String
   s = StrConv(AText, vbUnicode)
   GetTextWidthW = pdfGetTextWidthW(m_Instance, s)
End Function

Friend Function GetTextWidthExA(ByVal AText As String, ByVal sLen As Long) As Double
   GetTextWidthExA = pdfGetTextWidthExA(m_Instance, AText, sLen)
End Function

Friend Function GetTextWidthExW(ByVal AText As String, ByVal sLen As Long) As Double
   Dim s As String
   s = StrConv(Mid(AText, 1, sLen), vbUnicode)
   GetTextWidthExW = pdfGetTextWidthExW(m_Instance, s, LenB(s) / 2)
End Function

Friend Function GetTransparentColor() As Long
   GetTransparentColor = pdfGetTransparentColor(m_Instance)
End Function

Friend Function GetTrapped() As Boolean
   GetTrapped = pdfGetTrapped(m_Instance) <> 0
End Function

Friend Function GetUseExactPwd() As Boolean
   GetUseExactPwd = pdfGetUseExactPwd(m_Instance) <> 0
End Function

Friend Function GetUseGlobalImpFiles() As Boolean
   GetUseGlobalImpFiles = pdfGetUseGlobalImpFiles(m_Instance) <> 0
End Function

Friend Function GetUserRights() As Long
   GetUserRights = pdfGetUserRights(m_Instance)
End Function

Friend Function GetUseStdFonts() As Boolean
   GetUseStdFonts = pdfGetUseStdFonts(m_Instance) <> 0
End Function

Friend Function GetUseSystemFonts() As Boolean
   GetUseSystemFonts = pdfGetUseSystemFonts(m_Instance) <> 0
End Function

Friend Function GetUseTransparency() As Boolean
   GetUseTransparency = pdfGetUseTransparency(m_Instance) <> 0
End Function

Friend Function GetUseVisibleCoords() As Boolean
   GetUseVisibleCoords = pdfGetUseVisibleCoords(m_Instance) <> 0
End Function

Friend Function GetViewerPrefrences(Preference As Long, AddVal As Long) As Boolean
   GetViewerPrefrences = pdfGetViewerPrefrences(m_Instance, Preference, AddVal) <> 0
End Function

Friend Function GetWMFDefExtent(Width As Long, Height As Long) As Boolean
   GetWMFDefExtent = pdfGetWMFDefExtent(m_Instance, Width, Height) <> 0
End Function

Friend Function GetWMFPixelPerInch() As Long
   GetWMFPixelPerInch = pdfGetWMFPixelPerInch(m_Instance)
End Function

Friend Function GetWordSpacing() As Double
   GetWordSpacing = pdfGetWordSpacing(m_Instance)
End Function

Friend Function HaveOpenDoc() As Boolean
   HaveOpenDoc = pdfHaveOpenDoc(m_Instance) <> 0
End Function

Friend Function HighlightAnnotA(ByVal Subtype As TAnnotType, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Color As Long, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
   HighlightAnnotA = pdfHighlightAnnotA(m_Instance, Subtype, PosX, PosY, Width, Height, Color, Author, Subject, Comment)
End Function

Friend Function HighlightAnnotW(ByVal Subtype As TAnnotType, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Color As Long, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
   Dim auth As String
   Dim subj As String
   Dim comt As String
   auth = StrConv(Author, vbUnicode)
   subj = StrConv(Subject, vbUnicode)
   comt = StrConv(Comment, vbUnicode)
   HighlightAnnotW = pdfHighlightAnnotW(m_Instance, Subtype, PosX, PosY, Width, Height, Color, auth, subj, comt)
End Function

Friend Function ImportBookmarks() As Long
   ImportBookmarks = pdfImportBookmarks(m_Instance)
End Function

Friend Function ImportCatalogObjects() As Boolean
   ImportCatalogObjects = pdfImportCatalogObjects(m_Instance) <> 0
End Function

Friend Function ImportDocInfo() As Boolean
   ImportDocInfo = pdfImportDocInfo(m_Instance) <> 0
End Function

Friend Function ImportPage(ByVal PageNum As Long) As Long
   ImportPage = pdfImportPage(m_Instance, PageNum)
End Function

Friend Function ImportPageEx(ByVal PageNum As Long, ByVal ScaleX As Double, ByVal ScaleY As Double) As Long
   ImportPageEx = pdfImportPageEx(m_Instance, PageNum, ScaleX, ScaleY)
End Function

Friend Function ImportPDFFile(ByVal DestPage As Long, ByVal ScaleX As Double, ByVal ScaleY As Double) As Long
   ImportPDFFile = pdfImportPDFFile(m_Instance, DestPage, ScaleX, ScaleY)
End Function

Friend Function InitExtGState(ByRef GS As TPDFExtGState) As Boolean
   InitExtGState = pdfInitExtGState(GS) <> 0
End Function

Friend Function InitStack(Stack As TPDFStack) As Boolean
   If pdfInitStack(m_Instance, FStack) = 0 Then Exit Function
   Stack.ctm = FStack.ctm
   Stack.tm = FStack.tm
   Stack.x = FStack.x
   Stack.y = FStack.y
   Stack.FontSize = FStack.FontSize
   Stack.CharSP = FStack.CharSP
   Stack.WordSP = FStack.WordSP
   Stack.HScale = FStack.HScale
   Stack.TextRise = FStack.TextRise
   Stack.Leading = FStack.Leading
   Stack.LineWidth = FStack.LineWidth
   Stack.DrawMode = FStack.DrawMode
   Stack.FillCS = FStack.FillCS
   Stack.FillColor = FStack.FillColor
   Stack.StrokeCS = FStack.StrokeCS
   Stack.StrokeColor = FStack.StrokeColor
   Stack.Text = ""
   InitStack = True
End Function

Friend Function InsertBMPFromBuffer(ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, Buffer() As Byte) As Long
   InsertBMPFromBuffer = pdfInsertBMPFromBuffer(m_Instance, PosX, PosY, ScaleWidth, ScaleHeight, Buffer(0))
End Function

Friend Function InsertBMPFromHandle(ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal hBitmap As Long) As Long
   InsertBMPFromHandle = pdfInsertBMPFromHandle(m_Instance, PosX, PosY, ScaleWidth, ScaleHeight, hBitmap)
End Function

Friend Function InsertImage(ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal AFile As String) As Long
   InsertImage = pdfInsertImage(m_Instance, PosX, PosY, ScaleWidth, ScaleHeight, AFile)
End Function

Friend Function InsertImageEx(ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByVal AFile As String, ByVal Index As Long) As Long
   InsertImageEx = pdfInsertImageEx(m_Instance, PosX, PosY, ScaleWidth, ScaleHeight, AFile, Index)
End Function

Friend Function InsertImageFromBuffer(ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double, ByRef Buffer() As Byte, ByVal Index As Long) As Long
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   InsertImageFromBuffer = pdfInsertImageFromBuffer(m_Instance, PosX, PosY, ScaleWidth, ScaleHeight, Buffer(0), BufSize + 1, Index)
End Function

Friend Function InsertMetafile(ByVal FileName As String, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   InsertMetafile = pdfInsertMetafile(m_Instance, FileName, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertMetafileEx(Buffer() As Byte, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   InsertMetafileEx = pdfInsertMetafileEx(m_Instance, Buffer(0), BufSize + 1, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertMetafileExt(ByVal FileName As String, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   InsertMetafileExt = pdfInsertMetafileExt(m_Instance, FileName, View, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertMetafileExtEx(Buffer() As Byte, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   InsertMetafileExtEx = pdfInsertMetafileExtEx(m_Instance, Buffer(0), BufSize + 1, View, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertMetafileFromHandle(ByVal hEnhMetafile As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   InsertMetafileFromHandle = pdfInsertMetafileFromHandle(m_Instance, hEnhMetafile, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertMetafileFromHandleEx(ByVal hEnhMetafile As Long, ByRef View As TRectL, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   InsertMetafileFromHandleEx = pdfInsertMetafileFromHandleEx(m_Instance, hEnhMetafile, View, PosX, PosY, Width, Height) <> 0
End Function

Friend Function InsertRawImage(Buffer() As Byte, ByVal BitsPerPixel As Long, ByVal ColorCount As Long, ByVal ImgWidth As Long, ByVal ImgHeight As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Long
   InsertRawImage = pdfInsertRawImage(m_Instance, Buffer(0), BitsPerPixel, ColorCount, ImgWidth, ImgHeight, PosX, PosY, ScaleWidth, ScaleHeight)
End Function

Friend Function IsBidiText(ByVal AText As String) As Long
   IsBidiText = pdfIsBidiText(m_Instance, AText)
End Function

Friend Function IsColorPage(ByVal GrayIsColor As Boolean) As Long
   IsColorPage = pdfIsColorPage(m_Instance, GrayIsColor)
End Function

Friend Function IsEmptyPage() As Long
   IsEmptyPage = pdfIsEmptyPage(m_Instance)
End Function

Friend Function IsWrongPwd(ErrCode As Long) As Boolean
   IsWrongPwd = ((ErrCode = ENEED_PWD) Or (ErrCode = EWRONG_OPEN_PWD) Or (ErrCode = EWRONG_OWNER_PWD) Or (ErrCode = EWRONG_PWD))
End Function

Friend Function LineTo(ByVal PosX As Double, ByVal PosY As Double) As Boolean
   LineTo = pdfLineTo(m_Instance, PosX, PosY) <> 0
End Function

Friend Function LoadCMap(ByVal CMapName As String, ByVal Embed As Boolean) As Long
   LoadCMap = pdfLoadCMap(m_Instance, CMapName, Embed)
End Function

Friend Function LoadFDFDataA(ByVal FileName As String, ByVal Password As String, ByVal Flags As Long) As Boolean
   LoadFDFDataA = pdfLoadFDFDataA(m_Instance, FileName, Password, Flags) <> 0
End Function

Friend Function LoadFDFDataW(ByVal FileName As String, ByVal Password As String, ByVal Flags As Long) As Boolean
   Dim s As String
   s = StrConv(FileName, vbUnicode)
   LoadFDFDataW = pdfLoadFDFDataW(m_Instance, s, Password, Flags) <> 0
End Function

Friend Function LoadFDFDataEx(ByRef Buffer() As Byte, ByVal Password As String, ByVal Flags As Long) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   LoadFDFDataEx = pdfLoadFDFDataEx(m_Instance, Buffer(0), BufSize + 1, Password, Flags) <> 0
End Function

Friend Function LoadFont(ByRef Buffer() As Byte, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean, ByVal CP As TCodepage) As Long
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   LoadFont = pdfLoadFont(m_Instance, Buffer(0), BufSize + 1, Style, Size, Embed, CP)
End Function

Friend Function MovePage(ByVal Source As Long, ByVal Dest As Long) As Boolean
   MovePage = pdfMovePage(m_Instance, Source, Dest) <> 0
End Function

Friend Function MoveTo(ByVal PosX As Double, ByVal PosY As Double) As Boolean
   MoveTo = pdfMoveTo(m_Instance, PosX, PosY) <> 0
End Function

Friend Sub MuliplyMatrix(ByRef M1 As TCTM, ByRef M2 As TCTM, ByRef NewMatrix As TCTM)
   NewMatrix.a = M2.a * M1.a + M2.b * M1.c
   NewMatrix.b = M2.a * M1.b + M2.b * M1.d
   NewMatrix.c = M2.c * M1.a + M2.d * M1.c
   NewMatrix.d = M2.c * M1.b + M2.d * M1.d
   NewMatrix.x = M2.x * M1.a + M2.y * M1.c + M1.x
   NewMatrix.y = M2.x * M1.b + M2.y * M1.d + M1.y
End Sub

Friend Function OpenImportBuffer(Buffer() As Byte, ByVal PwdType As TPwdType, ByVal Password As String) As Long
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   OpenImportBuffer = pdfOpenImportBuffer(m_Instance, Buffer(0), BufSize + 1, PwdType, Password)
End Function

Friend Function OpenImportFileA(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal Password As String) As Long
   OpenImportFileA = pdfOpenImportFileA(m_Instance, FileName, PwdType, Password)
End Function

Friend Function OpenImportFileW(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal Password As String) As Long
   Dim s As String
   s = StrConv(FileName, vbUnicode)
   OpenImportFileW = pdfOpenImportFileW(m_Instance, s, PwdType, Password)
End Function

Friend Function OpenOutputFileA(ByVal OutPDF As String) As Boolean
   OpenOutputFileA = pdfOpenOutputFileA(m_Instance, OutPDF) <> 0
End Function

Friend Function OpenOutputFileW(ByVal OutPDF As String) As Boolean
   Dim s As String
   s = StrConv(OutPDF, vbUnicode)
   OpenOutputFileW = pdfOpenOutputFileW(m_Instance, s) <> 0
End Function

Friend Function OpenTagA(ByVal Tag As TPDFBaseTag, ByVal Lang As String, ByVal AltText As String, ByVal Expansion As String) As Boolean
   OpenTagA = pdfOpenTagA(m_Instance, Tag, Lang, AltText, Expansion)
End Function

Friend Function OpenTagW(ByVal Tag As TPDFBaseTag, ByVal Lang As String, ByVal AltText As String, ByVal Expansion As String) As Boolean
   OpenTagW = pdfOpenTagW(m_Instance, Tag, Lang, StrPtr(AltText), StrPtr(Expansion))
End Function

Friend Function PageLink(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal DestPage As Long) As Long
   PageLink = pdfPageLink(m_Instance, PosX, PosY, Width, Height, DestPage)
End Function

Friend Function PageLink2(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal NamedDest As Long) As Long
   PageLink2 = pdfPageLink2(m_Instance, PosX, PosY, Width, Height, NamedDest)
End Function

Friend Function PageLinkEx(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal DestType As TDestType, ByVal DestPage As Long, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Long
   PageLinkEx = pdfPageLinkEx(m_Instance, PosX, PosY, Width, Height, DestType, DestPage, a, b, c, d)
End Function

Friend Function PlaceImage(ByVal ImgHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Boolean
   PlaceImage = pdfPlaceImage(m_Instance, ImgHandle, PosX, PosY, ScaleWidth, ScaleHeight) <> 0
End Function

Friend Function PlaceSigFieldValidateIcon(ByVal SigField As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   PlaceSigFieldValidateIcon = pdfPlaceSigFieldValidateIcon(m_Instance, SigField, PosX, PosY, Width, Height) <> 0
End Function

Friend Function PlaceTemplate(ByVal TmplHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Boolean
   PlaceTemplate = pdfPlaceTemplate(m_Instance, TmplHandle, PosX, PosY, ScaleWidth, ScaleHeight) <> 0
End Function

Friend Function PlaceTemplateEx(ByVal TmplHandle As Long, ByVal PosX As Double, ByVal PosY As Double, ByVal ScaleWidth As Double, ByVal ScaleHeight As Double) As Boolean
   PlaceTemplateEx = pdfPlaceTemplateEx(m_Instance, TmplHandle, PosX, PosY, ScaleWidth, ScaleHeight) <> 0
End Function

Friend Function ReadImageFormat(ByVal FileName As String, Width As Long, Height As Long, BitsPerPixel As Long, UseZip As Long) As Boolean
   ReadImageFormat = pdfReadImageFormat(m_Instance, FileName, Width, Height, BitsPerPixel, UseZip) <> 0
End Function

Friend Function ReadImageFormat2(ByVal FileName As String, ByVal Index As Long, Width As Long, Height As Long, BitsPerPixel As Long, UseZip As Long) As Boolean
   ReadImageFormat2 = pdfReadImageFormat2(m_Instance, FileName, Index, Width, Height, BitsPerPixel, UseZip) <> 0
End Function

Friend Function ReadImageFormatEx(ByVal hBitmap As Long, Width As Long, Height As Long, BitsPerPixel As Long, UseZip As Long) As Boolean
   ReadImageFormatEx = pdfReadImageFormatEx(m_Instance, hBitmap, Width, Height, BitsPerPixel, UseZip) <> 0
End Function

Friend Function ReadImageFormatFromBuffer(Buffer() As Byte, ByVal Index As Long, Width As Long, Height As Long, BitsPerPixel As Long, UseZip As Long) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   ReadImageFormatFromBuffer = pdfReadImageFormatFromBuffer(m_Instance, Buffer(0), BufSize + 1, Index, Width, Height, BitsPerPixel, UseZip) <> 0
End Function

Friend Function ReadImageResolution(ByVal FileName As String, ByVal Index As Long, resX As Long, resY As Long) As Boolean
   ReadImageResolution = pdfReadImageResolution(m_Instance, FileName, Index, resX, resY) <> 0
End Function

Friend Function ReadImageResolutionEx(Buffer() As Byte, ByVal Index As Long, resX As Long, resY As Long) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   ReadImageResolutionEx = pdfReadImageResolutionEx(m_Instance, Buffer(0), BufSize + 1, Index, resX, resY) <> 0
End Function

Friend Function Rectangle(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal FillMode As TPathFillMode) As Boolean
   Rectangle = pdfRectangle(m_Instance, PosX, PosY, Width, Height, FillMode) <> 0
End Function

Friend Function ReEncryptPDFA(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal InPwd As String, ByVal NewOpenPwd As String, ByVal NewOwnerPwd As String, ByVal NewKeyLen As TKeyLen, ByVal Restrict As TRestrictions) As Long
   ReEncryptPDFA = pdfReEncryptPDFA(m_Instance, FileName, PwdType, InPwd, NewOpenPwd, NewOwnerPwd, NewKeyLen, Restrict)
End Function

Friend Function ReEncryptPDFW(ByVal FileName As String, ByVal PwdType As TPwdType, ByVal InPwd As String, ByVal NewOpenPwd As String, ByVal NewOwnerPwd As String, ByVal NewKeyLen As TKeyLen, ByVal Restrict As TRestrictions) As Long
   Dim s As String
   s = StrConv(FileName, vbUnicode)
   ReEncryptPDFW = pdfReEncryptPDFW(m_Instance, s, PwdType, InPwd, NewOpenPwd, NewOwnerPwd, NewKeyLen, Restrict)
End Function

Friend Function RenameSpotColor(ByVal Colorant As String, ByVal NewName As String) As Long
   RenameSpotColor = pdfRenameSpotColor(m_Instance, Colorant, NewName)
End Function

Friend Function ReplaceFontA(ByVal PDFFont As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal NameIsFamilyName As Boolean) As Long
   ReplaceFontA = pdfReplaceFontA(m_Instance, PDFFont, Name, Style, NameIsFamilyName)
End Function

Friend Function ReplaceFontW(ByVal PDFFont As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal NameIsFamilyName As Boolean) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   ReplaceFontW = pdfReplaceFontW(m_Instance, PDFFont, s, Style, NameIsFamilyName)
End Function

Friend Function ReplaceFontExA(ByVal PDFFont As Long, ByVal FontFile As String, ByVal Embed As Boolean) As Long
   ReplaceFontExA = pdfReplaceFontExA(m_Instance, PDFFont, FontFile, Embed)
End Function

Friend Function ReplaceFontExW(ByVal PDFFont As Long, ByVal FontFile As String, ByVal Embed As Boolean) As Long
   Dim s As String
   s = StrConv(FontFile, vbUnicode)
   ReplaceFontExW = pdfReplaceFontExW(m_Instance, PDFFont, s, Embed)
End Function

Friend Function ReplaceICCProfileA(ByVal ColorSpace As Long, ByVal ICCFile As String) As Long
   ReplaceICCProfileA = pdfReplaceICCProfileA(m_Instance, ColorSpace, ICCFile)
End Function

Friend Function ReplaceICCProfileW(ByVal ColorSpace As Long, ByVal ICCFile As String) As Long
   Dim s As String
   s = StrConv(ICCFile, vbUnicode)
   ReplaceICCProfileW = pdfReplaceICCProfileW(m_Instance, ColorSpace, s)
End Function

Friend Function ReplacePageTextA(ByRef Stack As TPDFStack, ByVal NewText As String) As Boolean
   FStack.DeleteKerningAt = Stack.DeleteKerningAt
   ReplacePageTextA = pdfReplacePageTextA(m_Instance, NewText, FStack) <> 0
End Function

Friend Function ReplacePageTextExA(ByVal NewText As String) As Boolean
   ReplacePageTextExA = pdfReplacePageTextExA(m_Instance, NewText, FStack) <> 0
End Function

Friend Function ReplacePageTextExW(ByVal NewText As String) As Boolean
   Dim s As String
   s = StrConv(NewText, vbUnicode)
   ReplacePageTextExW = pdfReplacePageTextExW(m_Instance, s, FStack) <> 0
End Function

Friend Function ResetLineDashPattern() As Boolean
   ResetLineDashPattern = pdfResetLineDashPattern(m_Instance) <> 0
End Function

Friend Function RestoreGraphicState() As Boolean
   RestoreGraphicState = pdfRestoreGraphicState(m_Instance) <> 0
End Function

Friend Function RotateCoords(ByVal alpha As Double, ByVal OriginX As Double, ByVal OriginY As Double) As Long
   RotateCoords = pdfRotateCoords(m_Instance, alpha, OriginX, OriginY)
End Function

Friend Function RoundRect(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Radius As Double, ByVal FillMode As TPathFillMode) As Boolean
   RoundRect = pdfRoundRect(m_Instance, PosX, PosY, Width, Height, Radius, FillMode) <> 0
End Function

Friend Function RoundRectEx(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal rWidth As Double, ByVal rHeight As Double, ByVal FillMode As TPathFillMode) As Boolean
   RoundRectEx = pdfRoundRectEx(m_Instance, PosX, PosY, Width, Height, rWidth, rHeight, FillMode) <> 0
End Function

Friend Function SaveGraphicState() As Boolean
   SaveGraphicState = pdfSaveGraphicState(m_Instance) <> 0
End Function

Friend Function ScaleCoords(ByVal sx As Double, ByVal sy As Double) As Long
   ScaleCoords = pdfScaleCoords(m_Instance, sx, sy)
End Function

Friend Function SelfTest() As Boolean
   SelfTest = pdfSelfTest(m_Instance) <> 0
End Function

Friend Function Set3DAnnotProps(ByVal Annot As Long, ByVal ActType As T3DActivationType, ByVal DeActType As T3DDeActivateType, ByVal InstType As T3DInstanceType, ByVal DeInstType As T3DDeActInstance, ByVal DisplToolbar As Boolean, ByVal DisplModelTree As Boolean) As Boolean
   Set3DAnnotProps = pdfSet3DAnnotProps(m_Instance, Annot, ActType, DeActType, InstType, DeInstType, DisplToolbar, DisplModelTree) <> 0
End Function

Friend Function Set3DAnnotScriptA(ByVal Annot As Long, ByVal Value As String) As Boolean
   Set3DAnnotScriptA = pdfSet3DAnnotScriptA(m_Instance, Annot, Value, Len(Value)) <> 0
End Function

Friend Function SetAllocBy(ByVal Value As Long) As Long
   SetAllocBy = pdfSetAllocBy(m_Instance, Value)
End Function

Friend Function SetAnnotBorderStyle(ByVal Handle As Long, ByVal Style As TBorderStyle) As Boolean
   SetAnnotBorderStyle = pdfSetAnnotBorderStyle(m_Instance, Handle, Style) <> 0
End Function

Friend Function SetAnnotBorderWidth(ByVal Handle As Long, ByVal LineWidth As Double) As Boolean
   SetAnnotBorderWidth = pdfSetAnnotBorderWidth(m_Instance, Handle, LineWidth) <> 0
End Function

Friend Function SetAnnotColor(ByVal Handle As Long, ByVal ColorType As TAnnotColor, ByVal CS As TPDFColorSpace, ByVal Color As Long) As Boolean
   SetAnnotColor = pdfSetAnnotColor(m_Instance, Handle, ColorType, CS, Color) <> 0
End Function

Friend Function SetAnnotFlags(ByVal Flags As TAnnotFlags) As Boolean
   SetAnnotFlags = pdfSetAnnotFlags(m_Instance, Flags) <> 0
End Function

Friend Function SetAnnotFlagsEx(ByVal Handle As Long, ByVal Flags As Long) As Boolean
   SetAnnotFlagsEx = pdfSetAnnotFlagsEx(m_Instance, Handle, Flags) <> 0
End Function

Friend Function SetAnnotHighlightMode(ByVal Handle As Long, ByVal Mode As THighlightMode) As Boolean
   SetAnnotHighlightMode = pdfSetAnnotHighlightMode(m_Instance, Handle, Mode) <> 0
End Function

Friend Function SetAnnotIcon(ByVal Handle As Long, ByVal Icon As TAnnotIcon) As Boolean
   SetAnnotIcon = pdfSetAnnotIcon(m_Instance, Handle, Icon) <> 0
End Function

Friend Function SetAnnotOpenState(ByVal Handle As Long, ByVal DoOpen As Boolean) As Boolean
   SetAnnotOpenState = pdfSetAnnotOpenState(m_Instance, Handle, DoOpen) <> 0
End Function

Friend Function SetAnnotStringA(ByVal Handle As Long, ByVal StringType As TAnnotString, ByVal Value As String) As Boolean
   SetAnnotStringA = pdfSetAnnotStringA(m_Instance, Handle, StringType, Value) <> 0
End Function

Friend Function SetAnnotStringW(ByVal Handle As Long, ByVal StringType As TAnnotString, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetAnnotStringW = pdfSetAnnotStringW(m_Instance, Handle, StringType, s) <> 0
End Function

Friend Function SetAnnotSubjectA(ByVal Handle As Long, ByVal Value As String) As Boolean
   SetAnnotSubjectA = pdfSetAnnotSubjectA(m_Instance, Handle, Value) <> 0
End Function

Friend Function SetAnnotSubjectW(ByVal Handle As Long, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetAnnotSubjectW = pdfSetAnnotSubjectW(m_Instance, Handle, s) <> 0
End Function

Friend Function SetBBox(ByVal Boundary As TPageBoundary, ByVal LeftX As Double, ByVal LeftY As Double, ByVal RightX As Double, ByVal RightY As Double) As Boolean
   SetBBox = pdfSetBBox(m_Instance, Boundary, LeftX, LeftY, RightX, RightY) <> 0
End Function

Friend Function SetBidiMode(ByVal Mode As TPDFBidiMode) As Boolean
   SetBidiMode = pdfSetBidiMode(m_Instance, Mode) <> 0
End Function

Friend Function SetBookmarkDest(ByVal ABmk As Long, ByVal DestType As TDestType, ByVal a As Double, ByVal b As Double, ByVal c As Double, ByVal d As Double) As Boolean
   SetBookmarkDest = pdfSetBookmarkDest(m_Instance, ABmk, DestType, a, b, c, d) <> 0
End Function

Friend Function SetBookmarkStyle(ByVal ABmk As Long, ByVal Style As TFStyle, ByVal RGBColor As Long) As Boolean
   SetBookmarkStyle = pdfSetBookmarkStyle(m_Instance, ABmk, Style, RGBColor) <> 0
End Function

Friend Function SetBorderStyle(ByVal Style As TBorderStyle) As Boolean
   SetBorderStyle = pdfSetBorderStyle(m_Instance, Style) <> 0
End Function

Friend Function SetCharacterSpacing(ByVal Value As Double) As Boolean
   SetCharacterSpacing = pdfSetCharacterSpacing(m_Instance, Value) <> 0
End Function

Friend Function SetCheckBoxChar(ByVal CheckBoxChar As TCheckBoxChar) As Boolean
   SetCheckBoxChar = pdfSetCheckBoxChar(m_Instance, CheckBoxChar) <> 0
End Function

Friend Function SetCheckBoxDefState(ByVal Field As Long, ByVal Checked As Boolean) As Boolean
   SetCheckBoxDefState = pdfSetCheckBoxDefState(m_Instance, Field, Checked) <> 0
End Function

Friend Function SetCheckBoxState(ByVal Field As Long, ByVal Checked As Boolean) As Boolean
   SetCheckBoxState = pdfSetCheckBoxState(m_Instance, Field, Checked) <> 0
End Function

Friend Function SetCIDFontA(ByVal CMapHandle As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean) As Long
   SetCIDFontA = pdfSetCIDFontA(m_Instance, CMapHandle, Name, Style, Size, Embed)
End Function

Friend Function SetCIDFontW(ByVal CMapHandle As Long, ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   SetCIDFontW = pdfSetCIDFontW(m_Instance, CMapHandle, s, Style, Size, Embed)
End Function

Friend Function SetCMapDirA(ByVal Path As String, ByVal Recursive As Boolean) As Long
   SetCMapDirA = pdfSetCMapDirA(m_Instance, Path, Recursive)
End Function

Friend Function SetCMapDirW(ByVal Path As String, ByVal Recursive As Boolean) As Long
   Dim s As String
   s = StrConv(Path, vbUnicode)
   SetCMapDirW = pdfSetCMapDirW(m_Instance, s, Recursive)
End Function

Friend Function SetColDefFile(ByVal EmbFile As Long) As Boolean
   SetColDefFile = pdfSetColDefFile(m_Instance, EmbFile) <> 0
End Function

Friend Function SetColors(ByVal Color As Long) As Boolean
   SetColors = pdfSetColors(m_Instance, Color) <> 0
End Function

Friend Function SetColorSpace(ByVal ColorSpace As TPDFColorSpace) As Boolean
   SetColorSpace = pdfSetColorSpace(m_Instance, ColorSpace) <> 0
End Function

Friend Function SetColSortField(ByVal ColField As Long, ByVal AscendingOrder As Long) As Boolean
   SetColSortField = pdfSetColSortField(m_Instance, ColField, AscendingOrder) <> 0
End Function

Friend Function SetCompressionFilter(ByVal ComprFilter As TCompressionFilter) As Boolean
   SetCompressionFilter = pdfSetCompressionFilter(m_Instance, ComprFilter) <> 0
End Function

Friend Function SetCompressionLevel(ByVal CompressLevel As TCompressionLevel) As Boolean
   SetCompressionLevel = pdfSetCompressionLevel(m_Instance, CompressLevel) <> 0
End Function

Friend Function SetContent(ByRef Buffer() As Byte) As Boolean
   Dim BufSize As Long
   BufSize = UBound(Buffer)
   SetContent = pdfSetContent(m_Instance, Buffer(0), BufSize + 1) <> 0
End Function

Friend Function SetDateTimeFormat(ByVal TxtField As Long, ByVal Fmt As TPDFDateTime) As Boolean
   SetDateTimeFormat = pdfSetDateTimeFormat(m_Instance, TxtField, Fmt) <> 0
End Function

Friend Function SetDefBitsPerPixel(ByVal Value As Long) As Boolean
   SetDefBitsPerPixel = pdfSetDefBitsPerPixel(m_Instance, Value) <> 0
End Function

Friend Function SetDocInfoA(ByVal DInfo As TDocumentInfo, ByVal Value As String) As Boolean
   SetDocInfoA = pdfSetDocInfoA(m_Instance, DInfo, Value) <> 0
End Function

Friend Function SetDocInfoW(ByVal DInfo As TDocumentInfo, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetDocInfoW = pdfSetDocInfoW(m_Instance, DInfo, s) <> 0
End Function

Friend Function SetDocInfoExA(ByVal DInfo As TDocumentInfo, ByVal Key As String, ByVal Value As String) As Boolean
   SetDocInfoExA = pdfSetDocInfoExA(m_Instance, DInfo, Key, Value) <> 0
End Function

Friend Function SetDocInfoExW(ByVal DInfo As TDocumentInfo, ByVal Key As String, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetDocInfoExW = pdfSetDocInfoExW(m_Instance, DInfo, Key, s) <> 0
End Function

Friend Function SetDrawDirection(ByVal Direction As TDrawDirection) As Boolean
   SetDrawDirection = pdfSetDrawDirection(m_Instance, Direction) <> 0
End Function

Friend Function SetEMFFrameDPI(ByVal DPIX As Long, ByVal DPIY As Long) As Boolean
   SetEMFFrameDPI = pdfSetEMFFrameDPI(m_Instance, DPIX, DPIY) <> 0
End Function

Friend Function SetEMFPatternDistance(ByVal Value As Double) As Boolean
   SetEMFPatternDistance = pdfSetEMFPatternDistance(m_Instance, Value) <> 0
End Function

Friend Function SetErrorMode(ByVal ErrMode As TErrMode) As Boolean
   SetErrorMode = pdfSetErrorMode(m_Instance, ErrMode) <> 0
End Function

Friend Function SetExtColorSpace(ByVal Handle As Long) As Boolean
   SetExtColorSpace = pdfSetExtColorSpace(m_Instance, Handle) <> 0
End Function

Friend Function SetExtGState(ByVal Handle As Long) As Boolean
   SetExtGState = pdfSetExtGState(m_Instance, Handle) <> 0
End Function

Friend Function SetFieldBackColor(ByVal AColor As Long) As Boolean
   SetFieldBackColor = pdfSetFieldBackColor(m_Instance, AColor) <> 0
End Function

Friend Function SetFieldBBox(ByVal Field As Long, ByRef BBox As TPDFRect) As Boolean
    SetFieldBBox = pdfSetFieldBBox(m_Instance, Field, BBox) <> 0
End Function

Friend Function SetFieldBorderColor(ByVal AColor As Long) As Boolean
   SetFieldBorderColor = pdfSetFieldBorderColor(m_Instance, AColor) <> 0
End Function

Friend Function SetFieldBorderStyle(ByVal Field As Long, ByVal aStyle As TBorderStyle) As Boolean
   SetFieldBorderStyle = pdfSetFieldBorderStyle(m_Instance, Field, aStyle) <> 0
End Function

Friend Function SetFieldBorderWidth(ByVal Field As Long, ByVal LineWidth As Double) As Boolean
   SetFieldBorderWidth = pdfSetFieldBorderWidth(m_Instance, Field, LineWidth) <> 0
End Function

Friend Function SetFieldColor(ByVal Field As Long, ByVal ColorType As TFieldColor, ByVal CS As TPDFColorSpace, ByVal Color As Long) As Boolean
   SetFieldColor = pdfSetFieldColor(m_Instance, Field, ColorType, CS, Color) <> 0
End Function

Friend Function SetFieldExpValue(ByVal Field As Long, ByVal ValIndex As Long, ByVal Value As String, ByVal ExpValue As String, ByVal Selected As Boolean) As Boolean
   SetFieldExpValue = pdfSetFieldExpValue(m_Instance, Field, ValIndex, Value, ExpValue, Selected) <> 0
End Function

Friend Function SetFieldFlags(ByVal Field As Long, ByVal Flags As TFieldFlags, ByVal DoReset As Boolean) As Boolean
   SetFieldFlags = pdfSetFieldFlags(m_Instance, Field, Flags, DoReset) <> 0
End Function

Friend Function SetFieldFontSize(ByVal Field As Long, ByVal FontSize As Double) As Boolean
    SetFieldFontSize = pdfSetFieldFontSize(m_Instance, Field, FontSize) <> 0
End Function

Friend Function SetFieldHighlightMode(ByVal Field As Long, ByVal Mode As THighlightMode) As Boolean
   SetFieldHighlightMode = pdfSetFieldHighlightMode(m_Instance, Field, Mode) <> 0
End Function

Friend Function SetFieldIndex(ByVal Field As Long, ByVal Index As Long) As Boolean
   SetFieldIndex = pdfSetFieldIndex(m_Instance, Field, Index) <> 0
End Function

Friend Function SetFieldMapNameA(ByVal Field As Long, ByVal Value As String) As Boolean
   SetFieldMapNameA = pdfSetFieldMapNameA(m_Instance, Field, Value) <> 0
End Function

Friend Function SetFieldMapNameW(ByVal Field As Long, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetFieldMapNameW = pdfSetFieldMapNameW(m_Instance, Field, s) <> 0
End Function

Friend Function SetFieldName(ByVal Field As Long, ByVal NewName As String) As Boolean
   SetFieldName = pdfSetFieldName(m_Instance, Field, NewName) <> 0
End Function

Friend Function SetFieldOrientation(ByVal Field As Long, ByVal Value As Long) As Boolean
   SetFieldOrientation = pdfSetFieldOrientation(m_Instance, Field, Value) <> 0
End Function

Friend Function SetFieldTextAlign(ByVal Field As Long, ByVal Align As TTextAlign) As Boolean
   SetFieldTextAlign = pdfSetFieldTextAlign(m_Instance, Field, Align) <> 0
End Function

Friend Function SetFieldTextColor(ByVal Color As Long) As Boolean
   SetFieldTextColor = pdfSetFieldTextColor(m_Instance, Color) <> 0
End Function

Friend Function SetFieldToolTipA(ByVal Field As Long, ByVal Value As String) As Boolean
   SetFieldToolTipA = pdfSetFieldToolTipA(m_Instance, Field, Value) <> 0
End Function

Friend Function SetFieldToolTipW(ByVal Field As Long, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetFieldToolTipW = pdfSetFieldToolTipW(m_Instance, Field, s) <> 0
End Function

Friend Function SetFillColor(ByVal Color As Long) As Boolean
   SetFillColor = pdfSetFillColor(m_Instance, Color) <> 0
End Function

Friend Function SetFillColorEx(ByRef Color() As Byte, ByVal NumComponents As Long) As Boolean
   SetFillColorEx = pdfSetFillColorEx(m_Instance, Color(0), NumComponents) <> 0
End Function

Friend Function SetFontA(ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean, ByVal CP As TCodepage) As Long
   SetFontA = pdfSetFontA(m_Instance, Name, Style, Size, Embed, CP)
End Function

Friend Function SetFontW(ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean, ByVal CP As TCodepage) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   SetFontW = pdfSetFontW(m_Instance, s, Style, Size, Embed, CP)
End Function

Friend Function SetFontExA(ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean, ByVal CP As TCodepage) As Long
   SetFontExA = pdfSetFontExA(m_Instance, Name, Style, Size, Embed, CP)
End Function

Friend Function SetFontExW(ByVal Name As String, ByVal Style As TFStyle, ByVal Size As Double, ByVal Embed As Boolean, ByVal CP As TCodepage) As Long
   Dim s As String
   s = StrConv(Name, vbUnicode)
   SetFontExW = pdfSetFontExW(m_Instance, s, Style, Size, Embed, CP)
End Function

Friend Function SetFontOrigin(ByVal Origin As TOrigin) As Boolean
   SetFontOrigin = pdfSetFontOrigin(m_Instance, Origin) <> 0
End Function

Friend Sub SetFontSearchOrder(ByRef Order() As TFontBaseType)
   pdfSetFontSearchOrder m_Instance, Order(0)
End Sub

Friend Function SetFontSelMode(ByVal Mode As TFontSelMode) As Boolean
   SetFontSelMode = pdfSetFontSelMode(m_Instance, Mode) <> 0
End Function

Friend Function SetFontWeight(ByVal Weight As Long) As Boolean
   SetFontWeight = pdfSetFontWeight(m_Instance, Weight) <> 0
End Function

Friend Sub SetGStateFlags(ByVal Flags As TGStateFlags, ByVal Reset As Boolean)
   pdfSetGStateFlags m_Instance, Flags, Reset
End Sub

Friend Function SetIconColor(ByVal Color As Long) As Boolean
   SetIconColor = pdfSetIconColor(m_Instance, Color) <> 0
End Function

Friend Function SetImportFlags(ByVal Flags As TImportFlags) As Boolean
   SetImportFlags = pdfSetImportFlags(m_Instance, Flags) <> 0
End Function

Friend Function SetImportFlags2(ByVal Flags As TImportFlags2) As Boolean
   SetImportFlags2 = pdfSetImportFlags2(m_Instance, Flags) <> 0
End Function

Friend Function SetItalicAngle(ByVal Angle As Double) As Boolean
   SetItalicAngle = pdfSetItalicAngle(m_Instance, Angle) <> 0
End Function

Friend Function SetJPEGQuality(ByVal Value As Long) As Boolean
   SetJPEGQuality = pdfSetJPEGQuality(m_Instance, Value) <> 0
End Function

Friend Function SetLanguage(ByVal ISOTag As String) As Boolean
   SetLanguage = pdfSetLanguage(m_Instance, ISOTag) <> 0
End Function

Friend Function SetLeading(ByVal Value As Double) As Boolean
   SetLeading = pdfSetLeading(m_Instance, Value) <> 0
End Function

Friend Function SetLicenseKey(ByVal Value As String) As Boolean
   SetLicenseKey = pdfSetLicenseKey(m_Instance, Value) <> 0
End Function

Friend Function SetLineCapStyle(ByVal Style As TLineCapStyle) As Boolean
   SetLineCapStyle = pdfSetLineCapStyle(m_Instance, Style) <> 0
End Function

Friend Function SetLineDashPattern(ByVal Dash As String, ByVal Phase As Long) As Boolean
   SetLineDashPattern = pdfSetLineDashPattern(m_Instance, Dash, Phase) <> 0
End Function

Friend Function SetLineDashPatternEx(Dash() As Double, ByVal NumValues As Long, ByVal Phase As Long) As Boolean
   SetLineDashPatternEx = pdfSetLineDashPatternEx(m_Instance, Dash(0), NumValues, Phase) <> 0
End Function

Friend Function SetLineJoinStyle(ByVal Style As TLineJoinStyle) As Boolean
   SetLineJoinStyle = pdfSetLineJoinStyle(m_Instance, Style) <> 0
End Function

Friend Function SetLineWidth(ByVal Value As Double) As Boolean
   SetLineWidth = pdfSetLineWidth(m_Instance, Value) <> 0
End Function

Friend Function SetLinkHighlightMode(ByVal Mode As THighlightMode) As Boolean
   SetLinkHighlightMode = pdfSetLinkHighlightMode(m_Instance, Mode) <> 0
End Function

Friend Function SetListFont(ByVal Handle As Long) As Boolean
   SetListFont = pdfSetListFont(m_Instance, Handle) <> 0
End Function

Friend Function SetMatrix(ByRef Matrix As TCTM) As Boolean
   SetMatrix = pdfSetMatrix(m_Instance, Matrix) <> 0
End Function

Friend Function SetMaxFieldLen(ByVal TxtField As Long, ByVal MaxLen As Long) As Boolean
   SetMaxFieldLen = pdfSetMaxFieldLen(m_Instance, TxtField, MaxLen) <> 0
End Function

Friend Function SetMetaConvFlags(ByVal Flags As TMetaFlags) As Boolean
   SetMetaConvFlags = pdfSetMetaConvFlags(m_Instance, Flags) <> 0
End Function

Friend Function SetMiterLimit(ByVal Value As Double) As Boolean
   SetMiterLimit = pdfSetMiterLimit(m_Instance, Value) <> 0
End Function

Friend Function SetNeedAppearance(ByVal Value As Boolean) As Boolean
   SetNeedAppearance = pdfSetNeedAppearance(m_Instance, Value) <> 0
End Function

Friend Function SetNumberFormat(ByVal TxtField As Long, ByVal Sep As TDecSeparator, ByVal DecPlaces As Long, ByVal NegStyle As TNegativeStyle, ByVal CurrStr As String, ByVal Prepend As Long) As Boolean
   SetNumberFormat = pdfSetNumberFormat(m_Instance, TxtField, Sep, DecPlaces, NegStyle, CurrStr, Prepend) <> 0
End Function

Friend Function SetOpacity(ByVal Value As Double) As Boolean
   SetOpacity = pdfSetOpacity(m_Instance, Value) <> 0
End Function

Friend Function SetOrientation(ByVal Value As Long) As Boolean
   SetOrientation = pdfSetOrientation(m_Instance, Value) <> 0
End Function

Friend Function SetOrientationEx(ByVal Value As Long) As Boolean
   SetOrientationEx = pdfSetOrientationEx(m_Instance, Value) <> 0
End Function

Friend Function SetPageCoords(ByVal PageCoords As TPageCoord) As Boolean
   SetPageCoords = pdfSetPageCoords(m_Instance, PageCoords) <> 0
End Function

Friend Function SetPageFormat(ByVal Value As TPageFormat) As Boolean
   SetPageFormat = pdfSetPageFormat(m_Instance, Value) <> 0
End Function

Friend Function SetPageHeight(ByVal Value As Double) As Boolean
   SetPageHeight = pdfSetPageHeight(m_Instance, Value) <> 0
End Function

Friend Function SetPageLayout(ByVal Layout As TPageLayout) As Boolean
   SetPageLayout = pdfSetPageLayout(m_Instance, Layout) <> 0
End Function

Friend Function SetPageMode(ByVal Mode As TPageMode) As Boolean
   SetPageMode = pdfSetPageMode(m_Instance, Mode) <> 0
End Function

Friend Function SetPageWidth(ByVal Value As Double) As Boolean
   SetPageWidth = pdfSetPageWidth(m_Instance, Value) <> 0
End Function

Friend Function SetPDFVersion(ByVal Version As TPDFVersion) As Boolean
   SetPDFVersion = pdfSetPDFVersion(m_Instance, Version) <> 0
End Function

Friend Function SetPrintSettings(ByVal Mode As TDuplexMode, ByVal PickTrayByPDFSize As Long, ByVal NumCopies As Long, ByVal PrintScaling As TPrintScaling, ByRef PrintRanges() As Long) As Boolean
   SetPrintSettings = pdfSetPrintSettings(m_Instance, Mode, PickTrayByPDFSize, NumCopies, PrintScaling, VarPtr(PrintRanges(0)), (UBound(PrintRanges) + 1) / 2) <> 0
End Function

Friend Function SetResolution(ByVal Value As Long) As Boolean
   SetResolution = pdfSetResolution(m_Instance, Value) <> 0
End Function

Friend Function SetSaveNewImageFormat(ByVal Value As Boolean) As Boolean
   SetSaveNewImageFormat = pdfSetSaveNewImageFormat(m_Instance, Value) <> 0
End Function

Friend Function SetStrokeColor(ByVal Color As Long) As Boolean
   SetStrokeColor = pdfSetStrokeColor(m_Instance, Color) <> 0
End Function

Friend Function SetStrokeColorEx(ByRef Color() As Byte, ByVal NumComponents As Long) As Boolean
   SetStrokeColorEx = pdfSetStrokeColorEx(m_Instance, Color(0), NumComponents) <> 0
End Function

Friend Function SetTabLen(ByVal TabLen As Long) As Boolean
   SetTabLen = pdfSetTabLen(m_Instance, TabLen) <> 0
End Function

Friend Function SetTextDrawMode(ByVal Mode As TDrawMode) As Boolean
   SetTextDrawMode = pdfSetTextDrawMode(m_Instance, Mode) <> 0
End Function

Friend Function SetTextFieldValueA(ByVal Field As Long, ByVal Value As String, ByVal DefValue As String, ByVal Align As TTextAlign) As Boolean
   SetTextFieldValueA = pdfSetTextFieldValueA(m_Instance, Field, Value, DefValue, Align) <> 0
End Function

Friend Function SetTextFieldValueW(ByVal Field As Long, ByVal Value As String, ByVal DefValue As String, ByVal Align As TTextAlign) As Boolean
   Dim s1 As String, s2 As String
   s1 = StrConv(Value, vbUnicode)
   s2 = StrConv(DefValue, vbUnicode)
   SetTextFieldValueW = pdfSetTextFieldValueW(m_Instance, Field, s1, s2, Align) <> 0
End Function

Friend Function SetTextFieldValueExA(ByVal Field As Long, ByVal Value As String) As Boolean
   SetTextFieldValueExA = pdfSetTextFieldValueExA(m_Instance, Field, Value) <> 0
End Function

Friend Function SetTextFieldValueExW(ByVal Field As Long, ByVal Value As String) As Boolean
   Dim s As String
   s = StrConv(Value, vbUnicode)
   SetTextFieldValueExW = pdfSetTextFieldValueExW(m_Instance, Field, s) <> 0
End Function

Friend Function SetTextRect(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double) As Boolean
   SetTextRect = pdfSetTextRect(m_Instance, PosX, PosY, Width, Height) <> 0
End Function

Friend Function SetTextRise(ByVal Value As Double) As Boolean
   SetTextRise = pdfSetTextRise(m_Instance, Value) <> 0
End Function

Friend Function SetTextScaling(ByVal Value As Double) As Boolean
   SetTextScaling = pdfSetTextScaling(m_Instance, Value) <> 0
End Function

Friend Function SetTransparentColor(ByVal AColor As Long) As Boolean
   SetTransparentColor = pdfSetTransparentColor(m_Instance, AColor) <> 0
End Function

Friend Sub SetTrapped(ByVal Value As Boolean)
   pdfSetTrapped m_Instance, Value
End Sub

Friend Function SetUseExactPwd(ByVal Value As Boolean) As Boolean
   SetUseExactPwd = pdfSetUseExactPwd(m_Instance, Value) <> 0
End Function

Friend Function SetUseGlobalImpFiles(ByVal Value As Boolean) As Boolean
   SetUseGlobalImpFiles = pdfSetUseGlobalImpFiles(m_Instance, Value) <> 0
End Function

Friend Function SetUseStdFonts(ByVal Value As Boolean) As Boolean
   SetUseStdFonts = pdfSetUseStdFonts(m_Instance, Value) <> 0
End Function

Friend Function SetUseSwapFile(ByVal SwapContents As Boolean, ByVal SwapLimit As Long) As Boolean
   SetUseSwapFile = pdfSetUseSwapFile(m_Instance, SwapContents, SwapLimit) <> 0
End Function

Friend Function SetUseSwapFileEx(ByVal SwapContents As Boolean, ByVal SwapLimit As Long, ByVal SwapDir As String) As Boolean
   SetUseSwapFileEx = pdfSetUseSwapFileEx(m_Instance, SwapContents, SwapLimit, SwapDir) <> 0
End Function

Friend Function SetUseSystemFonts(ByVal Value As Boolean) As Boolean
   SetUseSystemFonts = pdfSetUseSystemFonts(m_Instance, Value) <> 0
End Function

Friend Function SetUseTransparency(ByVal Value As Boolean) As Boolean
   SetUseTransparency = pdfSetUseTransparency(m_Instance, Value) <> 0
End Function

Friend Function SetUseVisibleCoords(ByVal Value As Boolean) As Boolean
   SetUseVisibleCoords = pdfSetUseVisibleCoords(m_Instance, Value) <> 0
End Function

Friend Function SetViewerPreferences(ByVal Value As TViewerPreference, ByVal AddVal As TViewPrefAddVal) As Boolean
   SetViewerPreferences = pdfSetViewerPreferences(m_Instance, Value, AddVal) <> 0
End Function

Friend Function SetWMFDefExtent(ByVal Width As Long, ByVal Height As Long) As Boolean
   SetWMFDefExtent = pdfSetWMFDefExtent(m_Instance, Width, Height) <> 0
End Function

Friend Function SetWMFPixelPerInch(ByVal Value As Long) As Boolean
   SetWMFPixelPerInch = pdfSetWMFPixelPerInch(m_Instance, Value) <> 0
End Function

Friend Function SetWordSpacing(ByVal Value As Double) As Boolean
   SetWordSpacing = pdfSetWordSpacing(m_Instance, Value) <> 0
End Function

Friend Function SkewCoords(ByVal alpha As Double, ByVal beta As Double, ByVal OriginX As Double, ByVal OriginY As Double) As Boolean
   SkewCoords = pdfSkewCoords(m_Instance, alpha, beta, OriginX, OriginY) <> 0
End Function

Friend Function SortFieldsByIndex() As Boolean
   SortFieldsByIndex = pdfSortFieldsByIndex(m_Instance) <> 0
End Function

Friend Function SortFieldsByName() As Boolean
   SortFieldsByName = pdfSortFieldsByName(m_Instance) <> 0
End Function

Friend Function StampAnnotA(ByVal Subtype As TRubberStamp, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
   StampAnnotA = pdfStampAnnotA(m_Instance, Subtype, PosX, PosY, Width, Height, Author, Subject, Comment)
End Function

Friend Function StampAnnotW(ByVal Subtype As TRubberStamp, ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Subject As String, ByVal Comment As String) As Long
   Dim a As String
   Dim s As String
   Dim c As String
   a = StrConv(Author, vbUnicode)
   s = StrConv(Subject, vbUnicode)
   c = StrConv(Comment, vbUnicode)
   StampAnnotW = pdfStampAnnotW(m_Instance, Subtype, PosX, PosY, Width, Height, a, s, c)
End Function

Friend Function StrLenA(ByVal AStr) As Long
   StrLenA = pdfStrLenA(AStr)
End Function

Friend Function StrokePath() As Boolean
   StrokePath = pdfStrokePath(m_Instance) <> 0
End Function

Friend Function TextAnnotA(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Text As String, ByVal Icon As TAnnotIcon, ByVal DoOpen As Boolean) As Long
   TextAnnotA = pdfTextAnnotA(m_Instance, PosX, PosY, Width, Height, Author, Text, Icon, DoOpen)
End Function

Friend Function TextAnnotW(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Author As String, ByVal Text As String, ByVal Icon As TAnnotIcon, ByVal DoOpen As Boolean) As Long
   Dim s1 As String, s2 As String
   s1 = StrConv(Author, vbUnicode)
   s2 = StrConv(Text, vbUnicode)
   TextAnnotW = pdfTextAnnotW(m_Instance, PosX, PosY, Width, Height, s1, s2, Icon, DoOpen)
End Function

Friend Function TranslateCoords(ByVal OriginX As Double, ByVal OriginY As Double) As Boolean
   TranslateCoords = pdfTranslateCoords(m_Instance, OriginX, OriginY) <> 0
End Function

Friend Function TranslateRawCode(ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByRef Width As Double, ByRef OutText As String, ByRef OutLen As Long, ByRef Decoded As Long, ByVal CharSpacing As Single, ByVal WordSpacing As Single, ByVal TextScale As Single) As Long
   TranslateRawCode = fntTranslateRawCode(IFont, Text, sLen, Width, StrPtr(OutText), OutLen, Decoded, CharSpacing, WordSpacing, TextScale)
End Function

Friend Function TranslateString(ByRef Stack As TPDFStack, ByRef OutText As String, ByVal Flags As Long) As Long
   TranslateString = fntTranslateString(FStack, StrPtr(OutText), Len(OutText), Flags)
End Function

Friend Function TranslateString2(ByVal IFont As Long, ByVal Text As Long, ByVal sLen As Long, ByRef OutText As String, ByVal Flags As Long) As Long
   TranslateString2 = fntTranslateString2(IFont, Text, sLen, StrPtr(OutText), Len(OutText), Flags)
End Function

Friend Function Triangle(ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double, ByVal x3 As Double, ByVal y3 As Double, ByVal FillMode As TPathFillMode) As Boolean
   Triangle = pdfTriangle(m_Instance, x1, y1, x2, y2, x3, y3, FillMode) <> 0
End Function

Friend Function WebLinkA(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal URL As String) As Long
   WebLinkA = pdfWebLinkA(m_Instance, PosX, PosY, Width, Height, URL)
End Function

Friend Function WebLinkW(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal URL As String) As Long
   Dim s As String
   s = StrConv(URL, vbUnicode)
   WebLinkW = pdfWebLinkW(m_Instance, PosX, PosY, Width, Height, s)
End Function

Friend Function WeightFromStyle(ByVal Style As TFStyle) As Long
   WeightFromStyle = ((Style And Not &HC00FFFFF) / 1048576)
End Function

Friend Function WeightToStyle(ByVal Weight As Long) As TFStyle
   WeightToStyle = Weight * 1048576
End Function

Friend Function WidthFromStyle(ByVal Style As TFStyle) As Long
   WidthFromStyle = ((Style And Not &HFFF2D00F) / 256)
End Function

Friend Function WidthToStyle(ByVal Width As Long) As TFStyle
   WidthToStyle = Width * 256
End Function

Friend Function WriteAngleTextA(ByVal AText As String, ByVal Angle As Double, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal YOrigin As Double) As Boolean
   WriteAngleTextA = pdfWriteAngleTextA(m_Instance, AText, Angle, PosX, PosY, Radius, YOrigin) <> 0
End Function

Friend Function WriteAngleTextW(ByVal AText As String, ByVal Angle As Double, ByVal PosX As Double, ByVal PosY As Double, ByVal Radius As Double, ByVal YOrigin As Double) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   WriteAngleTextW = pdfWriteAngleTextW(m_Instance, s, Angle, PosX, PosY, Radius, YOrigin) <> 0
End Function

Friend Function WriteFTextA(ByVal Align As TTextAlign, ByVal AText As String) As Boolean
   WriteFTextA = pdfWriteFTextA(m_Instance, Align, AText) <> 0
End Function

Friend Function WriteFTextW(ByVal Align As TTextAlign, ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   WriteFTextW = pdfWriteFTextW(m_Instance, Align, s) <> 0
End Function

Friend Function WriteFTextExA(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Align As TTextAlign, ByVal AText As String) As Boolean
   WriteFTextExA = pdfWriteFTextExA(m_Instance, PosX, PosY, Width, Height, Align, AText) <> 0
End Function

Friend Function WriteFTextExW(ByVal PosX As Double, ByVal PosY As Double, ByVal Width As Double, ByVal Height As Double, ByVal Align As TTextAlign, ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   WriteFTextExW = pdfWriteFTextExW(m_Instance, PosX, PosY, Width, Height, Align, s) <> 0
End Function

Friend Function WriteTextA(ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String) As Boolean
   WriteTextA = pdfWriteTextA(m_Instance, PosX, PosY, AText) <> 0
End Function

Friend Function WriteTextW(ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   WriteTextW = pdfWriteTextW(m_Instance, PosX, PosY, s) <> 0
End Function

Friend Function WriteTextExA(ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String, ByVal sLen As Long) As Boolean
   WriteTextExA = pdfWriteTextExA(m_Instance, PosX, PosY, AText, sLen) <> 0
End Function

Friend Function WriteTextExW(ByVal PosX As Double, ByVal PosY As Double, ByVal AText As String, ByVal sLen As Long) As Boolean
   Dim s As String
   s = StrConv(Mid(AText, 1, sLen), vbUnicode)
   WriteTextExW = pdfWriteTextExW(m_Instance, PosX, PosY, s, LenB(s) / 2) <> 0
End Function

Friend Function WriteTextMatrixA(ByRef Matrix As TCTM, ByVal AText As String) As Boolean
   WriteTextMatrixA = pdfWriteTextMatrixA(m_Instance, Matrix, AText) <> 0
End Function

Friend Function WriteTextMatrixW(ByRef Matrix As TCTM, ByVal AText As String) As Boolean
   Dim s As String
   s = StrConv(AText, vbUnicode)
   WriteTextMatrixW = pdfWriteTextMatrixW(m_Instance, Matrix, s) <> 0
End Function

Friend Function WriteTextMatrixExA(ByRef Matrix As TCTM, ByVal AText As String, ByVal sLen As Long) As Boolean
   WriteTextMatrixExA = pdfWriteTextMatrixExA(m_Instance, Matrix, AText, sLen) <> 0
End Function

Friend Function WriteTextMatrixExW(ByRef Matrix As TCTM, ByVal AText As String, ByVal sLen As Long) As Boolean
   Dim s As String
   s = StrConv(Mid(AText, 1, sLen), vbUnicode)
   WriteTextMatrixExW = pdfWriteTextMatrixExW(m_Instance, Matrix, s, LenB(s) / 2) <> 0
End Function

' ------------------------------------------------- Private Functions -------------------------------------------------

Private Sub GetIntAnnot(ByRef IAnnot As TPDFAnnotation_I, ByRef Annot As TPDFAnnotation)
   Annot.AnnotType = IAnnot.AnnotType
   Annot.Author = ToStringEx(IAnnot.AuthorA, IAnnot.AuthorW)
   Annot.Content = ToStringEx(IAnnot.ContentA, IAnnot.ContentW)
   Annot.Deleted = IAnnot.Deleted
   Annot.BBox = IAnnot.BBox
   Annot.BorderWidth = IAnnot.BorderWidth
   Annot.BorderColor = IAnnot.BorderColor
   Annot.BorderStyle = IAnnot.BorderStyle
   Annot.BackColor = IAnnot.BackColor
   Annot.Handle = IAnnot.Handle
   Annot.HighlightMode = IAnnot.HighlightMode
   Annot.Name = ToStringEx(IAnnot.NameA, IAnnot.NameW)
   Annot.PageNum = IAnnot.PageNum
   Annot.Subject = ToStringEx(IAnnot.SubjectA, IAnnot.SubjectW)
End Sub

Private Sub GetIntAnnotEx(ByRef IAnnot As TPDFAnnotationEx_I, ByRef Annot As TPDFAnnotationEx)
   Annot.AnnotType = IAnnot.AnnotType
   Annot.Author = ToStringEx(IAnnot.AuthorA, IAnnot.AuthorW)
   Annot.Content = ToStringEx(IAnnot.ContentA, IAnnot.ContentW)
   Annot.Deleted = IAnnot.Deleted
   Annot.BBox = IAnnot.BBox
   Annot.BorderWidth = IAnnot.BorderWidth
   Annot.BorderColor = IAnnot.BorderColor
   Annot.BorderStyle = IAnnot.BorderStyle
   Annot.BackColor = IAnnot.BackColor
   Annot.Handle = IAnnot.Handle
   Annot.HighlightMode = IAnnot.HighlightMode
   Annot.Name = ToStringEx(IAnnot.NameA, IAnnot.NameW)
   Annot.PageNum = IAnnot.PageNum
   Annot.Subject = ToStringEx(IAnnot.SubjectA, IAnnot.SubjectW)
   Annot.DestPage = IAnnot.DestPage
   Annot.DestPos = IAnnot.DestPos
   Annot.DestType = IAnnot.DestType
   Annot.DestFile = ToString1(IAnnot.DestFile, False)
   Annot.Icon = IAnnot.Icon
   Annot.StampName = ToString1(IAnnot.StampName, False)
   Annot.AnnotFlags = IAnnot.AnnotFlags
   Annot.CreateDate = ToString1(IAnnot.CreateDate, False)
   Annot.ModDate = ToString1(IAnnot.ModDate, False)
   Annot.Grouped = IAnnot.Grouped <> 0
   Annot.Open = IAnnot.Open <> 0
   Annot.Parent = IAnnot.Parent
   Annot.PopUp = IAnnot.PopUp
   Annot.State = ToString1(IAnnot.State, False)
   Annot.StateModel = ToString1(IAnnot.StateModel, False)
   Annot.EmbeddedFile = IAnnot.EmbeddedFile
   Annot.Subtype = ToString1(IAnnot.Subtype, False)
End Sub

Private Sub GetIntColorSpaceObj(ByRef ics As TPDFColorSpaceObj_I, ByRef CS As TPDFColorSpaceObj)
   Dim i As Long
   CS.ColorSpaceType = ics.ColorSpaceType
   CS.Alternate = ics.Alternate
   CS.IAlternate = ics.IAlternate
   CS.Buffer = ics.Buffer
   CS.BufSize = ics.BufSize
   CS.NumInComponents = ics.NumInComponents
   CS.NumOutComponents = ics.NumOutComponents
   CS.NumColors = ics.NumColors
   CS.ColorantsCount = ics.ColorantsCount
   CS.Metadata = ics.Metadata
   CS.MetadataSize = ics.MetadataSize
   CS.IFunction = ics.IFunction
   CS.IAttributes = ics.IAttributes
   CS.IColorSpaceObj = ics.IColorSpaceObj
   If ics.BlackPoint <> 0 Then
      ReDim CS.BlackPoint(2)
      pdfCopyMem2 ics.BlackPoint, CS.BlackPoint(0), 12
   Else
      Erase CS.BlackPoint
   End If
   If ics.WhitePoint <> 0 Then
      ReDim CS.WhitePoint(2)
      pdfCopyMem2 ics.WhitePoint, CS.WhitePoint(0), 12
   Else
      Erase CS.WhitePoint
   End If
   If ics.Gamma <> 0 Then
      ReDim CS.Gamma(CS.NumInComponents - 1)
      pdfCopyMem2 ics.Gamma, CS.Gamma(0), CS.NumInComponents * 4
   Else
      Erase CS.Gamma
   End If
   If ics.Range <> 0 Then
      If ics.ColorSpaceType = esLab Then
         ReDim CS.Range(3)
         pdfCopyMem2 ics.Range, CS.Range(0), 16
      Else
         ReDim CS.Range(CS.NumInComponents * 2 - 1)
         pdfCopyMem2 ics.Range, CS.Range(0), CS.NumInComponents * 8
      End If
   Else
      Erase CS.Range
   End If
   If ics.Matrix <> 0 Then
      ReDim CS.Matrix(8)
      pdfCopyMem2 ics.Matrix, CS.Matrix(0), 36
   Else
      Erase CS.Matrix
   End If
   Erase CS.Colorants
   For i = 0 To CS.ColorantsCount - 1
      CS.Colorants(i) = UTF8ToString(ics.Colorants(i))
   Next i
End Sub

Private Sub GetIntField(ByRef Field As TPDFField)
   Field.BackColor = FField.BackColor
   Field.BBox.rBottom = FField.BBox.rBottom
   Field.BBox.rLeft = FField.BBox.rLeft
   Field.BBox.rRight = FField.BBox.rRight
   Field.BBox.rTop = FField.BBox.rTop
   Field.BorderColor = FField.BorderColor
   Field.Checked = FField.Checked <> 0
   Field.BackCS = FField.BackCS
   Field.TextCS = FField.TextCS
   Field.Deleted = FField.Deleted <> 0
   Field.FieldName = ToString3(FField.FieldName, FField.FieldNameLen)
   Field.FieldType = FField.FieldType
   Field.FontName = ToString1(FField.FontName, False)
   Field.FontSize = FField.FontSize
   Field.Handle = FField.Handle
   Field.KidCount = FField.KidCount
   Field.Parent = FField.Parent
   Field.TextColor = FField.TextColor
   Field.ToolTip = ToString2(FField.ToolTip, FField.ToolTipLen, FField.UniToolTip <> 0)
   Field.Value = ToString2(FField.Value, FField.valLen, FField.UniVal <> 0)
End Sub

Private Sub GetIntFieldEx(ByRef Source As TPDFFieldEx_I, ByRef Dest As TPDFFieldEx)
   Dest.BackColor = Source.BackColor
   Dest.BackColorSP = Source.BackColorSP
   Dest.BBox = Source.BBox
   Dest.BorderColor = Source.BorderColor
   Dest.BorderColorSP = Source.BorderColorSP
   Dest.BorderStyle = Source.BorderStyle
   Dest.BorderWidth = Source.BorderWidth
   Dest.CharSpacing = Source.CharSpacing
   Dest.CheckBoxChar = Source.CheckBoxChar
   Dest.Checked = Source.Checked <> 0
   Dest.DefState = Source.DefState
   Dest.DefValue = ToStringEx(Source.DefValueA, Source.DefValueW)
   Dest.Deleted = Source.Deleted <> 0
   Dest.EditFont = Source.EditFont
   Dest.ExpValCount = Source.ExpValCount
   Dest.ExpValue = ToStringEx(Source.ExpValueA, Source.ExpValueW)
   Dest.FieldFlags = Source.FieldFlags
   Dest.FieldFont = ToString1(Source.FieldFont, False)
   Dest.FieldName = ToStringEx(Source.FieldNameA, Source.FieldNameW)
   Dest.FieldType = Source.FieldType
   Dest.FontSize = Source.FontSize
   Dest.GroupType = Source.GroupType
   Dest.Handle = Source.Handle
   Dest.HighlightMode = Source.HighlightMode
   Dest.IEditFont = Source.IEditFont
   Dest.IFieldFont = Source.IFieldFont
   Dest.IsCalcField = Source.IsCalcField <> 0
   Dest.KidCount = Source.KidCount
   If Source.KidCount > 0 Then
      ReDim Dest.Kids(Source.KidCount - 1)
      Call pdfCopyMem2(Source.Kids, Dest.Kids(0), Source.KidCount * 4)
   Else
      Erase Dest.Kids
   End If
   Dest.MapName = ToStringEx(Source.MapNameA, Source.MapNameW)
   Dest.MaxLen = Source.MaxLen
   Dest.PageNum = Source.PageNum
   Dest.Parent = Source.Parent
   Dest.Rotate = Source.Rotate
   Dest.TextAlign = Source.TextAlign
   Dest.TextColor = Source.TextColor
   Dest.TextColorSP = Source.TextColorSP
   Dest.TextScaling = Source.TextScaling
   Dest.ToolTip = ToStringEx(Source.ToolTipA, Source.ToolTipW)
   Dest.UniqueName = ToStringEx(Source.UniqueNameA, Source.UniqueNameW)
   Dest.Value = ToStringEx(Source.ValueA, Source.ValueW)
   Dest.WordSpacing = Source.WordSpacing
End Sub

Private Function GetIntFont(ByRef IFont As TPDFFontObj_I, ByRef Font As TPDFFontObj)
   Font.Ascent = IFont.Ascent
   Font.BaseFont = ToString1(IFont.BaseFont, False)
   Font.CapHeight = IFont.CapHeight
   Font.DefWidth = IFont.DefWidth
   Font.Descent = IFont.Descent
   If IFont.Encoding <> 0 Then
      Font.Encoding = ToString2(IFont.Encoding, 256, True)
   Else
      Font.Encoding = ""
   End If
   Font.FirstChar = IFont.FirstChar
   Font.Flags = IFont.Flags
   Font.FontFamily = ToString1(IFont.FontFamily, IFont.FontFamilyUni <> 0)
   Font.FontName = ToString1(IFont.FontName, False)
   Font.FontType = IFont.FontType
   Font.ItalicAngle = IFont.ItalicAngle
   Font.LastChar = IFont.LastChar
   Font.spaceWidth = IFont.spaceWidth
   Font.XHeight = IFont.XHeight
   If IFont.WidthsCount > 0 Then
      ReDim Font.Widths(IFont.WidthsCount - 1)
      Call pdfCopyMem2(IFont.Widths, Font.Widths(0), IFont.WidthsCount * 4)
   Else
      Erase Font.Widths
   End If
   ' We don't copy the buffer here! Copy the buffer manually with pdfCopyMem() if you need it!
   ' However, if Font.Length1 == 0 and if Font.FontFile <> 0 then the variable contains the
   ' file path to the used font file. This is always a null-terminated Ansi string at
   ' this time. The string length can be determined with pdfStrLenA().
   Font.FontFile = IFont.FontFile
   Font.Length1 = IFont.Length1
   Font.Length2 = IFont.Length2
   Font.Length3 = IFont.Length3
   Font.FontFileType = IFont.FontFileType
End Function

Private Sub IPDFCallBack_EnumDocFonts(ByVal PDFFont As Long, ByVal FontType As TFontType, ByVal BaseFont As Long, ByVal FontName As Long, ByVal Embedded As Long, ByVal IsFormFont As Long, ByVal Flags As Long, DoBreak As Boolean)
   Dim bName As String
   Dim fName As String

   bName = ToString1(BaseFont, False)
   fName = ToString1(FontName, False)
   RaiseEvent EnumDocFont(PDFFont, FontType, bName, fName, Embedded, IsFormFont, Flags, DoBreak)
End Sub

Private Sub IPDFCallBack_EnumFonts(ByVal FamilyName As Long, ByVal PostScriptName As Long, ByVal Style As Long, DoBreak As Boolean)
   Dim famName  As String
   Dim postName As String

   famName = ToString1(FamilyName, True)
   postName = ToString1(PostScriptName, False)
   RaiseEvent EnumFont(famName, postName, Style, DoBreak)
End Sub

Private Sub IPDFCallBack_EnumFontsEx(ByVal FamilyName As Long, ByVal PostScriptName As Long, ByVal Style As Long, ByVal BaseType As TFontBaseType, ByVal Embeddable As Boolean, ByVal FilePath As Long, DoBreak As Boolean)
   Dim famName  As String
   Dim postName As String
   Dim Path     As String
   Dim BufSize  As Long

   famName = ToString1(FamilyName, True)
   postName = ToString1(PostScriptName, False)
   Path = ToString1(FilePath, False)
   RaiseEvent EnumFontEx(famName, postName, Style, BaseType, Embeddable, Path, DoBreak)
End Sub

Private Sub IPDFCallBack_ErrorProc(ByVal ErrCode As Long, ByVal ErrMessage As Long, ByVal ErrType As Long, DoBreak As Boolean)
   Dim s As String

   s = ToString1(ErrMessage, False)
   DoBreak = False
   RaiseEvent Error(s, ErrType, DoBreak)
End Sub

Private Sub IPDFCallBack_InitProgress(ByVal ProgType As Long, ByVal MaxCount As Long)
    RaiseEvent InitProgress(ProgType, MaxCount)
End Sub

Private Sub IPDFCallBack_OnPageBreakProc(ByVal LastPosX As Double, ByVal LastPosY As Double, ByVal PageBreak As Long, NewAlign As TNewAlign, DoBreak As Boolean)
    RaiseEvent PageBreak(LastPosX, LastPosY, PageBreak, NewAlign, DoBreak)
End Sub

Private Sub IPDFCallBack_Progress(ByVal ActivePage As Long, DoBreak As Boolean)
    RaiseEvent Progress(ActivePage, DoBreak)
End Sub

Private Function ToString1(ByVal APtr As Long, ByVal bIsUnicode As Boolean) As String
   Dim sLen As Long
   Dim retval As String
   If APtr = 0 Then Exit Function
   If bIsUnicode = True Then
      sLen = pdfStrLenW(APtr)
      retval = Space(sLen)
      pdfCopyMem3 APtr, StrPtr(retval), sLen * 2
   Else
      sLen = pdfStrLenA(APtr)
      retval = Space(sLen)
      pdfCopyMem APtr, retval, sLen
   End If
   ToString1 = retval
End Function

Private Function ToString2(ByVal APtr As Long, ByVal sLen As Long, ByVal bIsUnicode As Boolean) As String
   Dim retval As String
   If (APtr = 0) Or (sLen = 0) Then Exit Function
   If bIsUnicode = True Then
      retval = Space(sLen)
      pdfCopyMem3 APtr, StrPtr(retval), sLen * 2
   Else
      retval = Space(sLen)
      pdfCopyMem APtr, retval, sLen
   End If
   ToString2 = retval
End Function

' Special version for form fields
Private Function ToString3(ByVal APtr As Long, ByVal sLen As Long) As String
   Dim ansiLen As Long
   Dim retval As String
   If (APtr = 0) Or (sLen = 0) Then Exit Function
   ansiLen = pdfStrLenA(APtr)
   ' Check whether we have an Unicode string.
   If ansiLen <> sLen Then
      retval = Space(sLen)
      pdfCopyMem3 APtr, StrPtr(retval), sLen * 2
   Else
      retval = Space(sLen)
      pdfCopyMem APtr, retval, sLen
   End If
   ToString3 = retval
End Function

Private Function ToStringEx(ByVal PtrA As Long, ByVal PtrW As Long, Optional ByVal sLen = 0) As String
   Dim retval As String
   If PtrA <> 0 Then
      If sLen = 0 Then sLen = pdfStrLenA(PtrA)
      retval = Space(sLen)
      pdfCopyMem PtrA, retval, sLen
   ElseIf PtrW <> 0 Then
      If sLen = 0 Then
         sLen = pdfStrLenW(PtrW)
      End If
      retval = Space(sLen)
      pdfCopyMem3 PtrW, StrPtr(retval), sLen * 2
   End If
   ToStringEx = retval
End Function

Private Function UTF8ToString(ByVal Source As Long) As String
   Dim Length As Long, srcLen As Long
   Dim retval As String
   srcLen = pdfStrLenA(Source)
   Length = MultiByteToWideChar(65001, 0, Source, srcLen, 0, 0)
   retval = Space(Length)
   MultiByteToWideChar 65001, 0, Source, srcLen, StrPtr(retval), Length
   UTF8ToString = retval
End Function
